--图鉴
Lua_HeroAtlasPanel = class("Lua_HeroAtlasPanel", Lua_DisplayObject);
function Lua_HeroAtlasPanel:ctor(p)
    self:superCall("ctor", p);
end

function Lua_HeroAtlasPanel:buildShowItem()
    self:superCall("buildShowItem");
    self:addLuaEvent("UPDATE_STAR_ATLAS_INFO", self, self.showHeroAtlasInfo);
    self:addLuaEvent("SHOW_SELECT_HERO_WIND", self, self.showSelectHeroWind);
    self:addLuaEvent("UPDATE_CBCARDDETAIL_REWARD", self, self.onInitDragList); -- 卡牌奖励更新
    
    self.help_spr = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_button_016", 313, -302, 0, 0);
    self.help_spr:setAnchorMin(0.5, 1);
    self.help_spr:setAnchorMax(0.5, 1);
    self.help_spr:addClickFuntion(self, self.onHelpBtnClick);

    self.embattleIcon = UICreate.createUIAtlasImage(self.content, "hero_altas", "xui_hb_button_1_n", -280, -273, 0, 0);
    self.embattleIcon:setAnchorMin(0.5, 1);
    self.embattleIcon:setAnchorMax(0.5, 1);
    self.embattleIcon:addClickFuntion(self, self.onOpenLineupClick);
    self.embattleIcon.name = "embattleIcon";

    self.dragContainer = Lua_DragListContainer.new(self.content, 680, 796 + self.adaptHeight, Lua_AxisDefine.Vertical)
    self.dragContainer:setLocation(5, -27, 0)
    self.dragContainer.tweenId = 2028
    self.dragContainer.delayTween = true
    self.dragContainer:setCellSpacing(10, 6);

    self.campSiftPanel = Lua_CampSiftPanel.new(self.content);
    self.campSiftPanel:setRectAnchor(7);
    self.campSiftPanel:setLocation(-32, 252, 0);
    self.campSiftPanel:setArrayData(DataCenter.heroUtil.siftAllInfo);
    self.campSiftPanel:setCallBack(self, self.onCampSelected);

    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroAtlas();
end

function Lua_HeroAtlasPanel:dispose()
    if self.dragContainer ~= nil then
        self.dragContainer:dispose();
        self.dragContainer = nil;
    end
    if self.campSiftPanel ~= nil then
        self.campSiftPanel:dispose();
        self.campSiftPanel = nil;
    end
    self:superCall("dispose");
end

function Lua_HeroAtlasPanel:onScreenResize(adaptHeight)
    self.dragContainer:setContentRect(680, 796 + adaptHeight);
end

function Lua_HeroAtlasPanel:showSelectHeroWind(heroVo)
    DataCenter.heroAtlasData:onOpenAtlasWindow(heroVo.id, 1, true, self.selectType, true);
end

function Lua_HeroAtlasPanel:updateShow()
    self.selectType = nil;
    self.dragContainer.showTween = true;
    self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, true);
end

function Lua_HeroAtlasPanel:showHeroAtlasInfo()
    self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, true);
end

function Lua_HeroAtlasPanel:onCampSelected(selectType) -- 更新筛选状态
    if self.selectType == selectType then
        return;
    end
    self.selectType = selectType;

    self:onInitDragList();
end

function Lua_HeroAtlasPanel:onHelpBtnClick(go)
    local tipsData = {des = LanUtil.getValue(126058), posX = 164, posY = -442};
    Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_HeroAtlasPanel:onOpenLineupClick() -- 打开布阵
    local sceneId = DataCenter.heroLineupData:getLineUpSceneId(Lua_HeroUtil.LINEUP_MAIN_TYPE);
    DataCenter.preLoadData:preShowScene("Lua_HeroLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
end


function Lua_HeroAtlasPanel:onSceneShow(param)
    local arr = DataCenter.heroLineupUtil:getLineupTabArr()
    Lua_WindowUtil.openWin("Lua_HeroLineupWindow", Lua_WinParam.ACTION_OPEN, arr);
end

function Lua_HeroAtlasPanel:onInitDragList()
    self.dragContainer:clearList()
    local tagIndex = 0
    local moveToIndex = 1
    local bShowRedDot = false
    for i = 1, 6 do
        idx = 7 - i
        data = DataCenter.heroAtlasData:getHeroAtlasArr(idx, self.selectType)
        if data and data:getSize() > 0 then
            -- 标题
            self.dragContainer:addChildData(idx, Lua_HeroAtlasTitleItem, 680, 41, 1)
            -- 内容
            self.dragContainer:addChildData(data, Lua_HeroAtlasHeroItem, 160, 252, 4)

            tagIndex = tagIndex + 1
            if not bShowRedDot then
                for j = 1, data:getSize() do
                    tagIndex = tagIndex + 1
                    bShowRedDot = self:bShowRedDot(data[j])
                    if bShowRedDot then
                        moveToIndex = tagIndex
                        break
                    end
                end
            end
        end
    end
    self.dragContainer:updateChildPos()
    moveToIndex = moveToIndex < 5 and 1 or moveToIndex
    self.dragContainer:moveToIndex(moveToIndex, true)
end

--一行是否有红点；
function Lua_HeroAtlasPanel:bShowRedDot(id)
    local avo = DataCenter.heroAtlasData:getAtlasVoById(id)
    if avo.heroVo and avo.heroVo.bHeroCardRedDot then
        return true
    end
    return false
end




















Lua_HeroAtlasTitleItem = class("Lua_HeroAtlasTitleItem", Lua_DragContainerItem)
function Lua_HeroAtlasTitleItem:ctor(p)
    self:superCall("ctor", p)
end

function Lua_HeroAtlasTitleItem:buildShowItem()
    self:superCall("buildShowItem")
    self.titleBg = UICreate.createUIAtlasImage(self.content, "hero_develop_altas", "xui_hb_widget_6", 0, 0, 605, 41)

    self.titleName = UICreate.createLabel(self.content, nil, 0, 0, 100, 35, 26)
    self.titleName.fontName = Lua_MyUISettings.huakangFontName
    self.titleName.pivotValue = 4
    self.titleName.alignmentValue = 4
    self.titleName.horizontalOverflowValue = 1
    self.titleName.effectStyle = 2
    self.titleName.colorStr = Lua_ColorDefine.transColor("F1EEC9")
    self.titleName.effectColorStr = Lua_ColorDefine.transColor("282831")
end

function Lua_HeroAtlasTitleItem:dispose()
    self.titleBg = nil
    self.titleName = nil
    self:superCall("dispose")
end

function Lua_HeroAtlasTitleItem:setData(data)
    self.titleName:setLangValue(126003 + data)
end




















Lua_HeroAtlasHeroItem = class("Lua_HeroAtlasHeroItem", Lua_DragContainerItem)
function Lua_HeroAtlasHeroItem:ctor(p)
    self:superCall("ctor", p, "HeroAtlasCells_skin")
end

function Lua_HeroAtlasHeroItem:buildShowItem()
    self:superCall("buildShowItem")
end

function Lua_HeroAtlasHeroItem:dispose()
    if self.redPointIcon then
        self.redPointIcon:dispose()
        self.redPointIcon = nil
    end
    self.data = nil
    self:superCall("dispose")
end

function Lua_HeroAtlasHeroItem:setData(data)
    data = DataCenter.heroAtlasData:getAtlasVoById(data);
    self.data = data.heroVo;
    self.name.text = self.data.name;
    self.icon_img:setUrl(data.path);
    self.mask:setEnable(not (data.isActivate));
    self.camp_icon:setAltas("common_altas_2", "xui_common_attribute_"..16 + self.data.campType.."_n");
    self:showRedPoint(self.data.bHeroCardRedDot);
end

function Lua_HeroAtlasHeroItem:showRedPoint(bShow)
    if bShow then
        if self.redPointIcon == nil then
            self.redPointIcon = Lua_RedPointIcon.new(self.content)
            self.redPointIcon:setLocation(66, 91)
            self.redPointIcon:createRedPointEff()
        end
        self.redPointIcon:updateRedPointShow(true)
    else
        if self.redPointIcon then
            self.redPointIcon:updateRedPointShow(false)
        end
    end
end

function Lua_HeroAtlasHeroItem:onPressClick()
    if self.data == nil then
        return
    end
    Lua_MsgUtil.callFunc("SHOW_SELECT_HERO_WIND", self.data)
end