--英雄图鉴属性展示
checkRequire("Lua_HeroTabCell");
checkRequire("Lua_HeroShowBaseWindow");
Lua_HeroShowAtlasAttributeWindow = class("Lua_HeroShowAtlasAttributeWindow", Lua_HeroShowBaseWindow);
function Lua_HeroShowAtlasAttributeWindow:ctor()
    self:superCall("ctor");
    self.bHeroAtlas = true;
    self.windowName = "Lua_HeroShowAtlasAttributeWindow";
end

function Lua_HeroShowAtlasAttributeWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.skin_btn:setEnable(false);
    self.lock_btn:setEnable(false);
    self.rebuild_btn:setEnable(false);
    self.sub_btn:setEnable(false);
    self.add_btn:setEnable(false);
    self.share_btn:setEnable(false);
    
    self.profession:setLocation(250, 484);
    self.zhanli:setLocation(-68, 484);
    self.skin_btn:setLocation(295, 566);
    self.rebuild_btn:setLocation(-303, 502);

    self.sub_btn:addClickFuntion(self, self.onSubBtnClick);
    self.add_btn:addClickFuntion(self, self.onAddBtnClick);
    self.type_icon:addClickFuntion(self, self.onCompBtnClick);--阵容克制描述
    self.comment_btn:addClickFuntion(self, self.onCommentBtnClick);-- 评论
    self.quality_icon:addClickFuntion(self, self.onQualityBtnClick);--质量描述
    self.introduce_btn:addClickFuntion(self, self.onIntroduceBtnClick);-- 传记

    self:addLuaEvent("UPDATE_HERO_ATLAS_INFO", self, self.updateShowPropInfo);-- 属性更新
    self:addLuaEvent("UPDATA_TAG_BUTTON_ITEM", self, self.onTabBtnClick);-- 页签按钮
    self:addLuaEvent("UPDATE_CBCARDDETAIL_REWARD", self, self.updateShowHeroInfo); -- 卡牌奖励更新
    self.tabList = Lua_DragList.new(self.content, 590, 108, Lua_AxisDefine.Horizontal);
    self.tabList:setListCell(Lua_HeroTabCell, 118, 108, 1);
    self.tabList:setRectAnchor(7);
end

--英雄展示数据
function Lua_HeroShowAtlasAttributeWindow:showWin(param)
    self:superCall("showWin", param);
    if param == nil then
        self:hide();
        return;
    end

    self.selectTabId = nil;
    self.selectBtn = param.selectBtn;--页签按钮
    self.tagShowCardRedDot = param.tagShowCardRedDot;

    if param.shieldType == 1 then
        self.comment_btn:setEnable(false);
        self.introduce_btn:setLocation(303, -52, 0);
    end

    if param.isShowTab == true then--仅展示当前英雄，可以左右切换展示别的英雄
        self.showArr = param.arr; --图鉴列表数据
        self.showIdx = param.createIdx;
    end

    local hvo = DataCenter.heroAtlasData:getAtlasVoById(param.aid).heroVo;
    self:updateShowHeroInfo(param.aid);
    self:updateShowTabBtnState(hvo);
    self:sendHeroAtlas(param.aid);
end

function Lua_HeroShowAtlasAttributeWindow:updateShowHeroInfo(aid)
    if aid == nil then
        aid = self.aid;
    else
        self.aid = aid;
    end
    
    self.hvo = DataCenter.heroAtlasData:getAtlasVoById(aid).heroVo;
    local len = 1;--默认1
    if self.showArr ~= nil then
        len = self.showArr:getSize();
    end
    if len == 1 then
        self.sub_btn:setEnable(false);
        self.add_btn:setEnable(false);
    else
        if self.showIdx == 1 then
            self.sub_btn:setEnable(false);
            self.add_btn:setEnable(true);
        elseif self.showIdx == len then
            self.sub_btn:setEnable(true);
            self.add_btn:setEnable(false);
        else
            self.sub_btn:setEnable(true);
            self.add_btn:setEnable(true);
        end
    end
    self.name.text = self.hvo.name;
    self.title.text = self.hvo.title;
    self.profession.text = self.hvo.career_des;
    self.quality_icon:setAltas("common_altas_4", "xui_common_attribute_"..35+self.hvo.quality);
    self.type_icon:setAltas("common_altas_3", tostring(self.hvo.campSprite));
    self:updateShowTabBtnState(self.hvo);
    self:showStarsItem(self.hvo); -- 显示星级

    DataCenter.audioManager:play(self.hvo.lineSound);
    self:setLineStartTime(self.hvo.lineSound);
    self:showRedPoint(self.hvo.bHeroCardRedDot and self.tagShowCardRedDot);
end

function Lua_HeroShowAtlasAttributeWindow:updateShowPropInfo(aid)
    self.heroVo = DataCenter.heroAtlasData:getAtlasVoById(aid).heroVo;
    self.forceNum.num = self.heroVo.heroForce;
    
    local width = self.forceNum:getWidth(1, 1, 20);
    self.zhanli:setLocation(-12 - (self.forceNum.totalWidth - width)/2, 484);
    self.forceNum:setLocation(12 - (self.forceNum.totalWidth - width)/2, 484);
    -- 切换页签更新数据
    if self.curPanel ~= nil then
        self.curPanel:updateHeroPanelInfo(self.heroVo, true, self.showData);
    end
    self:updateUIEnable();
end

-- 页签显示状态
function Lua_HeroShowAtlasAttributeWindow:updateShowTabBtnState(data)
    local selectTabId = self.selectBtn;
    if self.selectTabId ~= nil then
        selectTabId = self.selectTabId;
    end
    local arr,curSelectIdx = DataCenter.heroUtil:updateTabInfo(data, selectTabId, true);
    local len = arr:getSize();
    self.tabList.canDrag = len >5;
    local posX = 655-len*118;
    if posX < 64 then
        posX = 64;
    end
    self.tabList:setLocation(posX, 54);
    self.tabList:setArrayData(arr);
    self.tabList:setSelected(curSelectIdx);
    self.tabList.canDrag = not self.tabList.isTheEnd
    self:onTabBtnClick(arr[curSelectIdx]);
end

-- 页签处理
function Lua_HeroShowAtlasAttributeWindow:onTabBtnClick(tabVo)
    if tabVo.is_show_gray == true then
        OperateAlert.show(tabVo.show_tips);
        return;
    end
    if self.selectTabId == tabVo.id then
        return;
    end
    self.selectTabId = tabVo.id;
    self:updateModel();
    
    local panelName = tabVo.panel;
    if self.panelName ~= panelName then
        if self.curPanel ~= nil then
            self.curPanel:dispose();
            self.curPanel = nil;
        end
        self.panelName = panelName;
        local showPanel = checkRequire(self.panelName);
        self.curPanel = showPanel.new(self.content);
    end
    self.curPanel:setRectAnchor(9);
    if self.heroVo ~= nil then
        self.curPanel:updateHeroPanelInfo(self.heroVo, true, self.showData);
    end

    self:updateUIEnable();
end

function Lua_HeroShowAtlasAttributeWindow:updateUIEnable()
    local bUpObj;--上吸附UI
    local bDownObj;--下吸附UI
    if self.selectTabId == 4 then
        bUpObj = true;
        bDownObj = false; 
    elseif self.selectTabId == 6 then--神兵
        bUpObj = false;
        bDownObj = false;
    else
        bUpObj = true;
        bDownObj = true;
    end

    self.up_obj:SetActive(bUpObj);
    self.down_obj:SetActive(bDownObj);
end

function Lua_HeroShowAtlasAttributeWindow:onSubBtnClick()
    if self.modelScenePanel == nil or self.modelScenePanel:checkShowComplete() ~= true then 
        return;
    end

    if self.showArr == nil then
        return;
    end

    if self.showIdx <= 1 then
        return;
    end
    self.showIdx = self.showIdx - 1;
    local aid = self.showArr[self.showIdx];
    self:updateShowHeroInfo(aid);
    self:updateModel();
    self:sendHeroAtlas(aid);
end

function Lua_HeroShowAtlasAttributeWindow:onAddBtnClick()
    if self.modelScenePanel == nil or self.modelScenePanel:checkShowComplete() ~= true then 
        return;
    end

    if self.showArr == nil then
        return;
    end

    local len = self.showArr:getSize();
    if self.showIdx >= len then
        return;
    end

    self.showIdx = self.showIdx + 1;
    local aid = self.showArr[self.showIdx];
    self:updateShowHeroInfo(aid);
    self:updateModel();
    self:sendHeroAtlas(aid);
end

function Lua_HeroShowAtlasAttributeWindow:updateModel()
    if self.selectTabId == 6 then
        local weaponId = self.hvo.weaponId;
        if self.hvo.weapon_id > 0 then
            weaponId = self.hvo.weapon_id;
        end
        local vo = DataCenter.heroUtil:getHeroWeaponVo(weaponId)
        self:showHeroMondel(vo);
    else
        self:showHeroMondel(self.hvo);-- 模型展示
    end
end

-- 克制描述
function Lua_HeroShowAtlasAttributeWindow:onCompBtnClick()
    Lua_WindowUtil.openWin("Lua_HeroCampDesTipsWindow", Lua_WinParam.ACTION_OPEN, {des = DataCenter.heroUtil:getCampDic(self.hvo.campType), pos = {0, 520 + self.adaptHeight/2}});
end

function Lua_HeroShowAtlasAttributeWindow:onQualityBtnClick()
    Lua_WindowUtil.openWin("Lua_HeroCampDesTipsWindow", Lua_WinParam.ACTION_OPEN, {des = LanUtil.getValue(126068 + self.hvo.quality), pos = {0, 520 + self.adaptHeight/2}});
end

--请求数据
function Lua_HeroShowAtlasAttributeWindow:sendHeroAtlas(aid)
    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroAtlasAttr(aid);
end

--评论
function Lua_HeroShowAtlasAttributeWindow:onCommentBtnClick()
    Lua_WindowUtil.openWin("Lua_HeroCommentWindow", Lua_WinParam.ACTION_OPEN, self.heroVo);
end

function Lua_HeroShowAtlasAttributeWindow:onIntroduceBtnClick()
    if not DataCenter.collectionBookUtil:checkCompletedCardByHeroId(self.heroVo.id) then
        OperateAlert.showLangValue(126063);
        return
    end
    Lua_WindowUtil.openWin("Lua_CollectionBookShowHeroChannelWindow", Lua_WinParam.ACTION_OPEN, {cardlist = self.heroVo.cardList, tagShowCardRedDot = self.tagShowCardRedDot});
end

-- function Lua_HeroShowAtlasAttributeWindow:onBackBtnClick(go)
--     self:hide();
--     DataCenter.funcPathUtil:gotoFunction(1098, false);
-- end

function Lua_HeroShowAtlasAttributeWindow:dispose()
    if self.tabInfo ~= nil then
        self.tabInfo:dispose();
        self.tabInfo:clear();
        self.tabInfo = nil;
    end

    if self.curPanel ~= nil then
        self.curPanel:dispose();
        self.curPanel = nil;
    end
    
    self.heroVo = nil;
    self.showArr = nil;
    self.panelName = nil;
    DataCenter.heroAtlasData:removeShowModel();
    self:superCall("dispose");
end