-- 所有属性展示
Lua_HeroAllAttributeWindow = class("Lua_HeroAllAttributeWindow", Lua_Window);
function Lua_HeroAllAttributeWindow:ctor()
	self:superCall("ctor");

	self.isClickClose = true;
	self.showBlackMask = true;
	self.windowName = "Lua_HeroAllAttributeWindow";
	self.skinName = "HeroAllAttributeWindow_skin";
end

function Lua_HeroAllAttributeWindow:buildShowItem()
	self:superCall("buildShowItem");

	local list = DataCenter.heroUtil.hero_base_attr;
	local posX;
	local line;
	local item;
	self.space = 50;
	self.baseAttributeArr = Array();
	for i = 1, #list do
		posX = i % 2 == 0 and 164 or -164;
		line = Mathf.Ceil(i / 2);

		item = Lua_HeroAllAttributeItem.new(self.showObj);
		item:setLocation(posX, 386 - (line - 1) * self.space, 0);
		self.baseAttributeArr:add(item);
	end

	local list1 = DataCenter.heroUtil.hero_special_attr;
	self.specialAttributeArr = Array();
	for i = 1, #list1 do
		posX = i % 2 == 0 and 164 or -164;
		line = Mathf.Ceil(i / 2);

		item = Lua_HeroAllAttributeItem.new(self.showObj);
		item:setLocation(posX, 210 - (line - 1) * self.space, 0);
		self.specialAttributeArr:add(item);
	end

	self:addLuaEvent("HERO_ADD_OPTION_INFO", self, self.showAddAttrInfo)
end

function Lua_HeroAllAttributeWindow:showWin(param)
	self:superCall("showWin", param);

	self:showBsaeAttrInfo(param.data);
	self:showSpecialAttrInfo(param.data);

	local len = self.baseAttributeArr:getSize();
	local maxPosY = len > 0 and self.baseAttributeArr[len].posY or 0;
	local distance = maxPosY - self.specialDes.posY;

	len = self.specialAttributeArr:getSize();
	maxPosY = len > 0 and self.specialAttributeArr[len].posY or 0;
	LuaUtil.setObjPos(self.addObj, 0, maxPosY - distance, 0);
	self.addObj:SetActive(not param.isSHowAtlas);

	-- 文字用文本大小 / 2
	local width = self.baseDes.posY - maxPosY + self.baseDes.fontSize / 2 + 24 * 2;
	if param.isSHowAtlas == true then -- 图鉴
		showWidth = width + self.space / 2;
		self.winBg:SetDimensions(697, showWidth);
		LuaUtil.setObjPos(self.showObj, 0, -(864 - showWidth) / 2, 0);
	else
		local dragListHeight = 204;
		local posY = -150;
		showWidth = width - (-distance + posY - dragListHeight / 2);
		self.winBg:SetDimensions(697, showWidth);
		LuaUtil.setObjPos(self.showObj, 0, -(864 - showWidth) / 2, 0);

		self.dragList = Lua_DragList.new(self.addObj, 632, dragListHeight, Lua_AxisDefine.Vertical);
		self.dragList:setListCell(Lua_HeroAllAttributeCell, 632, 44, 1);
		self.dragList:setCellSpacing(0, 4);
		self.dragList:setLocation(0, posY);
		self.dragList.customParam = param.data.career;

		-- print("showWin", DataCenter.heroData.otherRoleId)
		if DataCenter.heroData.otherRoleId ~= nil then
			Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroAddOption(DataCenter.heroData.otherRoleId, 0);
		else
			Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroAddOption(DataCenter.roleData.roleId, 0);
		end
	end
end

-- 展示加成项
function Lua_HeroAllAttributeWindow:showAddAttrInfo()
	local congfig = getConfig("hero_add");
	self.dragList.canDrag = #congfig > 4;
	self.dragList:setArrayData(congfig);
end

-- 基础属性
function Lua_HeroAllAttributeWindow:showBsaeAttrInfo(data)
	local attrInfo = data.heroPropVo.heroPropInfo;
	local len = attrInfo:getSize();
	for i = 1,len do
		if i < 5 then
			self.baseAttributeArr[i]:setData(attrInfo[i]);
		end
	end
end

-- 特殊属性
function Lua_HeroAllAttributeWindow:showSpecialAttrInfo(data)
	local attrInfo = data.heroPropVo.heroDetailPropInfo;
	local len = attrInfo:getSize();
	for i = 1, len do
		self.specialAttributeArr[i]:setData(attrInfo[i]);
	end
end

function Lua_HeroAllAttributeWindow:dispose()
	if self.baseAttributeArr ~= nil then
		self.baseAttributeArr:dispose();
		self.baseAttributeArr:clear();
		self.baseAttributeArr = nil;
	end
	if self.specialAttributeArr ~= nil then
		self.specialAttributeArr:dispose();
		self.specialAttributeArr:clear();
		self.specialAttributeArr = nil;
	end
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end

	self:superCall("dispose");
end










Lua_HeroAllAttributeItem = class("Lua_HeroAllAttributeItem", Lua_DisplayObject);
function Lua_HeroAllAttributeItem:ctor(p)
	self:superCall("ctor", p, "HeroAllAttributeItem_skin");
end

function Lua_HeroAllAttributeItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_HeroAllAttributeItem:setData(data)
	self.attr_value.text = data.showValue;
	self.attr_name.text = data.show_name;
	self.attr_icon:setAltas("common_altas_2", data.attr_icon_1);
end

function Lua_HeroAllAttributeItem:dispose()
	self:superCall("dispose");
end










Lua_HeroAllAttributeCell = class("Lua_HeroAllAttributeCell", Lua_ListCell);
function Lua_HeroAllAttributeCell:ctor(p)
	self:superCall("ctor", p,"HeroAllAttributeCell_skin");
end

function Lua_HeroAllAttributeCell:buildShowItem()
	self:superCall("buildShowItem");

	self.goBtn:addClickFuntion(self, self.onGoBtnClick);
end

function Lua_HeroAllAttributeCell:setCustomParam(param)
	self.career = param;
end

function Lua_HeroAllAttributeCell:setData(data)
	if data == nil then
		return;
	end
	self.data = data;
	self.goto_id = data.goto_id;
	self.attr_name.text = data.name;

	local des;
	local lvl;
	if data.id == 1 then -- 社区属性加成
		lvl = DataCenter.heroData.league_level;
		if lvl == nil then
			lvl = 0;
		end
		des = "Lv."..lvl;
	elseif data.id == 2 then -- 社区技巧加成
		local list = DataCenter.heroData.leagueScienceDic;
		lvl = 0;
		if list ~= nil and list[self.career] ~= nil then
			lvl = list[self.career];
		end
		des = "Lv."..lvl;
	elseif data.id == 3 then -- 潜能加成
		des = LanUtil.getValue(126057);
		local info = DataCenter.heroData.potential_info;
		if info ~= nil then
			if info.key > 0 then
				local cfg = getConfig("destiny", info.key);
				des = LanUtil.formateStr(350004, cfg.name, convert_arab_to_chinese(info.value));
			end
		end
	elseif data.id == 4 then -- 英雄之力加成
		lvl = DataCenter.heroData.hero_power_level;
		if lvl == nil then
			lvl = 0;
		end
		des = "Lv."..lvl;
	end
	self.attr_value.text = des;

	self.goBtn:setEnable(DataCenter.heroData.curRoleId == nil or DataCenter.heroData.curRoleId == DataCenter.roleData.roleId);
end

function Lua_HeroAllAttributeCell:onGoBtnClick()
	if self.data == nil then
		return;
	end
	if self.data.id == 1 or self.data.id == 2 then
		if DataCenter.roleData.league_id == 0 then
			OperateAlert.showLangValue(126060);
			return
		end
	end
	if DataCenter.funcPathUtil:gotoFunction(self.data.goto_id) then
		Lua_WindowUtil.openWin("Lua_HeroAllAttributeWindow", Lua_WinParam.ACTION_CLOSE);
		Lua_WindowUtil.openWin("Lua_HeroShowAttributeWindow", Lua_WinParam.ACTION_CLOSE);
	end
end

function Lua_HeroAllAttributeCell:dispose()
	self:superCall("dispose");
end