-- 属性动画显示
checkRequire("Lua_HeroAttrAnimationPanel")
Lua_HeroAttrAnimationWindow = class("Lua_HeroAttrAnimationWindow", Lua_Window);
function Lua_HeroAttrAnimationWindow:ctor()
    self:superCall("ctor");
    self.showClose = false;
    self.showWinBg = false;
    self.showBlackMask = false;
    self.windowName = "Lua_HeroAttrAnimationWindow";
end

function Lua_HeroAttrAnimationWindow:buildShowItem()
    self:superCall("buildShowItem");

    -- self.depthTxt = UICreate.createLabel(self.content, ".", 0, 0, 20, 20, 20);
    -- -- self.depthTxt:setDepth(1);
    -- self.depthTxt.alpha = 0.01;
end

function Lua_HeroAttrAnimationWindow:showWin(param)
    if self.animationPanel == nil then
        self.animationPanel = Lua_HeroAttrAnimationPanel.new(self.content);
    end
    self.animationPanel:setLocation(-80, -10, 0);
    self.animationPanel:setData(param);
    self.animationPanel:setEnable(true);
    --self:createLevelEffect();

    self.moveTime1 = nil;
    self.moveTime = getTime();
    if self.bRegisterTime ~= true then
        self.bRegisterTime = true;
        Lua_CommonUtil.addTimer( "updataItemLocation", 0.01, self, self.updataItemLocation);
    end
end

function Lua_HeroAttrAnimationWindow:updataItemLocation()
    local endPox;
    local endPoy;
    local speed1 = 450;
    local speed2 = 25;
    local endTime = getTime();
    local moveDistance1 = (endTime - self.moveTime) * speed1;
    local movePox = -80 + moveDistance1;
    if movePox <= 0 then
        endPox = movePox;
        endPoy = -10;
    else
        if self.moveTime1 == nil then
            self.moveTime1 = endTime;
        end

        endPox = 0;
        local moveDistance2 = (endTime - self.moveTime1) * speed2;
        local movePoY = -10 + moveDistance2;
        if movePoY <= 0 then
            endPoy = movePoY;
        else
            endPoy = 0;
        end
    end

    if endPoy == 0 then
        self:removeControlTime()
        self.animationPanel:setEnable(false);
    else
        self.animationPanel:setLocation(endPox, endPoy, 0);
    end
end

function Lua_HeroAttrAnimationWindow:removeControlTime()
    if self.bRegisterTime == true then
        self.bRegisterTime = false;
        Lua_CommonUtil.removeTimer(self, self.updataItemLocation);
    end
end

function Lua_HeroAttrAnimationWindow:createLevelEffect()
    if self.uiEffect == nil then
       self.uiEffect = UICreate.createUIEffect(self.content, "/effects/uiEffects/levelup", "levelup", 0, 85);
       self.uiEffect:SetRenderQueue(self.depthTxt, -1, UIEffect.NormalSort);
       self.uiEffect:setAction(1);
       self.uiEffect:setScale(150,150,150);
    else
        self.uiEffect:setEnable(false);
        self.uiEffect:setEnable(true);
    end
end

function Lua_HeroAttrAnimationWindow:dispose()
    if self.uiEffect ~= nil then
        self.uiEffect:dispose();
        self.uiEffect = nil;
    end
    if self.depthTxt~= nil then
        self.depthTxt = nil;
    end
    if self.animationPanel ~= nil then
        self.animationPanel:dispose();
        self.animationPanel = nil;
    end
    
    self:removeControlTime();
    self:superCall("dispose");
end