-- 英雄属性
checkRequire("Lua_HeroCostItem");--英雄升级消耗 Item
checkRequire("Lua_HeroSkillItem"); --英雄技能 Item
checkRequire("Lua_HeroAttributeItem");--英雄属性 
checkRequire("Lua_HeroTrialTipItem");--英雄试用 Item
checkRequire("Lua_HeroRunesItem");
checkRequire("Lua_HeroEquipItem");
Lua_HeroAttributePanel = class("Lua_HeroAttributePanel", Lua_DisplayObject);
function Lua_HeroAttributePanel:ctor(p)
    self:superCall("ctor", p, "HeroAttributePanel_skin");
    self.isMouseDown = false;
    self.isShowMaxBtn = false;
    self.isFirstPress = 0;
end

function Lua_HeroAttributePanel:buildShowItem()
    self:superCall("buildShowItem");

    self.max_btn:setEnable(false);
    self.goto_btn:setEnable(false);
    self.mask_btn:setEnable(false);
    self.fengxian:setEnable(false);
    self.upgrade_btn:setEnable(false);

    self.upMaxLevel = 0;--最大直升等级上限

    self.max_btn:addClickFuntion(self, self.onMaxBtnClick);
    self.mask_btn:addClickFuntion(self, self.onMaskBtnClick);
    self.goto_btn:addClickFuntion(self, self.onGoToResonanceBtnClick);

    self.upgrade_btn:setClickSound("");
    self.upgrade_btn:addMousDownFuntion(self, self.onMouseDownHandle);
    self.upgrade_btn:addMouseUpFuntion(self, self.onMouseUpHandle);
    self.help_spr:addClickFuntion(self, self.onHelpBtnClick);

    -- 装备符石处理
    self.worn_btn:addClickFuntion(self, self.onWornBtnClick);
    self.master_btn:addClickFuntion(self, self.onMasterBtnClick);
    self.demount_btn:addClickFuntion(self, self.onDemountBtnClick);

    self.checkGenius:addClickFuntion(self, self.onCheckGenius);

    self:addLuaEvent("UPDATE_HERO_TAB_REDDOT", self, self.updateCostOrRed);--更新升级红点
    self:addLuaEvent("Guide_UpHeroGrade_Panel", self, self.guideUpHeroGradeLevel);--引导英雄升级
end


function Lua_HeroAttributePanel:dispose()
    if self.costInfo ~= nil then
        self.costInfo:dispose();
        self.costInfo:clear();
        self.costInfo = nil;
    end
    if self.skillInfo ~= nil then
        self.skillInfo:dispose();
        self.skillInfo:clear();
        self.skillInfo = nil;
    end
    if self.attributeArr ~= nil then
        self.attributeArr:dispose();
        self.attributeArr:clear();
        self.attributeArr = nil;
    end
    if self.redDotIcon ~= nil then
        self.redDotIcon:dispose();
        self.redDotIcon = nil;
    end
    if self.planSkillItem ~= nil then
        self.planSkillItem:dispose();
        self.planSkillItem = nil;
    end
    if self.showEquipArr ~= nil then
        self.showEquipArr:dispose();
        self.showEquipArr:clear();
        self.showEquipArr = nil;
    end
    if self.showSunesArr ~= nil then
        self.showSunesArr:dispose();
        self.showSunesArr:clear();
        self.showSunesArr = nil;
    end
    if self.equipRedDot ~= nil then
        self.equipRedDot:dispose();
        self.equipRedDot = nil;
    end
    if self.geniusRed then
        self.geniusRed:dispose();
        self.geniusRed = nil;
    end
    self:removeControlTime();
    DataCenter.winTweenManager:removeWinTween(self.tweenName);
    self:superCall("dispose");
end

function Lua_HeroAttributePanel:guideUpHeroGradeLevel(heroLevel)
    self.guideHeroLevel = heroLevel;
    self.upgrade_btn:setEnable(true);
    self.upgrade_btn.label = LanUtil.formateStr(126101,tostring(heroLevel));
    -- print("引导等级   ",heroLevel);
end

function Lua_HeroAttributePanel:updateCostOrRed()
    self:showRedDot();
    self:updateshowUpgradeCost();
end

function Lua_HeroAttributePanel:resetInfo()
    self.isShowMaxBtn = false;
    self.isFirstPress = 0;
end

function Lua_HeroAttributePanel:updateHeroPanelInfo(data, isSHowAtlas)
    self.data = data;
    self.isSHowAtlas = isSHowAtlas;
    if self.isSHowAtlas == true then--展示图鉴
        self:showAtlasAttr(data);
        return
    end
    if self.tag_uid ~= data.unique_id then
        self.tag_uid = data.unique_id;
        self.max_btn:setEnable(false);
        self:resetInfo();

        if self.tweenName ~= nil then
            DataCenter.winTweenManager:removeWinTween(self.tweenName);
        end
        self.tweenName = DataCenter.winTweenManager:createWinTween(self.content.name, self.content.transform);
    end

    self.fengxian:setEnable(true);
    self.showTips:setEnable(false);
    self:showResonanceTips(false);
    self:showTrialTipItem(false);
    --守护状态
    if self.data.is_resonance then
        self:showResonanceTips(true);
        self.goto_btn:setEnable(true);
        self.upgrade_btn:setEnable(false);
        self.show_level.text = Lua_ColorDefine.getColorStr("4DDEF3",self.data.level);
        self:showUpgradeCost(nil);
    elseif self.data.trial_state then
        --试用状态
        self.goto_btn:setEnable(false);
        self.upgrade_btn:setEnable(false);
        self:showTrialTipItem(true);
        self:showUpgradeCost(nil);
        self.show_level.text = Lua_ColorDefine.getColorStr("EAE4D8",self.data.level);
    else
        --已满级
        if self.data.heroUpgradeVo.isMaxLevel == true then--达到当前等级上限
            if self.data.level == self.data.max_lvl_limit then --最大等级的等级上限(250级)
                self.goto_btn:setEnable(true);
                self.upgrade_btn:setEnable(false);
                self:showUpgradeCost(nil);
            else
                self.goto_btn:setEnable(false);
                self.upgrade_btn:setEnable(true);
                if self.data.heroUpgradeVo.isBreak then
                    self.upgrade_btn:setLangValue(126109);
                else
                    self.upgrade_btn:setLangValue(126108);
                end
                self:showUpgradeCost(self.data);
            end
        else
            local str;
            if self.data.heroUpgradeVo.isBreak then
                str = LanUtil.getValue(126109);
            else
                local min_lvl = self.data.heroUpgradeVo.upgradelimit;
                if min_lvl == 0 or min_lvl == 1 then
                    str = LanUtil.getValue(126108);
                else
                    str = LanUtil.formateStr(126101,tostring(min_lvl));
                end
            end

            self.upgrade_btn.label = str;
            self:showUpgradeCost(self.data);-- 动态显示材料消耗
            self.goto_btn:setEnable(false);
            self.upgrade_btn:setEnable(true);
        end
        if not self.data.heroUpgradeVo.bResonanceLevel and self.data.level < self.data.max_lvl_limit  then
            self.showTips:setEnable(true);
            self.showTips.text = LanUtil.formateStr(126062,self.data.heroUpgradeVo.levelCostConfig.resonance);
        end
        self.show_level.text = Lua_ColorDefine.getColorStr("EAE4D8",self.data.level);
    end

    if self.upMaxLevel > 0 and self.upMaxLevel - self.data.level < DataCenter.heroUtil.show_button_lvl_limit  then
        self:onMaskBtnClick();
    end

    self:updateAttrInfo(self.data);-- 动态显示属性
    self:showFightSkill(self.data); -- 动态显示战斗技能
    self:showRedDot(); -- 升级红点
    self:updateEquipInfo(self.data);
    self:updateGenius();
end

function Lua_HeroAttributePanel:showAtlasAttr(data)
    self.fengxian:setEnable(false);
    self.upgrade_btn:setEnable(false);
    LuaUtil.setObjPos(self.content, 0, -60, 0);
    self:updateAttrInfo(data);-- 动态显示属性
    self:showFightSkill(data); -- 动态显示战斗技能
    self.show_level.text = data.level;
end

-- 更新属性
function Lua_HeroAttributePanel:updateAttrInfo(data)
    if data ~= nil then
        local info = data.heroPropVo.heroPropInfo;
        if self.attributeArr == nil then
            self.attributeArr = Array();
        end
        local len = self.attributeArr:getSize();
        for i = 1, len do
            self.attributeArr[i]:setEnable(false);
        end
        for i = 1, info:getSize() do
            local item = nil;
            if self.attributeArr[i] ~= nil then
                item = self.attributeArr[i];
            else
                item = Lua_HeroAttributeItem.new(self.content);
                item:setRectAnchor(7);
                self.attributeArr:add(item);
            end
            item:setData(info[i]);
            item:setLocation(-180+(i-1)*125, 480, 0);
            item:setEnable(true);
        end
    else
        if self.attributeArr ~= nil then
            local len = self.attributeArr:getSize();
            for i = 1, len do
                self.attributeArr[i]:setEnable(false);
            end
        end
    end
end

function Lua_HeroAttributePanel:updateshowUpgradeCost()
    if self.data.level == self.data.max_lvl_limit or self.data.is_resonance or self.data.trial_state then
        self:showUpgradeCost(nil);
    else
        self:showUpgradeCost(self.data);
    end
end

-- 动态显示升级消耗
function Lua_HeroAttributePanel:showUpgradeCost(data)
    if data ~= nil then
        local info = data.heroUpgradeVo.upgradeCostInfo;
        if self.costInfo == nil then
            self.costInfo = Array();
        end
        local item;
        local w = 0;--总宽
        local x = 0;--x坐标
        local itemW = 0;--item宽
        local len = self.costInfo:getSize();
        for i = 1, len do
            self.costInfo[i]:setEnable(false);
        end
        local length = info:getSize()
        for i = 1, length do
            local item = nil;
            if self.costInfo[i] ~= nil then
                item = self.costInfo[i];
            else
                item = Lua_HeroCostItem.new(self.showCost);
                self.costInfo:add(item);
            end
            item:setEnable(true);
            item:setData(info[i]);

            local space = i == length and 0 or 40;--间距
            x = x + itemW;
            itemW = item.itemW+space;
            w = itemW + w;

            item:setLocation(x, 261, 0);
        end
        LuaUtil.setObjPos(self.showCost, -w/2, 0, 0);
    else
        if self.costInfo ~= nil then
            local len = self.costInfo:getSize();
            for i = 1, len do
                self.costInfo[i]:setEnable(false);
            end
        end
    end
end

-- 动态显示战斗技能
function Lua_HeroAttributePanel:showFightSkill(data)
    local info = data.heroSkillInfo;
    local bConnect = data.connectId > 0;
    if info ~= nil then
        if self.skillInfo == nil then
            self.skillInfo = Array();
        end
        local len = self.skillInfo:getSize();
        for i = 1, len do
            self.skillInfo[i]:setEnable(false);
        end
        local skilWidth = bConnect and 130 or 170;
        local offectX = bConnect and 73 or 0;
        for i=1,#info do
            local item = nil;
            if self.skillInfo[i] ~= nil then
                item = self.skillInfo[i];
            else
                item = Lua_HeroSkillItem.new(self.content);
                item:setRectAnchor(7);
                self.skillInfo:add(item);
            end
            item:setData(info[i]);
            local x = -1 * skilWidth * #info / 2 + skilWidth * (i-1) + skilWidth / 2;
            item:setLocation(x-offectX,385, 0);
            item:setEnable(true);
        end
    else
        if self.skillInfo ~= nil then
            local len = self.skillInfo:getSize();
            for i = 1, len do
                self.skillInfo[i]:setEnable(false);
            end
        end
    end

    if bConnect then
        if self.planSkillItem == nil then
            self.planSkillItem = Lua_HeroSkillItem.new(self.content);--连携技能
            self.planSkillItem:setRectAnchor(7);
            self.planSkillItem:setLocation(272,385,0);
        end
        self.planSkillItem:setEnable(true);
        self.planSkillItem:setConnectData(data);
    else
        if self.planSkillItem ~= nil then
            self.planSkillItem:setEnable(false);
        end
    end
    self.fengxian1:setEnable(bConnect);
end


--显示试用英雄提示Item
function Lua_HeroAttributePanel:showTrialTipItem(val)
    if val then 
        if self.trialTipItem == nil then
            self.trialTipItem = Lua_HeroTrialTipItem.new(self.content, 1);
            self.trialTipItem:setRectAnchor(7);
            self.trialTipItem:setLocation(0, 223, 0);
        end
        self.trialTipItem:setData(self.data);
        self.trialTipItem:setEnable(true);
    else
        if self.trialTipItem ~= nil then
            self.trialTipItem:setData(nil);
            self.trialTipItem:setEnable(false);
        end
    end
end

--遮罩
function Lua_HeroAttributePanel:onMaskBtnClick(go)
    self:resetInfo();
    self.max_btn:setEnable(false);
    self.mask_btn:setEnable(false);
end

function Lua_HeroAttributePanel:onHelpBtnClick(go)
    Lua_WindowUtil.openWin("Lua_HeroAllAttributeWindow", Lua_WinParam.ACTION_OPEN,{data = self.data, isSHowAtlas = self.isSHowAtlas});
end

--升到最大级别
function Lua_HeroAttributePanel:onMaxBtnClick()
    Lua_WindowUtil.openWin("Lua_HeroUpgradeCostWindow", Lua_WinParam.ACTION_OPEN, {data = self.data, isBreak = false, isUpMaxlvl = true});
end

function Lua_HeroAttributePanel:onMouseDownHandle()
    self:onPress(true);
end

function Lua_HeroAttributePanel:onMouseUpHandle()
    self:onPress(false);
end

function Lua_HeroAttributePanel:onPress(state)
    if self.data == nil then
        return
    end
    if self.data.is_resonance == true then
        if state == false then
            if DataCenter.heroUtil:getHeroLevelCostConfig(self.data.ago_level).is_break then
                OperateAlert.showLangValue(126932);
            else
                OperateAlert.showLangValue(126920);
            end
        end
        return
    end

    if not self.data.heroUpgradeVo.bResonanceLevel and self.data.level < self.data.max_lvl_limit then--同调器等级不满足
        if state then
            self:showGotoResonanceTips();
        end
        return
    end
    
    if self.data.heroUpgradeVo.isMaxLevel == true then--达到当前星级的等级上限
        if state == false then
            if self.data.level == self.data.max_lvl_limit == true then --最大等级的等级上限
                self:onGoToResonanceBtnClick();
            else
                if state == false then
                    self:showUpStarTips();
                end
            end
        end
        return
    end
    local heroUpgradeVo = self.data.heroUpgradeVo;
    --展示提升最高等级按钮
    if heroUpgradeVo.isBreak == false and self.isFirstPress <= 1 then --第一次按压才进入判断一次 按压弹起进两次
        if self.isShowMaxBtn == false then
            self.upMaxLevel = heroUpgradeVo.upMaxLevel;
            if self.upMaxLevel > 0 then
                self.max_btn:setEnable(true);
                self.max_btn.label = LanUtil.formateStr(126113, tostring(self.upMaxLevel));
                self.mask_btn:setEnable(true);
                self.isShowMaxBtn = true;
            end
        end
        self.isFirstPress = self.isFirstPress + 1;
        if self.isShowMaxBtn == true then
            return;
        end
    end

    if state == true then
        self.startClickTime = getTime(); -- 记录开始点击时间
        --可以突破 就打开升级消耗界面
        if heroUpgradeVo.isBreak then
            self.isFirstPress = 0;
            Lua_WindowUtil.openWin("Lua_HeroUpgradeCostWindow", Lua_WinParam.ACTION_OPEN, {data = self.data, isBreak = true});
            self:removeControlTime();
            return;
        end
        if self.isMouseDown == false then
            self.isMouseDown = true;
            Lua_CommonUtil.addTimer("updataUpgradeControlTime", 0.3, self, self.updataUpgradeControlTime);
        end
    else
        if self.startClickTime == nil then
            self.startClickTime = getTime();
        end
        if getTime() - self.startClickTime < 0.3 then -- 点击
            self:onUpgradeBtnClick();
        end
        self:removeControlTime();
    end
end

function Lua_HeroAttributePanel:updataUpgradeControlTime()
    if getTime() - self.startClickTime > 0.3 then -- 长按
        self:onUpgradeBtnClick();
        return;
    end
end

function Lua_HeroAttributePanel:onUpgradeBtnClick() -- 点击
    local heroUpgradeVo = self.data.heroUpgradeVo;
    if not heroUpgradeVo.bResonanceLevel and self.data.level < self.data.max_lvl_limit then--同调器等级不满足
        self:showGotoResonanceTips();
        self:removeControlTime();
        return
    end

    if heroUpgradeVo.isBreak == true and heroUpgradeVo.isMaxLevel ~= true then --是突破就停止点击打开升级消耗界面
        self.isFirstPress = 0;
        self:removeControlTime();
        Lua_WindowUtil.openWin("Lua_HeroUpgradeCostWindow", Lua_WinParam.ACTION_OPEN, {data = self.data, isBreak = true} );
    else
        if heroUpgradeVo.isMaxLevel == true then--达到当前星级的等级上限
            self:showUpStarTips();
            self:removeControlTime();
            return
        end
        --材料充足
        if heroUpgradeVo.isUpgradeHero == true then -- 是否可以升级
            local value = self.guideHeroLevel;
            if value == nil then
                value = 0;
            end
            Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroUpgrade(self.data.unique_id, value);
            self.guideHeroLevel = nil;
        else
            self:removeControlTime();
            DataCenter.packUtil:openPathWindow(heroUpgradeVo.isUpgradeHero, false);
        end
    end
end

function Lua_HeroAttributePanel:showGotoResonanceTips()
    local tipData = { titleSprite = "fonts_3_007", des = LanUtil.getValue(126121), btnType = 1, owner = self, sureFun = self.onGoToResonanceBtnClick };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_HeroAttributePanel:showUpStarTips()
    local tipData = { titleSprite = "fonts_3_007", des = LanUtil.getValue(126111), btnType = 1, owner = self, sureFun = self.onSubBtnClick };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_HeroAttributePanel:onSubBtnClick() 
    Lua_MsgUtil.callFunc("UPDATE_HERO_TAB_REDDOT", 3);
end

--同调器Tips
function Lua_HeroAttributePanel:onGoToResonanceBtnClick()
    DataCenter.funcPathUtil:gotoFunction(1049, true)
end

function Lua_HeroAttributePanel:showResonanceTips(bool)
    if bool then
        if self.des_bg == nil then
            self.des_bg = UICreate.createUIAtlasImage(self.content, "hero_develop_altas", "xui_hb_widget_6", 0, 246, 0, 0);
            self.des_bg.anchorValue = 7;
            self.des_lab = UICreate.createLabel(self.content, LanUtil.getValue(126061), 0, 247, 300, 40, 24);
            self.des_lab.anchorValue = 7;
            self.des_lab.pivot = UIUtils.Pivot.Center;
            self.des_lab.alignmentValue = 4;
            self.des_lab.colorStr = Lua_ColorDefine.transColorStr("fdf2df");
        else
            self.des_bg:setEnable(true);
            self.des_lab:setEnable(true);
        end
    else
        if self.des_bg ~= nil then
            self.des_bg:setEnable(false);
            self.des_lab:setEnable(false);
        end
    end
end

--升级红点
function Lua_HeroAttributePanel:showRedDot()
    local redDotState = self.data.heroUpgradeVo.heroUpgradeReddot;
    if redDotState == true then
        if self.redDotIcon == nil then
            self.redDotIcon = Lua_RedPointIcon.new(self.content);
            self.redDotIcon:setLocation(86, 196, 0);
            self.redDotIcon:setRectAnchor(7);
            self.redDotIcon:createRedPointImg(nil);
        end
        self.redDotIcon:updateRedPointShow(true);
    else
        if self.redDotIcon ~= nil then
            self.redDotIcon:updateRedPointShow(false);
        end
    end
end

function Lua_HeroAttributePanel:removeControlTime(go) -- 移出计时器
    if self.isMouseDown == true then
        self.isMouseDown = false;
        self.startClickTime = nil;
        Lua_CommonUtil.removeTimer(self,self.updataUpgradeControlTime);
    end
end



------------------------------------ 装备符石处理 ------------------------------------

function Lua_HeroAttributePanel:updateEquipInfo(hvo)
    if self.hvo ~= nil and self.hvo.unique_id ~= hvo.unique_id then
        self.tag_activate_lvl = nil;
    end

    if self.isFirstUpdate == nil then
        self.isFirstUpdate = false;
        self.showSunesArr = Array();
        local isDouble;
        local pos = {{-293,112},{294.5,112}}
        for i = 1, 2 do
            if i % 2 ~= 0 then
                item = Lua_HeroRunesItem.new(self.leftObj, 2);
            else
                item = Lua_HeroRunesItem.new(self.rightObj, 2);
            end
            item.part = i;
            item:setLocation(pos[i][1], pos[i][2], 0);
            self.showSunesArr:add(item);
        end

        pos = {{-292,372},{294,372},{-292,247},{294,247}}
        self.showEquipArr = Array();
        for i = 1, 4 do
            if i % 2 ~= 0 then
                item = Lua_HeroEquipItem.new(self.leftObj);
            else
                item = Lua_HeroEquipItem.new(self.rightObj);
            end
            item:setLocation(pos[i][1], pos[i][2], 0);
            self.showEquipArr:add(item);
        end

        self.master_btn:setEnable(true);
        self.masterTxt:setEnable(true);
        self.leftDownObj:SetActive(true);
        self.rightDownObj:SetActive(true);
    end

    self.hvo = hvo;
    self.master_btn:setEnable(not hvo.trial_state);
    self.masterTxt:setEnable(not hvo.trial_state);

    local equip_red = false;
    local list = hvo.equipInfo;
    for i=1,self.showEquipArr:getSize() do
        self.showEquipArr[i]:setParams(i, hvo.level, hvo.star, hvo.unique_id, hvo.trial_state);

        if hvo.trial_state then
            self.showEquipArr[i]:setData(hvo.equipTipsInfo[i]);
        else
            self.showEquipArr[i]:setData(list[i]);
            if self.showEquipArr[i].redDotState == true then
                equip_red = true;
            end
        end
    end

    local list = hvo.runsInfo;
    if hvo.trial_state then
        list = hvo.runsTipsInfo;
    end
    for i=1,self.showSunesArr:getSize() do
        self.showSunesArr[i]:setData(list[i], hvo);
    end

    self.demount_btn:setEnable(not hvo.trial_state);
    self.worn_btn:setEnable(not hvo.trial_state);

    self:showWornRedDot(equip_red and (not hvo.trial_state));--一键穿戴红点

    local master_lvl = DataCenter.equipUtil:getEquipMasterLevelByHeroUid(hvo.unique_id);
    if master_lvl == 0 then
        self.masterTxt.text = master_lvl;
    else
        self.masterTxt.text = "+" .. master_lvl;
    end

    local activate_lvl = DataCenter.equipUtil:getMasterActivateIdByMasterLevel(master_lvl);
    if self.tag_activate_lvl == nil then
        self.tag_activate_lvl = activate_lvl;
    else
        if activate_lvl > self.tag_activate_lvl then--强化大师激活等级提高
            local arr = DataCenter.equipUtil:getStrongMasterProp(activate_lvl);
            Lua_WindowUtil.openWin("Lua_EquipMasterActivateWindow", Lua_WinParam.ACTION_OPEN, {attr_info = arr, activate_level = activate_lvl});
        end
        self.tag_activate_lvl = activate_lvl;
    end
end

--一键穿戴红点
function Lua_HeroAttributePanel:showWornRedDot(val)
    if val == true then
        if self.equipRedDot == nil then
            self.equipRedDot = Lua_RedPointIcon.new(self.worn_btn.mainContent);
            -- self.equipRedDot:setRectAnchor(7);
            self.equipRedDot:setLocation(75, 27, 0);
            self.equipRedDot:createRedPointImg(nil);
        end
        self.equipRedDot:updateRedPointShow(true);
    else
        if self.equipRedDot ~= nil then
            self.equipRedDot:updateRedPointShow(false);
        end
    end
end

--一键穿戴
function Lua_HeroAttributePanel:onWornBtnClick()
    local isWornEruip = #self.hvo.equip_info == 0;
    local arr = DataCenter.packData:getItemArrByPackType(Lua_PackDefine.TYPE_EQUIP);--装备背包数据
    if isWornEruip == true and arr:getSize() == 0 then
        OperateAlert.showLangValue(126716);--暂无可穿戴装备
        return
    end

    Lua_ProxyManager.getProxy("Lua_EquipProxy"):sEquipChange(self.hvo.unique_id, 1); -- 一键穿戴
end

--一键卸下
function Lua_HeroAttributePanel:onDemountBtnClick()
    local isWornEruip = #self.hvo.equip_info == 0;
    if isWornEruip == true then
        OperateAlert.showLangValue(126715);
        return
    end
    Lua_ProxyManager.getProxy("Lua_EquipProxy"):sEquipChange(self.hvo.unique_id,2); -- 一键卸下
end

--强化大师
function Lua_HeroAttributePanel:onMasterBtnClick()
    Lua_WindowUtil.openWin("Lua_EquipStrongMasterWindow", Lua_WinParam.ACTION_OPEN, {unique_id = self.hvo.unique_id, select_type = 1});
end

function Lua_HeroAttributePanel:updateGenius()
    if DataCenter.heroGeniusData:checkExistGenius(self.data.id) then
        self.checkGenius:setEnable(true);
        self.checkGenius:setAltas("hero_altas", "xui_tf_button_"..(5 + self.data.geniusLv));
        local state = DataCenter.heroGeniusData:checkRedPoint(self.data);
        if state then
            if self.geniusRed == nil then
                self.geniusRed = Lua_RedPointIcon.new(self.content);
                self.geniusRed:setRectAnchor(7);
                self.geniusRed:setLocation(-260, 600, 0);
                self.geniusRed:showRedPoint(true, true);
            end
            self.geniusRed:setEnable(true);
        else
            if self.geniusRed then
                self.geniusRed:setEnable(false);
            end
        end
    else
        self.checkGenius:setEnable(false);
        if self.geniusRed then
            self.geniusRed:setEnable(false);
        end
    end
end

function Lua_HeroAttributePanel:onCheckGenius(go)
    if DataCenter.heroGeniusData:checkHeroGeniusIsUnlock(self.hvo, true) then
        Lua_WindowUtil.openWin("Lua_HeroGeniusWindow", Lua_WinParam.ACTION_OPEN, self.hvo.unique_id);
    end
end