-- 英雄重修
Lua_HeroRebuildWindow = class("Lua_HeroRebuildWindow", Lua_Window);
function Lua_HeroRebuildWindow:ctor()
    self:superCall("ctor");
    self.isClickClose = true;
    self.showBlackMask = true;
    self.windowName = "Lua_HeroRebuildWindow";
    self.skinName = "HeroRebuildWindow_skin";
end

function Lua_HeroRebuildWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.show_obj:SetActive(false);

    self.heroItemIcon = Lua_HeroItemIcon.new(self.content);
    self.heroItemIcon:setScale(0.92,0.92);
    self.heroItemIcon:setLocation(-10,152,0);

    self.dragList = Lua_DragList.new(self.content,680, 230, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_HeroRebuildCell, 107, 107, 5);
    self.dragList:setCellSpacing(15, 20);
    self.dragList:setLocation(30, -153);
    self.dragList:setScale(0.86, 0.86);

    self.subBtn:addClickFuntion(self, self.onOpenTipsClick);
    self.help:addClickFuntion(self, self.onHelpBtnClick);
end

-- 英雄展示数据  
function Lua_HeroRebuildWindow:showWin(data)
    self:updateRebuildInfo(data);
end

function Lua_HeroRebuildWindow:updateRebuildInfo(data)
    self.data = data;

    self.heroItemIcon:setData(data);
    self.heroItemIcon:showFightIcon(nil);

    self.show_des.text = LanUtil.formateStr(126040,self.data.name);
    local arr = DataCenter.heroData:rebuildInfo(data);
    -- local arr = Array();
    -- for i=1,20 do
    --     arr:add(i);
    -- end
    self.dragList:setArrayData(arr);

    self.need_money = DataCenter.heroUtil:rebuild_money(data.level);
    if self.need_money == 0 then
        self.show_obj:SetActive(false);
    else
        self.money.text = LanUtil.formateStr(126039,tostring(self.need_money));
        self.show_obj:SetActive(true);
    end
end

function Lua_HeroRebuildWindow:onOpenTipsClick()
    local tipsData = {
        des = LanUtil.getValue(126042),
        posY = 30,
        time = DataCenter.heroUtil.rebuild_down_time,
        btnType = 1,
        owner = self,
        sureFun = self.onRebuildBtnClick
    };
    if self.need_money ~= 0 then -- 免费
        local str = spliceIconStrById(Lua_ResourcesDefine.DIAMOND);
        tipsData.des = LanUtil.formateStr(126043, str, tostring(self.need_money));
        tipsData.posY = 34;
        time = 0
    end
    Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipsData);
end

function Lua_HeroRebuildWindow:onRebuildBtnClick() -- 重修
    local have_num = DataCenter.packData:getItemCountById(Lua_ResourcesDefine.DIAMOND);
    if have_num < self.need_money then
        DataCenter.packUtil:openPathWindow(Lua_ResourcesDefine.DIAMOND, false);
        return;
    end

    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroRebuild(self.data.unique_id);
    self:hide();
end

function Lua_HeroRebuildWindow:onSureCallback(go)
    self:hide();
end

--重修规则
function Lua_HeroRebuildWindow:onHelpBtnClick()
    local tipsData = { des = LanUtil.getValue(126044), posX = 78, posY = -564 };
    Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_HeroRebuildWindow:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end

    if self.heroItemIcon ~= nil then
        self.heroItemIcon:dispose();
        self.heroItemIcon = nil;
    end
    self:superCall("dispose");
end














-- 重修Item
Lua_HeroRebuildCell = class("Lua_HeroRebuildCell", Lua_ListCell);
function Lua_HeroRebuildCell:ctor(p)
    self:superCall("ctor", p);
end

function Lua_HeroRebuildCell:buildShowItem()
    self:superCall("buildShowItem");
    self.heroItemIcon = Lua_ItemIcon.new(self.content);
    self.heroItemIcon:setScale(0.86,0.86,0.86);
    self.heroItemIcon:setCanClick(false);
end

function Lua_HeroRebuildCell:dispose()
    if self.heroItemIcon ~= nil then
        self.heroItemIcon:dispose();
        self.heroItemIcon = nil;
    end
    self.data = nil;
    self:superCall("dispose");
end

function Lua_HeroRebuildCell:setData(data)
    self.data = data;
    self.heroItemIcon:setData(data);
end

function Lua_HeroRebuildCell:onPressClick(go)
    if self.data ~= nil then
        DataCenter.packUtil:showItemInfo(self.data);
    end
end