-- 升级消耗展示
Lua_HeroUpgradeCostWindow = class("Lua_HeroUpgradeCostWindow", Lua_Window);
function Lua_HeroUpgradeCostWindow:ctor()
    self:superCall("ctor");
    self.showBlackMask = true;
    self.isClickClose = true;
    self.windowName = "Lua_HeroUpgradeCostWindow";
    self.skinName = "HeroUpgradeCostWindow_skin";
end

function Lua_HeroUpgradeCostWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.sub_btn:addClickFuntion(self, self.onSubBtnClick);
    self.cancel_btn:addClickFuntion(self, self.onCancelBtnClick);
end

function Lua_HeroUpgradeCostWindow:showWin(param)
    self:superCall("showWin",param)
    self.data = param.data;
    self.isBreak = param.isBreak;
    self.show_left.text = "Lv."..param.data.level;
    self.isUpMaxlvl = param.isUpMaxlvl;
    local show_lvl;
    if self.isBreak == true then
        show_lvl = param.data.level + 1;
        self:showUpgradeCost(param.data.heroUpgradeVo.upgradeCostInfo);
    else
        show_lvl = param.data.heroUpgradeVo.upMaxLevel;
        local info = param.data.heroUpgradeVo:upgradeMaxCostInfo(show_lvl);
        self:showUpgradeCost(info);
    end
    self.show_rigth.text = "Lv."..show_lvl;
end

-- 动态显示升级消耗
function Lua_HeroUpgradeCostWindow:showUpgradeCost(info)
    if self.costInfo == nil then
        self.costInfo = Array();
    end
    local len = self.costInfo:getSize();
    for i = 1, len do
        self.costInfo[i]:setEnable(false);
    end
    local item;
    local width = 200;
    for i = 1, info:getSize() do
        if self.costInfo[i] ~= nil then
            item = self.costInfo[i];
        else
            item = Lua_HeroUpgradeCostItem.new(self.content);
            self.costInfo:add(item);
        end
        item:setData(info[i]);
        item:setLocation(-1 * width * info:getSize() / 2 + width * (i-1) + width / 2 + 10, -65, 0);
        item:setEnable(true);
    end
end

function Lua_HeroUpgradeCostWindow:onSubBtnClick()
    local heroUpgradeVo = self.showData.data.heroUpgradeVo;
    if heroUpgradeVo.isUpgradeHero ~= true then -- 材料不足
        DataCenter.packUtil:openPathWindow(heroUpgradeVo.isUpgradeHero, false);
        return
    end
    DataCenter.heroData.isBreak = self.isBreak;
    local state = 0;
    if self.isUpMaxlvl == true then--直升100
        state = 1;
    end
    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroUpgrade(self.showData.data.unique_id, state);
    self:hide();
end

function Lua_HeroUpgradeCostWindow:onCancelBtnClick()
    self:hide();
end

function Lua_HeroUpgradeCostWindow:dispose()
    if self.costInfo ~= nil then
        self.costInfo:dispose();
        self.costInfo:clear();
        self.costInfo = nil;
    end

    self:superCall("dispose");
end











-- 消耗显示item
Lua_HeroUpgradeCostItem = class("Lua_HeroUpgradeCostItem", Lua_DisplayObject);
function Lua_HeroUpgradeCostItem:ctor(p)
    self:superCall("ctor", p,"HeroUpgradeCostItem_skin");
end

function Lua_HeroUpgradeCostItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_HeroUpgradeCostItem:setData(data)
    self.data = data;
    local bagNum = data.bagNum;
    local color = "479152";
    if data.isShowRed == false then
        color = "ec4d2d";
    end
    self.cost_value.text = "<color=#"..color..">"..bagNum.."</color>/"..data.needNum;
    self.cost_value:resetSize();
    self.cost_icon:setAltas(data.atlas,data.sprite);
end

function Lua_HeroUpgradeCostItem:dispose()
    self.data = nil;
    self:superCall("dispose");
end