-- 英雄觉醒技能详情
Lua_HeroAwakenSkillDetailsWindow = class("Lua_HeroAwakenSkillDetailsWindow", Lua_Window);
function Lua_HeroAwakenSkillDetailsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HeroAwakenSkillDetailsWindow";
	self.skinName = "HeroAwakeSkillDetailsWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_HeroAwakenSkillDetailsWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.skillItem = Lua_SkillIconItem.new(self.showObject);
	self.skillItem:setLocation(-170, -60, 0);

	self.btnSwitch:setEnable(false);
	self.btnSwitch:addClickFuntion(self, self.onBtnSwitchClick);
end

function Lua_HeroAwakenSkillDetailsWindow:dispose()
	if self.skillItem ~= nil then
		self.skillItem:dispose();
		self.skillItem = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroAwakenSkillDetailsWindow:showWin(param)
	self:superCall("showWin", param);

	if param.columnIdx == nil then
		self.btnSwitch:setEnable(false);
	else
		self.btnSwitch:setEnable(true);
	end

	local data = Lua_SkillConfigData.getConfigData(param.skillId);
	self.skillItem:setData(data);
	self.nameText.text = data.name;
	self.typeText.text = data.skillTypeName;
	self.des_1.text = data.des;
	self.des_2.text = data.des1;
	self.des_3.text = data.effect_des;
end

function Lua_HeroAwakenSkillDetailsWindow:onBtnSwitchClick(go)
	Lua_MsgUtil.callFunc("HERO_AWAKEN_SKILL_SWITCH",{ columnIdx = self.showData.columnIdx, skillIdx = self.showData.skillIdx, skillId = self.showData.skillId });
	self:hide();
end