Lua_HeroAwakenSkillIcon = class("Lua_HeroAwakenSkillIcon", Lua_DisplayObject);
function Lua_HeroAwakenSkillIcon:ctor(p)
	self:superCall("ctor", p, "HeroAwakenSkillIcon_skin");
end

function Lua_HeroAwakenSkillIcon:buildShowItem()
	self:superCall("buildShowItem");

	self.icon:setEnable(false);
	self.btnAdd:setEnable(false);
	self.lock:setEnable(true);
	self.iconBg:addClickFuntion(self, self.onIconClick);
end

function Lua_HeroAwakenSkillIcon:dispose()
	self.owner = nil;
	self.callBack = nil;
	self:superCall("dispose");
end

function Lua_HeroAwakenSkillIcon:setClickCallBack(owner, callBack)
	self.owner = owner;
	self.callBack = callBack;
end

function Lua_HeroAwakenSkillIcon:setData(columnIdx, unlockLv, awakenLv)
	self.columnIdx = columnIdx; -- 索引
	self.unlockLv = unlockLv; -- 解锁等级
	self.awakenLv = awakenLv; -- 觉醒等级
	self:updateShowInfo();
end

function Lua_HeroAwakenSkillIcon:setSkill(skillIdx, skillId)
	self.skillIdx = skillIdx; -- 选择的技能索引
	self.skillId = skillId; -- 技能
	self:updateShowInfo();
end

function Lua_HeroAwakenSkillIcon:updateShowInfo()
	if self.skillId == nil then
		self.icon:setEnable(false);
		self.btnAdd:setEnable(false);
		self.lock:setEnable(true);
		if self.awakenLv == self.unlockLv then
			self.des.text = "可解锁";
		elseif self.awakenLv < self.unlockLv then
			if self.unlockLv == 1 then
				self.des.text = "激活附魔解锁";
			else
				self.des.text = LanUtil.formateStr("附魔{1}级可解锁", tostring(self.unlockLv));
			end
		else
			self.des.text = "";
		end
	elseif self.skillId <= 0 then
		self.icon:setEnable(false);
		self.btnAdd:setEnable(true);
		self.lock:setEnable(false);		
		self.des.text = "点击选择技能";
	else
		self.icon:setEnable(true);
		self.btnAdd:setEnable(false);
		self.lock:setEnable(false);
		local data = Lua_SkillConfigData.getConfigData(self.skillId);
		self.icon:setAltas(data.atlas, data.sprite);
		self.des.text = data.name;
	end
end

function Lua_HeroAwakenSkillIcon:onIconClick(go)
	if self.skillId == nil then
		if self.awakenLv == self.unlockLv then
			self.callBack(self.owner, 2, self.columnIdx); -- 解锁
		elseif self.awakenLv < self.unlockLv then
			if self.unlockLv == 1 then
				OperateAlert.show("激活附魔解锁");
			else
				OperateAlert.show(LanUtil.formateStr("觉醒等级需要达到{1}级可解锁", tostring(self.unlockLv)));
			end		
		end
	elseif self.skillId <= 0 then
		self.callBack(self.owner, 1, self.columnIdx); -- 选择
	else
		self.callBack(self.owner, 3, self.columnIdx, self.skillIdx, self.skillId); -- 详情可切换
	end
end