-- 英雄觉醒技能选择
Lua_HeroAwakenSkillSelectWindow = class("Lua_HeroAwakenSkillSelectWindow", Lua_Window);
function Lua_HeroAwakenSkillSelectWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HeroAwakenSkillSelectWindow";
	self.skinName = "HeroAwakeSkillSelectWindow_skin";
	self.showBlackMask = true;
end

function Lua_HeroAwakenSkillSelectWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.skillList = Lua_DragList.new(self.content, 600, 250, Lua_AxisDefine.Horizontal);
	self.skillList:setLocation(0, 50, 0);
	self.skillList.canDrag = false;
	self.skillList:setListCell(Lua_HeroAwakenSkillSelectItem, 200, 250, 1);

	self.btnChoose:addClickFuntion(self, self.onBtnChooseClick);

	self:addLuaEvent("HERO_AWAKEN_SKILL_SELECT", self, self.onAwakenSkillSelected);
end

function Lua_HeroAwakenSkillSelectWindow:dispose()
	if self.skillList ~= nil then
		self.skillList:dispose();
		self.skillList = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroAwakenSkillSelectWindow:showWin(param)
	self:superCall("showWin", param);

	local config = DataCenter.heroUtil:getAwakenConfig(param.awakenId);
	local vo = DataCenter.heroUtil:getAwakenTypeVo(config.type);
	local list = vo.skill_info[param.columnIdx];
	self.skillList:setArrayData(list);
	self.skillList:setSelected(1);
	self.skillList.showDragDataList[1].cell:onPressClick();
end

function Lua_HeroAwakenSkillSelectWindow:onAwakenSkillSelected(data)
	self.skillIdx = data[1];
	self.skillId = data[2];
end

function Lua_HeroAwakenSkillSelectWindow:onBtnChooseClick(go)
	if self.showData == nil then
		return;
	end
	Lua_ProxyManager.getProxy("Lua_HeroProxy"):sSwitchAwakenSkill(self.showData.heroUId, self.showData.columnIdx, self.skillIdx, 1);
end




















Lua_HeroAwakenSkillSelectItem = class("Lua_HeroAwakenSkillSelectItem", Lua_ListCell);
function Lua_HeroAwakenSkillSelectItem:ctor(p)
	self:superCall("ctor", p, "HeroAwakenSkillItem_skin");
end

function Lua_HeroAwakenSkillSelectItem:buildShowItem()
	self:superCall("buildShowItem");

	self.skillItem = Lua_SkillIconItem.new(self.content);
	self.skillItem:setLocation(0, 40, 0);
	self.skillItem:setCanClick(true);
end

function Lua_HeroAwakenSkillSelectItem:dispose()
	if self.skillItem ~= nil then
		self.skillItem:dispose();
		self.skillItem = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_HeroAwakenSkillSelectItem:setData(data)
	self.data = data;

	local config = Lua_SkillConfigData.getConfigData(data[2]);
	self.skillItem:setData(config);
	self.nameText.text = config.name;
	self.levelText.text = "Lv."..config.level;
end

function Lua_HeroAwakenSkillSelectItem:onSelectionChange(bSelect)
    self:superCall("onSelectionChange", bSelect);
    if bSelect == true then
    	self.itemBg:setAltas("common_altas_1", "ui_common_window_009");
    else
    	self.itemBg:setAltas("common_altas_1", "ui_common_window_010");
    end
end

function Lua_HeroAwakenSkillSelectItem:onPressClick()
    Lua_MsgUtil.callFunc("HERO_AWAKEN_SKILL_SELECT", self.data);
    return true;
end