-- 英雄觉醒技能切换
Lua_HeroAwakenSkillSwitchWindow = class("Lua_HeroAwakenSkillSwitchWindow", Lua_Window);
function Lua_HeroAwakenSkillSwitchWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HeroAwakenSkillSwitchWindow";
	self.skinName = "HeroAwakeSkillSwitchWindow_skin";
	self.showBlackMask = true;
end

function Lua_HeroAwakenSkillSwitchWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.skillList = Lua_DragList.new(self.content, 600, 250, Lua_AxisDefine.Horizontal);
	self.skillList:setLocation(0, 50, 0);
	self.skillList.canDrag = false;
	self.skillList:setListCell(Lua_HeroAwakenSkillSwitchItem, 200, 250, 1);

	self.btnSwitch:addClickFuntion(self, self.onBtnSwitchClick);

	self:addLuaEvent("HERO_AWAKEN_SKILL_SELECT", self, self.onAwakenSkillSelected);
end

function Lua_HeroAwakenSkillSwitchWindow:dispose()
	if self.skillList ~= nil then
		self.skillList:dispose();
		self.skillList = nil;
	end
	if self.costArr ~= nil then
		self.costArr:dispose();
		self.costArr:clear();
		self.costArr = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroAwakenSkillSwitchWindow:showWin(param)
	self:superCall("showWin", param);

	local config = DataCenter.heroUtil:getAwakenConfig(param.awakenId);
	local vo = DataCenter.heroUtil:getAwakenTypeVo(config.type);
	local list = vo.skill_info[param.columnIdx];
	
	local arr = Array();
	local selectIdx = 1;
	for i = 1, #list do
		if list[i][1] == param.skillIdx then
			selectIdx = i;
		end
		arr:add({ data = list[i], bUseing = list[i][1] == param.skillIdx });
	end

	self.skillList:setArrayData(arr);
	self.skillList:setSelected(selectIdx);
	self.skillList.showDragDataList[selectIdx].cell:onPressClick();
end

function Lua_HeroAwakenSkillSwitchWindow:onAwakenSkillSelected(data)
	if data.bUseing == true then
		self.btnSwitch:setEnable(false);
		self:showCostItem(nil);
	else
		self.btnSwitch:setEnable(true);
		local config = Lua_SkillConfigData.getConfigData(self.showData.skillId);
		self:showCostItem(config.switch_skill_consume);
		self.skillIdx = data.data[1];
		self.skillId = data.data[2];
	end
end

function Lua_HeroAwakenSkillSwitchWindow:showCostItem(data)
	if data == nil then
		if self.costArr ~= nil then
			for i = 1, self.costArr:getSize() do
				self.costArr[i]:setEnable(false);
			end
		end
	else
		if self.costArr == nil then
			self.costArr = Array();
		end

		local len = #data - self.costArr:getSize();
		while (len > 0) do
			item = Lua_ConsumeIconItem.new(self.content);
			self.costArr:add(item);
			len = len - 1;
		end

		while (len < 0) do
			item = self.costArr:remove(1);
			item:dispose();
			len = len + 1;
		end

		len = self.costArr:getSize();
		local space = 200;
		local w;
		local posX;
		for i = 1, len do
			item = self.costArr[i];
			item:setEnable(true);
			item:setData(data[i]);

			w = -(space * len) / 2 + space / 2;
			posX = ((i - 1) % len) * space + w;
			item:setLocation(posX, -180, 0);
		end
	end
end

function Lua_HeroAwakenSkillSwitchWindow:onBtnSwitchClick(go)
	if self.showData == nil then
		return;
	end
	
	local config = Lua_SkillConfigData.getConfigData(self.showData.skillId);
	local costId = DataCenter.packData:checkConsumeEnough(config.switch_skill_consume);
	if costId == nil then
		Lua_ProxyManager.getProxy("Lua_HeroProxy"):sSwitchAwakenSkill(self.showData.heroUId, self.showData.columnIdx, self.skillIdx, 2);
	else
		DataCenter.packUtil:openPathWindow(costId, false);
	end
end




















Lua_HeroAwakenSkillSwitchItem = class("Lua_HeroAwakenSkillSwitchItem", Lua_ListCell);
function Lua_HeroAwakenSkillSwitchItem:ctor(p)
	self:superCall("ctor", p, "HeroAwakenSkillItem_skin");
end

function Lua_HeroAwakenSkillSwitchItem:buildShowItem()
	self:superCall("buildShowItem");

	self.skillItem = Lua_SkillIconItem.new(self.content);
	self.skillItem:setLocation(0, 40, 0);
	self.skillItem:setCanClick(true);
end

function Lua_HeroAwakenSkillSwitchItem:dispose()
	if self.skillItem ~= nil then
		self.skillItem:dispose();
		self.skillItem = nil;
	end
	self.data = nil;
	self:superCall("dispose");
end

function Lua_HeroAwakenSkillSwitchItem:setData(data)
	self.data = data;

	if data.bUseing == true then
		self.promptText.text = "使用中";
	else
		self.promptText.text = "";
	end

	local config = Lua_SkillConfigData.getConfigData(data.data[2]);
	self.skillItem:setData(config);
	self.nameText.text = config.name;
	self.levelText.text = "Lv."..config.level;
end

function Lua_HeroAwakenSkillSwitchItem:onSelectionChange(bSelect)
    self:superCall("onSelectionChange", bSelect);
    if bSelect == true then
    	self.itemBg:setAltas("common_altas_1", "ui_common_window_009");
    else
    	self.itemBg:setAltas("common_altas_1", "ui_common_window_010");
    end
end

function Lua_HeroAwakenSkillSwitchItem:onPressClick()
    Lua_MsgUtil.callFunc("HERO_AWAKEN_SKILL_SELECT", self.data);
    return true;
end