-- 英雄觉醒技能解锁
checkRequire("Lua_HeroUpStarCostItem");
Lua_HeroAwakenSkillUnlockWindow = class("Lua_HeroAwakenSkillUnlockWindow", Lua_Window);
function Lua_HeroAwakenSkillUnlockWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HeroAwakenSkillUnlockWindow";
	self.skinName = "HeroAwakeSkillUnlockWindow_skin";
	self.showBlackMask = true;
end

function Lua_HeroAwakenSkillUnlockWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.skillList = Lua_DragList.new(self.content, 600, 250, Lua_AxisDefine.Horizontal);
	self.skillList:setLocation(0, 50, 0);
	self.skillList.canDrag = false;
	self.skillList:setListCell(Lua_HeroAwakenSkillUnlockItem, 200, 250, 1);

	self.btnUnlock:addClickFuntion(self, self.onBtnUnlockClick);

	self:addLuaEvent("UPDATA_SELECT_COST_HERO_NUM", self, self.updateSelectCostHeroNum);
end

function Lua_HeroAwakenSkillUnlockWindow:dispose()
	if self.skillList ~= nil then
		self.skillList:dispose();
		self.skillList = nil;
	end
	if self.costHeroArr ~= nil then
		self.costHeroArr:dispose();
		self.costHeroArr:clear();
		self.costHeroArr = nil;
	end
	if self.costArr ~= nil then
		self.costArr:dispose();
		self.costArr:clear();
		self.costArr = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroAwakenSkillUnlockWindow:showWin(param)
	self:superCall("showWin", param);

	local config = DataCenter.heroUtil:getAwakenConfig(param.awakenId);
	local vo = DataCenter.heroUtil:getAwakenTypeVo(config.type);
	local list = vo.skill_info[param.columnIdx];
	local arr = Array();
	for i = 1, #list do
		arr:add({ skillId = list[i][2], skillLv = config.skill_level })
	end
	self.skillList:setArrayData(arr);

	DataCenter.heroUpStarData:initUpStarData(self.showData.heroUId);

	arr = vo:getCostHeroArr(param.columnIdx);
	self:showCostHeroItem(arr);

	self.needHeroNum = vo:getNeedHeroNum(param.columnIdx);

	self.costList = vo:getCostResource(param.columnIdx);
	self:showCostResourceItem(self.costList);
end

function Lua_HeroAwakenSkillUnlockWindow:showCostHeroItem(data)
	if self.costHeroArr == nil then
		self.costHeroArr = Array();
	end
	local dataLen = data:getSize();
	local len = self.costHeroArr:getSize();
	local maxLen = dataLen > len and dataLen or len;
	local item;
	for i = 1, maxLen do
		item = self.costHeroArr[i];
		if i > dataLen then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_HeroUpStarCostItem.new(self.content);
				self.costHeroArr:add(item);
			else
				item:setEnable(true);
			end
			item:setLocation(-255 + (i -1) * 120, -135, 0);
			item:setData(data[i]);
		end
	end
end

function Lua_HeroAwakenSkillUnlockWindow:showCostResourceItem(data)
	if self.costArr == nil then
		self.costArr = Array();
	end
	len = #data - self.costArr:getSize();

	while (len > 0) do
		item = Lua_ConsumeIconItem.new(self.content);
		self.costArr:add(item);
		len = len - 1;
	end

	while (len < 0) do
		item = self.costArr:remove(1);
		item:dispose();
		len = len + 1;
	end

	len = self.costArr:getSize();
	local space = 200;
	local w;
	for i = 1, len do
		item = self.costArr[i];
		item:setData(data[i]);

		w = -(space * len) / 2 + space / 2;
		posX = 230 + ((i - 1) % len) * space + w;
		item:setLocation(posX, -110, 0);
	end
end

function Lua_HeroAwakenSkillUnlockWindow:updateSelectCostHeroNum(costMaterialsIndex)
    if self.costHeroArr[costMaterialsIndex] ~= nil then
        self.costHeroArr[costMaterialsIndex]:setSelectNum();
    end
end

function Lua_HeroAwakenSkillUnlockWindow:onBtnUnlockClick(go)
	if self.showData == nil or self.costList == nil then
		return;
	end
	
	local costId = DataCenter.packData:checkConsumeEnough(self.costList);
	if costId == nil then
		if DataCenter.heroUpStarData:isUpStar(self.needHeroNum) == true then
			Lua_ProxyManager.getProxy("Lua_HeroProxy"):sUnlockAwakenSkill(self.showData.heroUId, self.showData.columnIdx);
		else
			OperateAlert.showLangValue(126210);
		end
	else
		DataCenter.packUtil:openPathWindow(costId, false);
	end
end




















Lua_HeroAwakenSkillUnlockItem = class("Lua_HeroAwakenSkillUnlockItem", Lua_ListCell);
function Lua_HeroAwakenSkillUnlockItem:ctor(p)
	self:superCall("ctor", p, "HeroAwakenSkillItem_skin");
end

function Lua_HeroAwakenSkillUnlockItem:buildShowItem()
	self:superCall("buildShowItem");

	self.skillItem = Lua_SkillIconItem.new(self.content);
	self.skillItem:setLocation(0, 40, 0);
	self.skillItem:setCanClick(true);
end

function Lua_HeroAwakenSkillUnlockItem:dispose()
	if self.skillItem ~= nil then
		self.skillItem:dispose();
		self.skillItem = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroAwakenSkillUnlockItem:setData(data)
	local config = Lua_SkillConfigData.getConfigData(data.skillId);
	self.skillItem:setData(config);
	self.nameText.text = config.name;
	self.levelText.text = "Lv."..data.skillLv;
end