-- 英雄觉醒
checkRequire("Lua_HeroUpStarCostItem");
Lua_HeroAwakenWindow = class("Lua_HeroAwakenWindow", Lua_Window);
function Lua_HeroAwakenWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HeroAwakenWindow";
	self.skinName = "HeroAwakenWindow_skin";
	self.showBlackMask = true;
end

function Lua_HeroAwakenWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.awakenList = Lua_DragList.new(self.content, 600, 600, Lua_AxisDefine.Vertical);
	self.awakenList:setLocation(0, 215, 0);
	self.awakenList:setListCell(Lua_HeroAwakenItem, 300, 300, 2);

	self.skillList = Lua_DragList.new(self.content, 600, 240, Lua_AxisDefine.Vertical);
	self.skillList:setLocation(0, -260, 0);
	self.skillList:setListCell(Lua_HeroAwakenSkillIconItem, 600, 80, 1);

	self.btnActivate:addClickFuntion(self, self.onBtnActivateClick);
	self.btnSwitch:addClickFuntion(self, self.onBtnSwitchClick);

	self:addLuaEvent("HERO_AWAKEN_SELECT", self, self.onAwakenSelected);
	self:addLuaEvent("UPDATA_SELECT_COST_HERO_NUM", self, self.updateSelectCostHeroNum);
end

function Lua_HeroAwakenWindow:dispose()
	if self.awakenList ~= nil then
		self.awakenList:dispose();
		self.awakenList = nil;
	end
	if self.skillList ~= nil then
		self.skillList:dispose();
		self.skillList = nil;
	end
	if self.costHeroArr ~= nil then
		self.costHeroArr:dispose();
		self.costHeroArr:clear();
		self.costHeroArr = nil;
	end
	if self.costArr ~= nil then
		self.costArr:dispose();
		self.costArr:clear();
		self.costArr = nil;
	end
	self.awakenVo = nil;
	self:superCall("dispose");
end

function Lua_HeroAwakenWindow:showWin(param)
	self:superCall("showWin", param);

	if param.awaken_id == nil or param.awaken_id <= 0 then
		self.btnActivate:setEnable(true);
		self.btnSwitch:setEnable(false);
	else
		self.btnActivate:setEnable(false);
		self.btnSwitch:setEnable(true);
	end

	local arr = DataCenter.heroUtil:getAwakenTypeArr(param.awaken_id, param.recom_awake);
	local len = arr:getSize();
	self.awakenList.canDrag = len > 4;
	self.awakenList:setArrayData(arr);

	local selectIdx;
	for i = 1, len do
		if arr[i].bRecom == true or arr[i].bUseing == true then
			selectIdx = i;
			break;
		end
	end
	if selectIdx == nil then
		selectIdx = 1;
	end
	self.awakenList:moveToIndex(selectIdx, true);
	self.awakenList:setSelected(selectIdx);
	local showList = self.awakenList.showList;
	for i = 1, showList:getSize() do
		if showList[i].data == arr[selectIdx] then
			showList[i]:onPressClick();
			break;
		end
	end
end

function Lua_HeroAwakenWindow:onAwakenSelected(data)
	self.awakenVo = DataCenter.heroUtil:getAwakenTypeVo(data.id);

	local arr = Array();
	local list = self.awakenVo.skill_info;
	for i = 1, #list do
		arr:add({ index = i, data = list[i] });
	end
	arr:sort("index", false);
	self.skillList:setArrayData(arr);

	if self.showData.awaken_id == nil or self.showData.awaken_id <= 0 then -- 激活
		DataCenter.heroUpStarData:initUpStarData(self.showData.unique_id);
		self:showCostHeroItem(self.awakenVo.costHeroArr);
		self:showCostResourceItem(self.awakenVo.active_resource_consume, 210, -470);
	else -- 切换
		if data.bUseing == true then
			self:showCostResourceItem(nil);
			self.btnSwitch:setEnable(false);
		else
			self:showCostResourceItem(self.awakenVo.active_resource_consume, 0, -470);
			self.btnSwitch:setEnable(true);
		end
	end
end

function Lua_HeroAwakenWindow:showCostHeroItem(data)
	if self.costHeroArr == nil then
		self.costHeroArr = Array();
	end
	local dataLen = data:getSize();
	local len = self.costHeroArr:getSize();
	local maxLen = dataLen > len and dataLen or len;
	local item;
	for i = 1, maxLen do
		item = self.costHeroArr[i];
		if i > dataLen then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_HeroUpStarCostItem.new(self.content);
				self.costHeroArr:add(item);
			else
				item:setEnable(true);
			end
			item:setLocation(-255 + (i -1) * 120, -480, 0);
			item:setData(data[i]);
		end
	end
end

function Lua_HeroAwakenWindow:showCostResourceItem(data, posX, posY)
	if data == nil then
		if self.costArr ~= nil then
			for i = 1, self.costArr:getSize() do
				self.costArr[i]:setEnable(false);
			end
		end
	else
		if self.costArr == nil then
			self.costArr = Array();
		end
		len = #data - self.costArr:getSize();

		while (len > 0) do
			item = Lua_ConsumeIconItem.new(self.content);
			self.costArr:add(item);
			len = len - 1;
		end

		while (len < 0) do
			item = self.costArr:remove(1);
			item:dispose();
			len = len + 1;
		end

		len = self.costArr:getSize();
		local space = 200;
		local w;
		for i = 1, len do
			item = self.costArr[i];
			item:setEnable(true);
			item:setData(data[i]);

			w = -(space * len) / 2 + space / 2;
			posX = posX + ((i - 1) % len) * space + w;
			item:setLocation(posX, posY, 0);
		end
	end
end

function Lua_HeroAwakenWindow:updateSelectCostHeroNum(costMaterialsIndex)
    if self.costHeroArr[costMaterialsIndex] ~= nil then
        self.costHeroArr[costMaterialsIndex]:setSelectNum();
    end
end

function Lua_HeroAwakenWindow:onBtnActivateClick(go)
	if self.awakenVo == nil then
		return;
	end

	local costId = DataCenter.packData:checkConsumeEnough(self.awakenVo.active_resource_consume);
	if costId == nil then
		if DataCenter.heroUpStarData:isUpStar(self.awakenVo.cost_hero_num) == true then
			Lua_ProxyManager.getProxy("Lua_HeroProxy"):sActivateAwaken(self.awakenVo.id, self.showData.unique_id);
		else
			OperateAlert.showLangValue(126210);
		end
	else
		DataCenter.packUtil:openPathWindow(costId, false);
	end
end

function Lua_HeroAwakenWindow:onBtnSwitchClick(go)
	if self.awakenVo == nil then
		return;
	end
	
	local config = DataCenter.heroUtil:getAwakenConfig(self.showData.awaken_id);
	local costId = DataCenter.packData:checkConsumeEnough(config.switch_consume);
	if costId == nil then
		Lua_ProxyManager.getProxy("Lua_HeroProxy"):sSwitchAwaken(self.showData.unique_id, self.awakenVo.id);
	else
		DataCenter.packUtil:openPathWindow(costId, false);
	end
end




















Lua_HeroAwakenItem = class("Lua_HeroAwakenItem", Lua_ListCell);
function Lua_HeroAwakenItem:ctor(p)
	self:superCall("ctor", p, "HeroAwakenItem_skin");
end

function Lua_HeroAwakenItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_HeroAwakenItem:dispose()
	self.data = nil;
	self:superCall("dispose");
end

function Lua_HeroAwakenItem:setData(data)
	self.data = data;
	if data.bRecom == true then
		self.prompt.text = "推荐";
	elseif data.bUseing == true then
		self.prompt.text = "使用中";
	else
		self.prompt.text = "";
	end

	local vo = DataCenter.heroUtil:getAwakenTypeVo(data.id);
	self.icon:setAltas(vo.atlas, vo.sprite);
	self.name.text = vo.name;
	self.des.text = vo.des;
end

function Lua_HeroAwakenItem:onSelectionChange(bSelect)
    self:superCall("onSelectionChange", bSelect);
    if bSelect == true then
    	self.itemBg:setAltas("common_altas_1", "ui_common_window_009");
    else
    	self.itemBg:setAltas("common_altas_1", "ui_common_window_010");
    end
end

function Lua_HeroAwakenItem:onPressClick()
    Lua_MsgUtil.callFunc("HERO_AWAKEN_SELECT", self.data);
    return true;
end




















Lua_HeroAwakenSkillIconItem = class("Lua_HeroAwakenSkillIconItem", Lua_ListCell);
function Lua_HeroAwakenSkillIconItem:ctor(p)
	self:superCall("ctor", p, "HeroAwakenSkillIconItem_skin");
end

function Lua_HeroAwakenSkillIconItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_HeroAwakenSkillIconItem:dispose()
	if self.skillArr ~= nil then
		self.skillArr:dispose();
		self.skillArr:clear();
		self.skillArr = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroAwakenSkillIconItem:setData(data)
	self.columnText.text = LanUtil.formateStr("第{1}层", tostring(data.index));

	if self.skillArr == nil then
		self.skillArr = Array();
	end
	local dataLen = #data.data;
	local len = self.skillArr:getSize();
	local maxLen = dataLen > len and dataLen or len;
	local item;
	for i = 1, maxLen do
		item = self.skillArr[i];
		if i > dataLen then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_SkillIconItem.new(self.content);
				self.skillArr:add(item);
			else
				item:setEnable(true);
			end
			item:setScale(0.7, 0.7);
			item:setLocation(-100 + (i -1) * 120, 0, 0);
			item:setCanClick(true);
			item:setSkillId(data.data[i][2]);
		end
	end
end