--英雄自传
Lua_HeroBiographyWindow = class("Lua_HeroBiographyWindow", Lua_Window);
function Lua_HeroBiographyWindow:ctor()
    self:superCall("ctor");
    self.isMaxIndex = false;
    self.selectIndex = 1;
    self.isClickClose = true;
    self.showBlackMask = true;
    self.windowName = "Lua_HeroBiographyWindow";
    self.skinName="HeroBiographyWindow_skin";
end

function Lua_HeroBiographyWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.upBtn:setEnable(false);
    self:addLuaEvent("UPDATE_HERO_DES_INFO", self, self.updateBiographyInfo);
    self.upBtn:addClickFuntion(self, self.onUpBtnClick);
    self.nextBtn:addClickFuntion(self, self.onNextBtnClick);
    self.icon:addClickFuntion(self, self.onBtnClick);
end

function Lua_HeroBiographyWindow:showWin(data)
    self.hvo = data;
    self.name.text = data.name;
    self.title.text = data.title;
    self:updateBiographyInfo();
end

--更新描述
function Lua_HeroBiographyWindow:updateBiographyInfo()
	local list = self.hvo.des_list;
    if list ~= nil then
    	self.isMaxIndex = list[self.selectIndex + 1]==nil;--是否到达最后选页
    end

    local isReward = DataCenter.heroData:getHeroDesStateByHid(self.hvo.id);
    if self.selectIndex == 1 then
    	self.num.text = self.hvo.biography[1][2];
	    self.reward_obj:SetActive(isReward == 1);--展示奖励
	else
		self.reward_obj:SetActive(false);
	end

	local id = list[self.selectIndex];
    local dcfg = DataCenter.heroUtil:getHeroDesConfig(id);
    local des = "";
    if dcfg ~= nil then
    	des = dcfg.des;
    end
    self.show_des.text = des;

    self.upBtn:setEnable(self.selectIndex ~= 1);
end

function Lua_HeroBiographyWindow:onUpBtnClick()
    if self.selectIndex < 1 then
        self.selectIndex = 1;
    else
        self.selectIndex = self.selectIndex-1;
    end
    self:updateBiographyInfo();
end

function Lua_HeroBiographyWindow:onNextBtnClick()
    if self.isMaxIndex == true then
    	self.selectIndex = 1;
	else
		self.selectIndex = self.selectIndex+1;
	end
    self:updateBiographyInfo();
end

function Lua_HeroBiographyWindow:onBtnClick()
    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroDesReward(self.hvo.unique_id);
end

function Lua_HeroBiographyWindow:dispose()
    self:superCall("dispose");
end