--评论评分
Lua_HeroCommentInputWindow = class("Lua_HeroCommentInputWindow", Lua_Window);
function Lua_HeroCommentInputWindow:ctor()
    self:superCall("ctor");
    self.isClickClose = true;
    self.showBlackMask = true;
    self.windowdes = "Lua_HeroCommentInputWindow";
    self.skinName="HeroCommentInputWindow_skin";
end

function Lua_HeroCommentInputWindow:buildShowItem()
    self:superCall("buildShowItem");
    self:addLuaEvent("ON_SELECT_STAR_ITEM", self, self.onSelectStarItem);-- 选星

    self.inputText.lineTypeValue = 1;
    self.inputText.strLenLimit = DataCenter.heroUtil.hero_comment_limit;
    self.inputText.text = "";
    self.inputText.textField:setAnchorMax(1,1);
    self.inputText.textField:setAnchorMin(0,0);
	self.inputText.textField:SetDimensions(0, 0);

    self.inputText:setDefaultLangValue(126020)
    self.inputText.placeholderTxt:setAnchorMax(1,1);
    self.inputText.placeholderTxt:setAnchorMin(0,0);
    self.inputText.placeholderTxt:SetDimensions(0,0);
    self.inputText:onChange(self,self.updateShowNum);

    self.starArr = Array();
    for i = 1, 5 do
        local item = nil;
        if self.starArr[i] ~= nil then
            item = self.starArr[i];
        else
            item = Lua_HeroCommentShowStarItem.new(self.content);
            item:setData(i);
            self.starArr:add(item);
        end
        item:setLocation(-132+(i-1)*66-1, 83, 0);
    end

    self.subBtn:addClickFuntion(self, self.onSubBtnClick);
    self.sureBtn:addClickFuntion(self, self.onSendBtnClick);

    self:onSelectStarItem(DataCenter.heroData.player_star);
    self.limit_num = DataCenter.heroUtil.hero_comment_limit;
    self.show_num.text = "0"..Lua_ColorDefine.getColorStr("4D4B4D","/"..self.limit_num);
end

function Lua_HeroCommentInputWindow:showWin(hid)
    self.hid = hid;
end

--更新输入字数数量
function Lua_HeroCommentInputWindow:updateShowNum()
	local show1 = utf8len(self.inputText.text);
	self.show_num.text = show1..Lua_ColorDefine.getColorStr("4D4B4D","/"..self.limit_num);
end

-- 选星
function Lua_HeroCommentInputWindow:onSelectStarItem(index)
	if self.selectStar == index then
		return
	end
    self.selectStar = index;
    for i=1,self.starArr:getSize() do
    	self.starArr[i]:changeSprite(index>=i);
    end
end

function Lua_HeroCommentInputWindow:onSendBtnClick()
    local des = self.inputText.text;
    if des ~= "" then
        -- 敏感字限制
	    if LanUtil.isIncludeInvalidWord(des) or string.find(des, "\\") ~= nil then     --含违规字符
	        OperateAlert.showLangValue(171031);
	        return;
	    end

	    -- local rs = Lua_ChatUtil.replaceChatMsg(des);
	    -- local canSend = Lua_ChatUtil.checkSendMsg(rs);
	    -- if canSend == 1 or canSend == 2 then
	    --     OperateAlert.showLangValue(171020);
	    --     self.inputText.text = "";
	    --     return;
	    -- end
    end
    if DataCenter.heroData.comment_have == 0 then--未拥有
        OperateAlert.showLangValue(126015);
        return;
    end
    if DataCenter.heroData.player_star == 0 then --第一次评星
	    if self.selectStar > 0 then--选了星级
	    	OperateAlert.showLangValue(126016);
	    else
	    	if des ~= "" then--写了评论
    			OperateAlert.showLangValue(126017);
    		else
    			OperateAlert.showLangValue(126018);
    			return;
			end
	    end
    else
    	if self.selectStar ~= DataCenter.heroData.player_star then--星级变动了
    		OperateAlert.showLangValue(126019);
		else
			if des ~= "" then--写了评论
    			OperateAlert.showLangValue(126017);
    		else
    			OperateAlert.showLangValue(126018);
    			return;
			end
		end
    end
    
    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sCommentSend(self.hid, des, self.selectStar);
    self:hide();
end

function Lua_HeroCommentInputWindow:onSubBtnClick()
	self:hide();
end

function Lua_HeroCommentInputWindow:dispose()
	self:superCall("dispose");
end











Lua_HeroCommentShowStarItem = class("Lua_HeroCommentShowStarItem", Lua_DisplayObject);
function Lua_HeroCommentShowStarItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_HeroCommentShowStarItem:buildShowItem()
    self:superCall("buildShowItem");
    self.star = UICreate.createUIAtlasImage(self.content, "common_altas_4", "xui_common_toggle_002_b", 0, 0, 60, 56);
    self.star:addClickFuntion(self, self.onBtnClick);
end

function Lua_HeroCommentShowStarItem:setData(index)
    self.index = index;
end

function Lua_HeroCommentShowStarItem:changeSprite(bool)
	if bool == true then
    	self.star:setAltas("common_altas_4","xui_common_toggle_002_f");
    else
    	self.star:setAltas("common_altas_4","xui_common_toggle_002_b");
    end
end

function Lua_HeroCommentShowStarItem:onBtnClick()
    Lua_MsgUtil.callFunc("ON_SELECT_STAR_ITEM", self.index);
end

function Lua_HeroCommentShowStarItem:dispose()
    self:superCall("dispose");
end