-- 英雄评论
Lua_HeroCommentWindow = class("Lua_HeroCommentWindow", Lua_Window);
function Lua_HeroCommentWindow:ctor()
    self:superCall("ctor");
    self.isClickClose = true;
    self.showBlackMask = true;
    self.windowName = "Lua_HeroCommentWindow";
    self.skinName="HeroCommentWindow_skin";
end

function Lua_HeroCommentWindow:buildShowItem()
    self:superCall("buildShowItem");

    self:addLuaEvent("UPDATE_HERO_COMMENT_INFO", self, self.updateCommentInfo);
    
    self:addLuaEvent("ON_COMMENT_CELL", self, self.onCommentCellItem);   --点赞
    self:addLuaEvent("ON_COMMENT_BTN_ITEM", self, self.onCommentBtnItem);--按钮点击

    self.heroItemIcon = Lua_HeroItemIcon.new(self.content);
    self.heroItemIcon:setLocation(-209,425,0);
    self.showBtnArr = Array();
    for i=1,2 do
        local item = Lua_HeroCommentBtnItem.new(self.content);
        item:setData(i);
        item:setLocation(-77+(i-1)*156, -478, 0);
        self.showBtnArr:add(item)
    end

    self.starArr = Array();
    for i = 1, 5 do
        local item = nil;
        if self.starArr[i] ~= nil then
            item = self.starArr[i];
        else
            item = Lua_HeroCommentStarItem.new(self.content);
            self.starArr:add(item);
        end
        item:setLocation(139+(i-1)*35, 324, 0);
        item:setEnable(true);
    end

    self.dragList = Lua_DragList.new(self.content,628, 670, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_HeroCommenCell, 628, 172, 1);
    self.dragList:setCellSpacing(4, 4);
    self.dragList:setLocation(0, -80);
    self.onBtn:addClickFuntion(self, self.onBtnClick);

    self:onCommentBtnItem(1);
end

function Lua_HeroCommentWindow:showWin(data)
    self.hvo = data;
    self.heroItemIcon:setData(data);
    self.heroItemIcon:showLevel(nil);
    self.heroItemIcon:showEffect(nil);
    self.heroItemIcon:showFightIcon(nil);

    self.name.text = self.hvo.name;
    self.title.text = self.hvo.title;

    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroComment(self.hvo.id);
end

function Lua_HeroCommentWindow:updateCommentInfo()
    if DataCenter.heroData.comment_have == 0 then
        self.heroItemIcon:showStar(nil);
    end
    self.heroItemIcon:setMask(DataCenter.heroData.comment_have == 0);
    self.comment_num.text = LanUtil.formateStr(126012, tostring(DataCenter.heroData.comment_num));
    local num = string.sub(DataCenter.heroData.comment_score,-1);
    if tonumber(num) == 0 then
        num = Mathf.Ceil(DataCenter.heroData.comment_score);
    else
        num = DataCenter.heroData.comment_score;
    end

    self.comment_score.text = num; --LanUtil.formateStr(126022, tostring());
    self:showStar();
    self:updateDragList(self.selectIndex);
end

-- 更新评论列表
function Lua_HeroCommentWindow:updateDragList(index)
    local arr = DataCenter.heroData:getCommentArrByIndex(index);
    self.dragList:setArrayData(arr);
end

-- 点击页签按钮
function Lua_HeroCommentWindow:onCommentBtnItem(index)
    if self.selectIndex == index then
        return
    end
    self.selectIndex = index;
    for i=1,self.showBtnArr:getSize() do
        self.showBtnArr[i]:selected(index);
    end
    self:updateDragList(index);
end

-- 显示星
function Lua_HeroCommentWindow:showStar()
    local comment = DataCenter.heroData.comment_score;
    local star = Mathf.Ceil(comment/2);
    local percent = string.sub(comment/2, 2,-1);
    if percent == "" then
        percent = 1;
    else
        percent = tonumber("0"..percent);
    end

    for i=1,self.starArr:getSize() do
        if i < star then
            self.starArr[i]:setFillAmount(1);
        elseif i == star then
            self.starArr[i]:setFillAmount(percent);
        else
            self.starArr[i]:setFillAmount(0);
        end

    end
end

function Lua_HeroCommentWindow:onCommentCellItem(data)
    if self.tagLikeCid == data.id then
        if self.lastTime == nil then
            self.lastTime = getTime();
        end
        local hero_comment_time = DataCenter.heroUtil.hero_comment_time;
        if getTime() - self.lastTime <= hero_comment_time then
            OperateAlert.showLangValue(126021);
            return
        end
    end
    self.lastTime = nil;
    self.tagLikeCid = data.id;
    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sCommentPressLike(self.hvo.id, data.id);

    if data.is_like == 0 then
        OperateAlert.showLangValue(126013);
    else
        OperateAlert.showLangValue(126014);
    end
end

function Lua_HeroCommentWindow:onBtnClick()
    if DataCenter.heroData.comment_have == 0 then--未拥有
        OperateAlert.showLangValue(126015);
        return;
    end
    Lua_WindowUtil.openWin("Lua_HeroCommentInputWindow", Lua_WinParam.ACTION_OPEN,self.hvo.id);
end

function Lua_HeroCommentWindow:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    if self.showBtnArr ~= nil then
        self.showBtnArr:dispose();
        self.showBtnArr:clear();
        self.showBtnArr = nil;
    end
    if self.starArr ~= nil then
        self.starArr:dispose();
        self.starArr:clear();
        self.starArr = nil;
    end
    self:superCall("dispose");
end

















--页签按钮
Lua_HeroCommentBtnItem = class("Lua_HeroCommentBtnItem", Lua_DisplayObject);
function Lua_HeroCommentBtnItem:ctor(p)
    self:superCall("ctor", p,"HeroCommentBtnItem_skin");
end

function Lua_HeroCommentBtnItem:buildShowItem()
    self:superCall("buildShowItem");
    self.bg.alpha = 0.01;
    self.bg:addClickFuntion(self, self.onBtnClick);
end

function Lua_HeroCommentBtnItem:setData(index)
    self.index = index;
    self.name:setLangValue(126009 + index);
end

function Lua_HeroCommentBtnItem:selected(index)
    if index == self.index then
        self.select:setEnable(true);
        self.name.colorStr = Lua_ColorDefine.transColor("8f5123");

        self.bg:SetDimensions(220, 67);
        self.select:SetDimensions(220, 67);
        self.bg:setLocation(0, 0);
        self.select:setLocation(0, 0);
    else
        self.select:setEnable(false);
        self.name.colorStr = Lua_ColorDefine.transColor("594d4d");
        
        self.bg:SetDimensions(185, 67);
        self.select:SetDimensions(185, 67);
        if self.index < index then
            self.bg:setLocation(-15, 0);
            self.select:setLocation(-15, 0);
        elseif self.index > index then
            self.bg:setLocation(15, 0);
            self.select:setLocation(15, 0);
        end
    end
    
end

function Lua_HeroCommentBtnItem:onBtnClick()
    Lua_MsgUtil.callFunc("ON_COMMENT_BTN_ITEM", self.index);
end

function Lua_HeroCommentBtnItem:dispose()
    self:superCall("dispose");
end
















--展示星星
Lua_HeroCommentStarItem = class("Lua_HeroCommentStarItem", Lua_DisplayObject);
function Lua_HeroCommentStarItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_HeroCommentStarItem:buildShowItem()
    self:superCall("buildShowItem");
    self.star_bg = UICreate.createUIAtlasImage(self.content, "common_altas_2", "ui_common_label_13", 0, 0, 36, 35);
    self.star_bg:setGray(true);
    self.star = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_label_06", 0, 0, 36, 35);
    self.star:setEnable(false);
    self.star.typeValue = 3;
end

function Lua_HeroCommentStarItem:setFillAmount(val)
    self.star.fillAmount = val;
    self.star:setEnable(true);
end

function Lua_HeroCommentStarItem:onBtnClick()
    Lua_MsgUtil.callFunc("ON_SELECT_STAR_ITEM", self.index);
end

function Lua_HeroCommentStarItem:dispose()
    self:superCall("dispose");
end












-- 评论item
Lua_HeroCommenCell = class("Lua_HeroCommenCell", Lua_ListCell);
function Lua_HeroCommenCell:ctor(p)
    self:superCall("ctor", p,"HeroCommenCell_skin");
end

function Lua_HeroCommenCell:buildShowItem()
    self:superCall("buildShowItem");
    self.like:addClickFuntion(self, self.onLikeBtnClick);
end

function Lua_HeroCommenCell:setData(data)
    self.data = data;
    self.name.text = data.name;
    self.des.text = data.comment;
    self.hot:setEnable(data.isShowHot);
    self.like_num.text = data.like_num;
    if data.is_like == 0 then
        self.like:setAltas("hero_develop_altas","xui_hb_tab_7");
    elseif data.is_like == 1 then
        self.like:setAltas("hero_develop_altas","xui_hb_tab_7_s");
    end
end

function Lua_HeroCommenCell:onLikeBtnClick()
    Lua_MsgUtil.callFunc("ON_COMMENT_CELL", self.data);
end

function Lua_HeroCommenCell:dispose()
    self.data = nil;
    self:superCall("dispose");
end
