-- 英雄升星星级图标展示 
Lua_HeroStarItem = class("Lua_HeroStarItem", Lua_DisplayObject);
function Lua_HeroStarItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_HeroStarItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_HeroStarItem:setData(data)
    if data ~= nil  then
        if self.quality_icon == nil then
            self.quality_icon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
            self.quality_icon:setScale(0.7,0.7,0.7);
        end
        self.quality_icon:setAltas("common_altas_4", "xui_common_attribute_"..35+data.quality);
        self.quality_icon:setEnable(true);
        if self.starDic == nil then
            self.starDic = {};
        end
        local scale = 0.8;
        local scale_bg = 0.8;
        local spr = "xui_common_label_15";
        local spr_bg = "xui_common_label_32";
        if data.quality >= 5 then
            scale = 1;
            scale_bg = 0.8;
            spr = "xui_common_label_34";
            spr_bg = "xui_common_label_33";
        end
        local item;
        local starWidth = 35;
        local star = data.quality_star;
        for i = 1, 5 do
            item = self.starDic[i];
            if item ~= nil then
                item:setEnable(false);
            end
            if i > star or data.quality < 5 then
                if item == nil then
                    item = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
                    item:setScale(0.8,0.8,0.8)
                    self.starDic[i] = item;
                end
                if i <= star then
                    item:setScale(scale,scale,scale);
                    item:setAltas("common_altas_4",spr);
                else
                    item:setScale(scale_bg,scale_bg,scale_bg);
                    item:setAltas("common_altas_4",spr_bg);
                end
                item:resetSize();
                item:setEnable(true);
                item:setLocation(46+(i-1)*starWidth, 0, 0);
            end
        end
    else
        if self.starDic ~= nil then
            for i = 1, 5 do
                if self.starDic[i] ~= nil then
                    self.starDic[i]:setEnable(false);
                end
            end
        end
        if self.quality_icon ~= nil then
            self.quality_icon:setEnable(false);
        end
    end
    self:showEffect(data);
end


function Lua_HeroStarItem:showEffect(data)
    if data ~= nil and data.quality ~= nil and data.quality >= 5  then
        if self.effectArr == nil then
            self.effectArr = Array();
        end
        local star = data.quality_star;
        local len = self.effectArr:getSize();
        for i=1,len do
            self.effectArr[i]:setEnable(false);
        end
        local starWidth = 35;
        for i = 1, star do
            local effect = self.effectArr[i];
            if effect == nil then
                effect = UICreate.createModelEffImg(self.content, "/effects/scsEffects/yinxiong_fire", "yinxiong_fire", 0, 0, 200, 200);
                effect:setCamField(100, 1, 100, true);
                self.effectArr:add(effect);
            end
            effect:setEnable(true);
            effect:setLocation(46+(i-1)*starWidth, -8, 0);
        end
    else
        if self.effectArr ~= nil then
            local len = self.effectArr:getSize();
            for i = 1, len do
                self.effectArr[i]:setEnable(false);
            end
        end
    end
end

function Lua_HeroStarItem:dispose()
    self.data = nil;
    self.quality_icon = nil;
    if self.starDic ~= nil then
        for k,v in pairs(self.starDic) do
            v:dispose();
            v = nil;
        end
        self.starDic = nil;
    end
    if self.effectArr ~= nil then
        self.effectArr:dispose();
        self.effectArr:clear();
        self.effectArr = nil;
    end
    self:superCall("dispose");
end