Lua_HeroConnectListWindow = class("Lua_HeroConnectListWindow", Lua_Window)
function Lua_HeroConnectListWindow:ctor()
	self:superCall("ctor")

	self.windowName = "Lua_HeroConnectListWindow"
	self.skinName = "HeroConnectListWindow_skin"
	self.showBlackMask = true
	self.isClickClose = true
end

function Lua_HeroConnectListWindow:buildShowItem()
	self:superCall("buildShowItem")
end

function Lua_HeroConnectListWindow:dispose()
	if self.itemList then
		self.itemList:dispose()
		self.itemList = nil
	end
	self:superCall("dispose")
end

function Lua_HeroConnectListWindow:showWin(param)
	if self.showData == param then
		return
	end
	self:superCall("showWin", param)

	local len = param:getSize()
	local height = len * 140
	local posY = (100 + height) / 2
	if self.itemList == nil then
		self.itemList = Lua_DragList.new(self.showObject, 653, height, Lua_AxisDefine.Vertical)
		self.itemList.canDrag = false
		self.itemList:setLocation(0, -posY - 18, 0)
		self.itemList:setListCell(Lua_HeroConnectListItem, 653, 140, 1)
	end
	self.itemList:setArrayData(param)

	self.winBg:SetDimensions(700, 100 + height)
	self.closeImgTip:setLocation(0, -self.winBg.height - 180, 0)
	LuaUtil.setObjPos(self.showObject, 0, posY + 18, 0)
end




















Lua_HeroConnectListItem = class("Lua_HeroConnectListItem", Lua_ListCell)
function Lua_HeroConnectListItem:ctor(p)
	self:superCall("ctor", p, "HeroConnectListItem_skin")
end

function Lua_HeroConnectListItem:buildShowItem()
	self:superCall("buildShowItem")
	self.icon:addClickFuntion(self, self.onCheckSkill)
end

function Lua_HeroConnectListItem:dispose()
	self.data = nil
	self.skillVo = nil
    self:superCall("dispose")
end

function Lua_HeroConnectListItem:setData(data)
	self.data = data
	self.skillVo = Lua_SkillConfigData.getConfigData(data.skillId)
	if self.skillVo then
		self.icon:setEnable(true)
		self.icon:setAltas(self.skillVo.atlas, self.skillVo.sprite)
	else
		self.icon:setEnable(false)
	end
	self.iconMask:setEnable(not data.isActivate)
	if data.isActivate then
		self.desText.colorStr = Lua_ColorDefine.transColorStr("FDEEB2")
	else
		self.desText.colorStr = Lua_ColorDefine.transColorStr("8E8E8E")
	end
	-- local str = data.desc
	-- str = string.gsub(str, "BCBCBC", "FFFFFF")
	-- str = string.gsub(str, "63BD7D", "FFFFFF")
	-- str = string.gsub(str, "F09080", "FFFFFF")
	self.desText.text = LanUtil.formateStr(10056, data.name)..data.desc
end

function Lua_HeroConnectListItem:onCheckSkill(go)
    local param = { skillVo = self.skillVo,unlock_type = 3,
     bActConnect = self.data.isActivate, connectVo = self.data }
    Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, param)
end