checkRequire("Lua_HeroConnectIconItem")
Lua_HeroConnectTipsWindow = class("Lua_HeroConnectTipsWindow", Lua_Window)
function Lua_HeroConnectTipsWindow:ctor()
	self:superCall("ctor")

	self.windowName = "Lua_HeroConnectTipsWindow"
	self.skinName = "HeroConnectTipsWindow_skin"
	self.showBlackMask = true
end

function Lua_HeroConnectTipsWindow:buildShowItem()
	self:superCall("buildShowItem")
	self.itemArr = Array()
end

function Lua_HeroConnectTipsWindow:dispose()
	self:removeTween()
	if self.itemArr then
		self.itemArr:dispose()
		self.itemArr:clear()
		self.itemArr = nil
	end
	self:superCall("dispose")
end

function Lua_HeroConnectTipsWindow:onMaskClick()
	if not self.isClickClose then
		return
	end
	self.isClickClose = false
	self.maskBg.alpha = 0.01
	TweenUtil.getInstance():addTweenTargetScale(self.content, 0.5, 0, 0, 0, 0)
	Lua_CommonUtil.delayCall(0.25, self, self.onTweenCompleted)
end

function Lua_HeroConnectTipsWindow:onTweenCompleted()
	Lua_MsgUtil.callFunc("HERO_CONNECT_TIPS_CLOSE")
end

function Lua_HeroConnectTipsWindow:removeTween()
	Lua_CommonUtil.removeTimer(self, self.onTweenCompleted)
	TweenUtil.getInstance():stop(self.content)
end

function Lua_HeroConnectTipsWindow:showWin(param)
	if self.showData == param then
		return
	end
	self:superCall("showWin", param)

	self:removeTween()
	self.isClickClose = true
	self.maskBg.alpha = self.blackAlpha
	LuaUtil.setObjScale(self.content, 1, 1, 1)

	self.desText.text = LanUtil.formateStr(10056, param.name)..param.desc
	local arr = param.condInfo
	local dataLen = arr:getSize()
	local arrLen = self.itemArr:getSize()
	local maxLen = dataLen > arrLen and dataLen or arrLen
	local item
	for i = 1, maxLen do
		item = self.itemArr[i]
		if i > dataLen then
			if item then
				item:setEnable(false)
			end
		else
			if item == nil then
				item = Lua_HeroConnectTipsItem.new(self.content)
				self.itemArr:add(item)
			else
				item:setEnable(true)
			end
			item:setData(i, dataLen, param, arr[i])
		end
	end

	local space = 185
	local w = -(space * dataLen) / 2 + space / 2
	local posX
	for i = 1, dataLen do
		item = self.itemArr[i]
		posX = ((i - 1) % dataLen) * space + w
		item:setLocation(posX, 158, 0);
	end
end




















Lua_HeroConnectTipsItem = class("Lua_HeroConnectTipsItem", Lua_DisplayObject)
function Lua_HeroConnectTipsItem:ctor(p)
	self:superCall("ctor", p)
end

function Lua_HeroConnectTipsItem:buildShowItem()
	self:superCall("buildShowItem")
	self.connItem = Lua_HeroConnectIconItem.new(self.content)
	self.addIcon = UICreate.createUIAtlasImage(self.content, "common_altas_4", "xui_common_label_29", 92.5, 0, 0, 0)
end

function Lua_HeroConnectTipsItem:dispose()
	if self.connItem then
		self.connItem:dispose()
		self.connItem = nil
	end
	self.addIcon = nil
	self:superCall("dispose")
end

function Lua_HeroConnectTipsItem:setData(index, len, connVo, data)
	self.addIcon:setEnable(index < len)
	self.connItem:setData(connVo, data)
end