-- 装备展示item
Lua_HeroEquipItem = class("Lua_HeroEquipItem", Lua_DisplayObject); 
function Lua_HeroEquipItem:ctor(p, typeof)
    self.typeof = typeof;--英雄tips 1
    self:superCall("ctor", p);
end

function Lua_HeroEquipItem:buildShowItem()
    self:superCall("buildShowItem");
    self.bg_spr = UICreate.createUIAtlasImage(self.content, "hero_develop_altas", "xui_hb_widget_2", 0, 0, 0, 0);
    self.maxk_spr = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
    self.lock_spr = UICreate.createUIAtlasImage(self.content, "hero_develop_altas","xui_hb_tab_5", 0, 0, 0, 0);
    self.lock_spr:setEnable(false);

    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.bg_spr:addClickFuntion(self, self.onIconBtnClick);

    if self.typeof == 1 then
        self.bg_spr:SetDimensions(112, 112);
    end
end

function Lua_HeroEquipItem:setParams(part, hvo_level, hvo_star, hero_uid, trial_state)
    self.part = part;
    self.hvo_level = hvo_level;
    self.hvo_star = hvo_star;
    self.hero_uid = hero_uid;
    self.trial_state = trial_state;
end

function Lua_HeroEquipItem.Get:redDotState()
    if self.showState == nil then
        return false;
    end
    return self.showState;
end

function Lua_HeroEquipItem:setData(param)
    if type(param) == "number" then
        self.evo = DataCenter.equipData:getEquipVoByUid(param);
    elseif type(param) == "table" then
        self.evo = param;
    elseif param == nil then
        self.evo = nil;
    end
    
    self.showState = false;
    if self.evo ~= nil then
        self.itemIcon:setData(self.evo);
        self.itemIcon:setEnable(true);
        self.itemIcon:setShadow(false);

        --替换红点状态
        if self.typeof == nil then
            self.showState = DataCenter.equipData:checkEquipChangeRedDot(self.part, self.evo.unique_id);
            -- if self.showState == false then
            --     self.showState = DataCenter.equipData:checkEquipStrongRedDot(self.evo.unique_id);--强化
            -- end
        end
    else
        self.isUnlock = DataCenter.equipUtil:equipPartUnlock(self.part, self.hvo_level, self.hvo_star);
        self.itemIcon:setEnable(false);
        self.lock_spr:setEnable(not self.isUnlock);
        self.maxk_spr:setAltas("hero_develop_altas", DataCenter.equipUtil:getEquipShadow(self.part, 1));
        if self.typeof == nil then
            self.showState = DataCenter.equipData:checkEquipChangeRedDot(self.part, nil) and self.isUnlock;
        end
    end

    if self.typeof == 1 then
        self.itemIcon:setScale(0.9, 0.9);
        self.itemIcon:setCanClick(self.evo ~= nil);
    else
        self.itemIcon:setScale(0.76, 0.76);
    end
    self.itemIcon:showNum(0);
    if self.trial_state == true then
        self.showState = false;
    end
    self:showRedPoint(self.showState);
end

function Lua_HeroEquipItem:showRedPoint(bShow)
    if bShow then
        if self.redPointIcon == nil then
            self.redPointIcon = Lua_RedPointIcon.new(self.content);
            self.redPointIcon:setLocation(40, 40);
            self.redPointIcon:createRedPointEff();
        end
        self.redPointIcon:updateRedPointShow(true);
    else
        if self.redPointIcon ~= nil then
            self.redPointIcon:updateRedPointShow(false);
        end
    end
end

function Lua_HeroEquipItem:onIconBtnClick()
    if self.typeof == 1 then
        if self.evo ~= nil then
            Lua_WindowUtil.openWin("Lua_EquipTipsWindow", Lua_WinParam.ACTION_OPEN, {data = self.evo, isShowBtns = false});
        end
        return
    end

    if self.isUnlock == false then--未解锁
        local info = DataCenter.equipUtil:getEquipPartConfigInfo(self.part);
        if info.unlock_lvl > self.hvo_level then
            OperateAlert.show(LanUtil.formateStr(126713, tostring(info.unlock_lvl)));
        end
        local unlock_star = DataCenter.heroUtil:getHeroAwakenStarByQuality(info.unlock_quality, info.unlock_star);
        if unlock_star > self.hvo_star then
            OperateAlert.show(LanUtil.formateStr(126739, tostring(info.unlock_des)));
        end
        return
    end
    
	if self.evo == nil then
        if self.trial_state then
            OperateAlert.showLangValue(126797);
            return;
        end
        Lua_WindowUtil.openWin("Lua_EquipChangeWindow", Lua_WinParam.ACTION_OPEN, {part = self.part, hero_uid = self.hero_uid});
	else
        Lua_WindowUtil.openWin("Lua_EquipTipsWindow", Lua_WinParam.ACTION_OPEN, {data = self.evo, isShowBtns = self.trial_state ~= true});
	end
end

function Lua_HeroEquipItem:dispose()
    self.hvo = nil;
    self.evo = nil;
    if self.redPointIcon ~= nil then
        self.redPointIcon:dispose();
        self.redPointIcon = nil;
    end
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    self:superCall("dispose");
end