--装备
checkRequire("Lua_HeroRunesItem");
checkRequire("Lua_HeroEquipItem");
-- checkRequire("Lua_HeroTalentItem");
checkRequire("Lua_HeroTrialTipItem");
Lua_HeroEquipPanel = class("Lua_HeroEquipPanel", Lua_DisplayObject);
function Lua_HeroEquipPanel:ctor(p)
    self:superCall("ctor", p,"HeroEquipPanel_skin");
end

function Lua_HeroEquipPanel:buildShowItem()
	self:superCall("buildShowItem");
	self.showSunesArr = Array();
	local item;
	local pos = {{-232,469},{233,469}}
	for i=1,2 do
		item = Lua_HeroRunesItem.new(self.content);
		item:setRectAnchor(7);
		item.part = i;
		item:setLocation(pos[i][1], pos[i][2], 0);
		self.showSunesArr:add(item);
	end
	
	pos = {{-280,332},{-96.5,306},{92.5,306},{278,332}}
	self.showEquipArr = Array();
	for i=1,4 do
		item = Lua_HeroEquipItem.new(self.content);
		item:setRectAnchor(7);
		item:setLocation(pos[i][1], pos[i][2], 0);
		self.showEquipArr:add(item);
	end

	self.worn_btn:addClickFuntion(self, self.onWornBtnClick);
	self.master_btn:addClickFuntion(self, self.onMasterBtnClick);
    self.demount_btn:addClickFuntion(self, self.onDemountBtnClick);
end

function Lua_HeroEquipPanel:updateHeroPanelInfo(hvo)
	if self.hvo ~= nil and self.hvo.unique_id ~= hvo.unique_id then
		self.tag_activate_lvl = nil;
	end
    self.hvo = hvo;
    self.master_btn:setEnable(not hvo.trial_state);
    self.level_txt:setEnable(not hvo.trial_state);

    local equip_red = false;
    local list = hvo.equipInfo;
    for i=1,self.showEquipArr:getSize() do
    	self.showEquipArr[i]:setParams(i, hvo.level, hvo.star, hvo.unique_id, hvo.trial_state);

    	if hvo.trial_state then
    		self.showEquipArr[i]:setData(hvo.equipTipsInfo[i]);
    	else
    		self.showEquipArr[i]:setData(list[i]);
    		if self.showEquipArr[i].redDotState == true then
    			equip_red = true;
    		end
    	end
    end

    local list = hvo.runsInfo;
    if hvo.trial_state then
    	list = hvo.runsTipsInfo;
    end
    for i=1,self.showSunesArr:getSize() do
    	self.showSunesArr[i]:setData(list[i], hvo);
    end

    self.demount_btn:setEnable(not hvo.trial_state);
    self.worn_btn:setEnable(not hvo.trial_state);
    self:showTrialTipItem(hvo.trial_state);

    self:showWornRedDot(equip_red and (not hvo.trial_state));--一键穿戴红点

	local master_lvl = DataCenter.equipUtil:getEquipMasterLevelByHeroUid(hvo.unique_id);
	self.level_txt.text = "+"..master_lvl;

	local activate_lvl = DataCenter.equipUtil:getMasterActivateIdByMasterLevel(master_lvl);
	if self.tag_activate_lvl == nil then
		self.tag_activate_lvl = activate_lvl;
	else
		if activate_lvl > self.tag_activate_lvl then--强化大师激活等级提高
			local arr = DataCenter.equipUtil:getStrongMasterProp(activate_lvl);
            Lua_WindowUtil.openWin("Lua_EquipMasterActivateWindow", Lua_WinParam.ACTION_OPEN, {attr_info = arr, activate_level = activate_lvl});
		end
		self.tag_activate_lvl = activate_lvl;
	end
end

--一键穿戴红点
function Lua_HeroEquipPanel:showWornRedDot(val)
    if val == true then
        if self.redDotIcon == nil then
            self.redDotIcon = Lua_RedPointIcon.new(self.content);
            self.redDotIcon:setRectAnchor(7);
            self.redDotIcon:setLocation(266, 195, 0);
            self.redDotIcon:createRedPointImg(nil);
        end
        self.redDotIcon:updateRedPointShow(true);
    else
        if self.redDotIcon ~= nil then
            self.redDotIcon:updateRedPointShow(false);
        end
    end
end

--显示试用英雄提示Item
function Lua_HeroEquipPanel:showTrialTipItem(val)
    if val then 
        if self.trialTipItem == nil then
            self.trialTipItem = Lua_HeroTrialTipItem.new(self.content,2);
            self.trialTipItem:setRectAnchor(7);
            self.trialTipItem:setLocation(0, 187, 0);
        end
        self.trialTipItem:setData(self.hvo);
        self.trialTipItem:setEnable(true);
    else
        if self.trialTipItem ~= nil then
            self.trialTipItem:setData(nil);
            self.trialTipItem:setEnable(false);
        end
   end
end

--一键穿戴
function Lua_HeroEquipPanel:onWornBtnClick()
	local isWornEruip = #self.hvo.equip_info == 0;
	local arr = DataCenter.packData:getItemArrByPackType(Lua_PackDefine.TYPE_EQUIP);--装备背包数据
	if isWornEruip == true and arr:getSize() == 0 then
		OperateAlert.showLangValue(126716);--暂无可穿戴装备
		return
	end

	Lua_ProxyManager.getProxy("Lua_EquipProxy"):sEquipChange(self.hvo.unique_id, 1); -- 一键穿戴
end

--一键卸下
function Lua_HeroEquipPanel:onDemountBtnClick()
	local isWornEruip = #self.hvo.equip_info == 0;
	if isWornEruip == true then
		OperateAlert.showLangValue(126715);
		return
	end
	Lua_ProxyManager.getProxy("Lua_EquipProxy"):sEquipChange(self.hvo.unique_id,2); -- 一键卸下
end

--强化大师
function Lua_HeroEquipPanel:onMasterBtnClick()
	Lua_WindowUtil.openWin("Lua_EquipStrongMasterWindow", Lua_WinParam.ACTION_OPEN, {unique_id = self.hvo.unique_id, select_type = 1});
end

function Lua_HeroEquipPanel:dispose()
	if self.showEquipArr ~= nil then
		self.showEquipArr:dispose();
		self.showEquipArr:clear();
		self.showEquipArr = nil;
	end
	if self.showSunesArr ~= nil then
		self.showSunesArr:dispose();
		self.showSunesArr:clear();
		self.showSunesArr = nil;
	end
	if self.showTalentArr ~= nil then
		self.showTalentArr:dispose();
		self.showTalentArr:clear();
		self.showTalentArr = nil;
	end

	if self.redDotIcon ~= nil then
        self.redDotIcon:dispose();
        self.redDotIcon = nil;
    end
	self:superCall("dispose");
end