-- 符文展示item
Lua_HeroRunesItem = class("Lua_HeroRunesItem", Lua_DisplayObject); 
function Lua_HeroRunesItem:ctor(p, typeof)
    self.typeof = typeof;--英雄tips特殊设置
    self:superCall("ctor", p);
end

function Lua_HeroRunesItem:buildShowItem()
    self:superCall("buildShowItem");
    self.bg_spr = UICreate.createUIAtlasImage(self.content, "hero_develop_altas", "xui_hb_widget_2", 0, 0, 0, 0);
    self.maxk_spr = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
    self.lock_spr = UICreate.createUIAtlasImage(self.content, "hero_develop_altas","xui_hb_tab_5", 0, 0, 0, 0);
    self.lock_spr:setEnable(false);

    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.bg_spr:addClickFuntion(self, self.onIconBtnClick);

    if self.typeof == 1 then
        self.bg_spr:SetDimensions(112, 112);
    elseif self.typeof == 2 then
        self.bg_spr:setAltas("hero_develop_altas", "xui_hb_widget_19");
        self.bg_spr:resetSize();
        self.maxk_spr:setAltas("hero_develop_altas", "xui_hb_button_19");
        self.maxk_spr:resetSize();
    end
end

function Lua_HeroRunesItem.Set:part(val)
    self._part = val;
end

function Lua_HeroRunesItem:setData(param, hvo)
    self.hvo = hvo;
    if type(param) == "number" or param == nil then
        self.data = DataCenter.runesData:getRunesVoByUid(param);
    elseif type(param) == "table" then
        self.data = param;
    elseif param == nil then
        self.data = nil;
    end
    
    self.isUnlock = DataCenter.runesUtil:RunesPartUnlock(self._part, hvo.level, hvo.star);
    if self.data ~= nil then
        self.itemIcon:setData(self.data);
        self.itemIcon:showNum(0);
        self.itemIcon:setEnable(true);
        self.itemIcon:setShadow(false);
    else
        self.itemIcon:setEnable(false);
        self.lock_spr:setEnable(not self.isUnlock);
    end

    if self.typeof == nil then
        self.itemIcon:setScale(0.7,0.7);
        self.maxk_spr:setAltas("common_atlas_4", "ui_zb_icon_02");
        self.redPointState = DataCenter.runesData:checkPartRedDotState(self._part, hvo) and self.isUnlock;
        self:showRedPoint(self.redPointState and not self.hvo.trial_state);
    elseif self.typeof == 1 then
        self.redPointState = nil;
        self.itemIcon:setScale(0.9,0.9);
        self.maxk_spr:setAltas("rune_atlas", "xui_fs_widget_13");
        self.itemIcon:setCanClick(self.data ~= nil);
    elseif self.typeof == 2 then
        if self.data ~= nil then
            self.itemIcon:setIconBg("hero_develop_altas", "xui_hb_widget_2"..(self.data.color - 1));
        end
        self.redPointState = DataCenter.runesData:checkPartRedDotState(self._part, hvo) and self.isUnlock;
        self:showRedPoint(self.redPointState and not self.hvo.trial_state);
        self.maxk_spr:setEnable(self.isUnlock)
    end
end

function Lua_HeroRunesItem:showRedPoint(bShow)
    if bShow then
        if self.redPointIcon == nil then
            self.redPointIcon = Lua_RedPointIcon.new(self.content);
            self.redPointIcon:setLocation(35, 35);
            self.redPointIcon:createRedPointEff();
        end
        self.redPointIcon:updateRedPointShow(true);
    else
        if self.redPointIcon ~= nil then
            self.redPointIcon:updateRedPointShow(false);
        end
    end
end

function Lua_HeroRunesItem:onIconBtnClick()
    if self.typeof == 1 then
        if self.data ~= nil then
            Lua_WindowUtil.openWin("Lua_RunesTipsWindow", Lua_WinParam.ACTION_OPEN, {part = self._part, hero_uid = self.hvo.unique_id, data = self.data, isShowBtns = false});
        end
        return
    end

    if self.isUnlock == false then
        local info = DataCenter.runesUtil:getRunesPartConfigInfo(self._part);
        local limit_star = DataCenter.heroUtil:getHeroAwakenStarByQuality(info.unlock_quality, info.unlock_star);
        if info.unlock_lvl > self.hvo.level or limit_star > self.hvo.star then
            if self._part == 1 then
                OperateAlert.show(LanUtil.formateStr(126854, tostring(info.unlock_lvl)));
            else
                OperateAlert.show(LanUtil.formateStr(126855, tostring(info.unlock_lvl), tostring(info.unlock_des)));
            end
        end
        return
    end
    
	if self.data == nil then
        if self.hvo.trial_state then
            OperateAlert.showLangValue(126851);
            return;
        end
        Lua_WindowUtil.openWin("Lua_RunesChangeWindow", Lua_WinParam.ACTION_OPEN, {part = self._part, hero_uid = self.hvo.unique_id});
	else
        if self.hvo.trial_state then
            Lua_WindowUtil.openWin("Lua_RunesTipsWindow", Lua_WinParam.ACTION_OPEN, {part = self._part, hero_uid = self.hvo.unique_id, data = self.data, isShowBtns = false});
            return;
        end
        Lua_WindowUtil.openWin("Lua_RunesTipsWindow", Lua_WinParam.ACTION_OPEN, {part = self._part, hero_uid = self.hvo.unique_id, data = self.data, isShowBtns = true, bShowRed = self.redPointState});
	end
end

function Lua_HeroRunesItem:dispose()
    self.bootom_bg = nil;
    if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    if self.redPointIcon ~= nil then
        self.redPointIcon:dispose();
        self.redPointIcon = nil;
    end
    self.hvo = nil;
    self.data = nil;
    self:superCall("dispose");
end