-- 战技展示item
Lua_HeroTalentItem = class("Lua_HeroTalentItem", Lua_DisplayObject); 
function Lua_HeroTalentItem:ctor(p,typeof)
    self.typeof = typeof;--英雄tips特殊设置
    self:superCall("ctor", p,"HeroTalentItem_skin");
end

function Lua_HeroTalentItem:buildShowItem()
    self:superCall("buildShowItem");

    self.skill_bg:addClickFuntion(self, self.onIconBtnClick);
    self.lock:setEnable(false);
end

function Lua_HeroTalentItem.Set:part(val)
    self._part = val;
end

function Lua_HeroTalentItem:setData(talent_id, hvo)
    self.hvo = hvo;
    local showState = false;
    if talent_id ~= 0 then
        self.level:setEnable(true);
        self.lvl_bg:setEnable(true);
        self.skill_icon:setEnable(true);

        self.data = Lua_TalentConfigData.getConfigData(talent_id);
        self.level.text = self.data.level;
        local skill_vo = self.data.skill_vo;
        self.skill_icon:setAltas(skill_vo.atlas, skill_vo.sprite);
        if self.typeof == nil then
            showState = DataCenter.talentData:talentUpgradeRedDot(talent_id);
        end
    else
        self.data = nil;
        self.level:setEnable(false);
        self.lvl_bg:setEnable(false);
        self.skill_icon:setEnable(false);
        if self.typeof == nil then
            showState = DataCenter.talentData:getTalentStudyRedDot(hvo.unique_id, self._part);
        end
    end

    if self.typeof == 1 then
        self.skill_bg.clickScale = self.data~=nil;
    end
    
    self.isUnlock = DataCenter.talentUtil:talentPartUnlock(self._part, hvo.level, hvo.star);
    self.lock:setEnable(not (self.isUnlock));
    self.show_mash:setEnable(self.isUnlock);
    self:showRedDot(showState);
end

--红点
function Lua_HeroTalentItem:showRedDot(val)
    if val == true then
        if self.redDotIcon == nil then
            self.redDotIcon = Lua_RedPointIcon.new(self.content);
            self.redDotIcon:setLocation(50, 43, 0);
            self.redDotIcon:createRedPointImg(nil);
        end
        self.redDotIcon:updateRedPointShow(true);
    else
        if self.redDotIcon ~= nil then
            self.redDotIcon:updateRedPointShow(false);
        end
    end
end

function Lua_HeroTalentItem:onIconBtnClick()
    if self.typeof == 1 then
        if self.data ~= nil then
            Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, self.data.skill_vo);
        end
        return
    end

    if self.hvo.trial_state then
        OperateAlert.show(126797);
        return;
    end
        
    if self.isUnlock == false then
        local info = DataCenter.talentUtil:getTalentPartInfo(self._part);
        if info.unlock_lvl > self.hvo.level then
            OperateAlert.show(LanUtil.formateStr(126868, tostring(info.unlock_lvl)));
        end
        if info.unlock_star > self.hvo.star then
            OperateAlert.show(LanUtil.formateStr(126869, tostring(info.unlock_star)));
        end
        return
    end

	if self.data == nil then
        Lua_WindowUtil.openWin("Lua_TalentStudyWindow", Lua_WinParam.ACTION_OPEN, {part = self._part, hvo = self.hvo});
    else
        Lua_WindowUtil.openWin("Lua_TalentUpgradeWindow", Lua_WinParam.ACTION_OPEN, {part = self._part,talent_id = self.data.id, hero_uid = self.hvo.unique_id});
    end
end

function Lua_HeroTalentItem:dispose()
    self.hvo = nil;
    self.data = nil;
    if self.redDotIcon ~= nil then
        self.redDotIcon:dispose();
        self.redDotIcon = nil;
    end
    self:superCall("dispose");
end