Lua_HeroFashionActivateWindow = class("Lua_HeroFashionActivateWindow", Lua_Window)
function Lua_HeroFashionActivateWindow:ctor()
	self:superCall("ctor");
	
	self.windowName = "Lua_HeroFashionActivateWindow";
	self.skinName = "HeroFashionActivateWindow_skin";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
end

function Lua_HeroFashionActivateWindow:buildShowItem()
	self:superCall("buildShowItem");
	self:addLuaEvent("HERO_FASHION_ACTIVATE_SELECT", self, self.onSelected);

	local width = Mathf.Ceil(124 * 0.86);
	self.itemList = Lua_DragList.new(self.content, 595, 370, Lua_AxisDefine.Vertical);
	self.itemList:setLocation(0, 56, 0);
	self.itemList:setListCell(Lua_HeroFashionActivateItem, width, width, 5);
	self.itemList:setCellSpacing(15, 15);

	self.btnCancel:addClickFuntion(self, self.hide);
	self.btnConfirm:addClickFuntion(self, self.onConfirm);
end

function Lua_HeroFashionActivateWindow:dispose()
	DataCenter.heroFashionData.activateMaterial = nil;
	self:superCall("dispose");
end

function Lua_HeroFashionActivateWindow:showWin(param)
	self:superCall("showWin", param);
	self.itemList:setArrayData(param);
end

function Lua_HeroFashionActivateWindow:onSelected(data)
	DataCenter.heroFashionData.activateMaterial = data;
	self.itemList:updateShowList();
end

function Lua_HeroFashionActivateWindow:onConfirm(go)
	local uniqueId = DataCenter.heroFashionData.activateMaterial;
	if uniqueId == nil then
		OperateAlert.showLangValue(126516);
		return;
	end
	Lua_MsgUtil.callFunc("HERO_FASHION_ACTIVATE", uniqueId);
end










Lua_HeroFashionActivateItem = class("Lua_HeroFashionActivateItem", Lua_ListCell)
function Lua_HeroFashionActivateItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setScale(0.86, 0.86, 1);
end

function Lua_HeroFashionActivateItem:dispose()
	self.selectedUid = nil;
	self.data = nil;
	self:superCall("dispose");
end

function Lua_HeroFashionActivateItem:setCustomParam(customParam)
	self.selectedUid = customParam;
end

function Lua_HeroFashionActivateItem:setData(data)
	self.data = data;
	local vo = DataCenter.packData:getItemVoByUnId(data);
	self.itemIcon:setData(vo);
	self:updateData();
end

function Lua_HeroFashionActivateItem:updateData()
	self.itemIcon:setDrawMask(self.data == DataCenter.heroFashionData.activateMaterial);
end

function Lua_HeroFashionActivateItem:onPressClick(go)
	Lua_MsgUtil.callFunc("HERO_FASHION_ACTIVATE_SELECT", self.data);
end