-- 英雄天赋
Lua_HeroGeniusOverviewWindow = class("Lua_HeroGeniusOverviewWindow", Lua_Window)
function Lua_HeroGeniusOverviewWindow:ctor()
	self:superCall("ctor");
	
	self.windowName = "Lua_HeroGeniusOverviewWindow";
	self.skinName = "HeroGeniusOverviewWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_HeroGeniusOverviewWindow:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_HeroGeniusOverviewWindow:dispose()
	if self.itemList then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroGeniusOverviewWindow:showWin(param)
	self:superCall("showWin", param);

	local heroVo = DataCenter.heroData:getItemByUniqueId(param);
	local arr = DataCenter.heroGeniusData:getHeroGeniusList(heroVo.id);
	if self.itemList == nil then
		self.itemList = Lua_DragList.new(self.content, 604, 656, Lua_AxisDefine.Vertical);
		self.itemList:setLocation(0, -6, 0);
		self.itemList:setListCell(Lua_HeroGeniusOverviewItem, 604, 162, 1);
		self.itemList:setCellSpacing(0, 2);
		self.itemList.tweenId = 2002;
	end
	self.itemList.customParam = param;
	self.itemList:setArrayData(arr);
	self.itemList.canDrag = not self.itemList.isTheEnd;
end










Lua_HeroGeniusOverviewItem = class("Lua_HeroGeniusOverviewItem", Lua_ListCell)
function Lua_HeroGeniusOverviewItem:ctor(p)
	self:superCall("ctor", p, "HeroGeniusOverviewItem_skin");
end

function Lua_HeroGeniusOverviewItem:buildShowItem()
	self:superCall("buildShowItem");
	self.icon:addClickFuntion(self, self.onCheckDetails);
	self.checkDetails:addClickFuntion(self, self.onCheckDetails);
end

function Lua_HeroGeniusOverviewItem:dispose()
	self.heroUid = nil;
	self:superCall("dispose");
end

function Lua_HeroGeniusOverviewItem:setCustomParam(customParam)
	self.heroUid = customParam;
end

function Lua_HeroGeniusOverviewItem:setData(geniusId)
	self.icon.mouseEnable = false;
	self.nameText:setLocation(-133, 0, 0);
	self.line:setEnable(false);
	self.desText:setEnable(false);
	self.checkDetails:setEnable(false);

	local data = DataCenter.heroGeniusData:getGeniusConfig(geniusId);
	local heroVo = DataCenter.heroData:getItemByUniqueId(self.heroUid);
	self.skillId = DataCenter.heroGeniusData:getHeroGeniusSkill(heroVo.unique_id, data.talent_lvl);
	local bUnlock = DataCenter.heroGeniusData:checkGeniusLvIsUnlock(data.talent_lvl, heroVo.star);
	if bUnlock then
		-- 已解锁
		if heroVo.geniusLv >= data.talent_lvl then
			-- 已激活
			if self.skillId == 0 then
				self.icon:setAltas("hero_genius_atlas", "xui_tf_button_2");
				self.icon:SetDimensions(44, 45);
				self.nameText:setLangValue(126097);
			else
				local skillCfg = Lua_SkillConfigData.getConfigData(self.skillId);
				self.icon:setAltas(skillCfg.atlas, skillCfg.sprite);
				self.icon:SetDimensions(92, 92);
				self.icon.mouseEnable = true;

				self.nameText:setLocation(-133, 53, 0);
				self.nameText.text = skillCfg.name;
				self.line:setEnable(true);
				self.desText:setEnable(true);
				self.desText.verticalOverflowValue = 1;
				self.desText.text = skillCfg.des;
				self.desText:resetSize();
				if self.desText.height > 87 then
					self.desText:SetDimensions(400, 87);
					self.desText.verticalOverflowValue = 0;
					self.checkDetails:setEnable(true);
				else
					self.checkDetails:setEnable(false);
				end
			end
		else
			self.icon:setAltas("hero_genius_atlas", "xui_tf_button_3");
			self.icon:SetDimensions(95, 47);
			self.nameText:setLangValue(126096);
		end
	else
		self.icon:setAltas("hero_genius_atlas", "xui_tf_label_1");
		self.icon:SetDimensions(76, 75);
		local str = DataCenter.heroGeniusData:getGeniusLvUnlockLabel(data.talent_lvl);
		self.nameText.text = LanUtil.formateStr(126091, str);
	end
end

function Lua_HeroGeniusOverviewItem:onCheckDetails(go)
	if self.skillId == nil or self.skillId == 0 then
		return;
	end
	Lua_WindowUtil.openWin("Lua_SkillTipsWindow", Lua_WinParam.ACTION_OPEN, self.skillId);
end