--层级筛选
Lua_HeroHeatFloorSelectWindow = class("Lua_HeroHeatFloorSelectWindow", Lua_Window);
function Lua_HeroHeatFloorSelectWindow:ctor()
	self:superCall("ctor");
	self.blackAlpha = 0.1;
	self.isClickClose = true;
	self.showBlackMask = true;
	self.isFullSizeWin = true;
	self.winBgAtlas = "hero_heat_atlas";
	self.winBgSprite = "xui_rdb_widget_5";
	self.windowName = "Lua_HeroHeatFloorSelectWindow";
end

function Lua_HeroHeatFloorSelectWindow:buildShowItem()
	self:superCall("buildShowItem")
	self.bg_spr = UICreate.createUIAtlasImage(self.content, "hero_heat_atlas", "xui_rdb_widget_5", -221, 307 + self.adaptHeight/2, 233, 166);

	self.selectList = Lua_DragList.new(self.content, 224, 156, Lua_AxisDefine.Vertical)
	self.selectList:setLocation(-221, 307 + self.adaptHeight/2, 0)
	self.selectList.tweenId = 2004
	self.selectList:setListCell(Lua_HeroHeatFloorSelectCell, 224, 50, 1)
	self.selectList:setCellSpacing(0, 3);

	self:addLuaEvent("FLOOR_LELECT_SINGLE", self, self.onFloorSelected)
end

-- selectFloor --当前选择的索引  -- rank_id  
function Lua_HeroHeatFloorSelectWindow:showWin(param)
	self:superCall("showWin", param)
	local selectFloor = param.selectFloor;
	local data = DataCenter.heroHeatUtil:getHeatRankDataById(param.rank_id);
	local list = data.tower_arr_value;
	local arr = Array();
	for k,v in pairs(list) do
		arr:add({index = tonumber(k), selectIndex = selectFloor, min = v[1], max = v[2]})
	end
	arr:sort("index",false);
	self.selectList:setArrayData(arr)
end

function Lua_HeroHeatFloorSelectWindow:onFloorSelected(selectFloor)
	Lua_MsgUtil.callFunc("ON_HEAT_FLOOR_SELECT", selectFloor)
	self:hide()
end

function Lua_HeroHeatFloorSelectWindow:onScreenResize()
    self:superCall("onScreenResize");
    self.bg_spr:setLocation(-221, 307 + self.adaptHeight/2);
	self.selectList:setLocation(-221, 307 + self.adaptHeight/2, 0)
end

function Lua_HeroHeatFloorSelectWindow:dispose()
	Lua_MsgUtil.callFunc("ON_HEAT_FLOOR_SELECT_CLOSE")
	if self.selectList then
		self.selectList:dispose()
		self.selectList = nil
	end
	self:superCall("dispose")
end


















Lua_HeroHeatFloorSelectCell = class("Lua_HeroHeatFloorSelectCell", Lua_ListCell)
function Lua_HeroHeatFloorSelectCell:ctor(p)
	self:superCall("ctor", p)
end

function Lua_HeroHeatFloorSelectCell:buildShowItem()
	self:superCall("buildShowItem")
	self.bg_spr = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_edit_002", 0, 0, 224, 50)
	self.select_bg = UICreate.createUIAtlasImage(self.content, "hero_heat_atlas", "xui_rdb_widget_6", 88, 0, 34, 34);

	self.select_spr = UICreate.createUIAtlasImage(self.content, "equipcopy_atlas_1", "xui_jmd_widget_31", 89, 0, 39, 33);
	self.select_spr:setEnable(false);

	self.name_txt = UICreate.createLabel(self.content, nil, -98, 0, 150, 31, 26)
	self.name_txt.pivot = UIUtils.Pivot.Left;
    self.name_txt.alignmentValue = 3;
	self.name_txt.colorStr = Lua_ColorDefine.transColor("7A6A5E")
end

function Lua_HeroHeatFloorSelectCell:setData(data)
	self.data = data;
	self.select_spr:setEnable(data.index == data.selectIndex);

	local des;
	if data.mix == 0 then
		des = LanUtil.getValue(126354);
	elseif data.max == 0 then
		des = LanUtil.formateStr(126356, data.min);
	else
		des = LanUtil.formateStr(126355, data.min.."~"..data.max);
	end

	self.name_txt.text = des;
end

function Lua_HeroHeatFloorSelectCell:onPressClick()
	Lua_MsgUtil.callFunc("FLOOR_LELECT_SINGLE", self.data.index)
end

function Lua_HeroHeatFloorSelectCell:dispose()
	self.data = nil;
	self.bg_spr = nil;
	self.name_txt = nil;
	self:superCall("dispose")
end