--英雄热度
Lua_HeroHeatPanel = class("Lua_HeroHeatPanel", Lua_DisplayObject);
function Lua_HeroHeatPanel:ctor(p)
    self:superCall("ctor", p);
end

function Lua_HeroHeatPanel:buildShowItem()
    self:superCall("buildShowItem");
    self.dragList = Lua_DragList.new(self.content,706, 858 + self.adaptHeight, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_HeroHeatCell, 706, 195, 1);
    self.dragList:setCellSpacing(5, 8);
    self.dragList:setLocation(0, -63);
    self.dragList.tweenId = 2011;
    
    self:updateHeatInfo();
    self:addLuaEvent("HERO_HEAT_RANK_RED", self, self.updateHeatInfo);
end

function Lua_HeroHeatPanel:updateHeatInfo()
	local arr = DataCenter.heroHeatUtil.fristTabArr;
    self.dragList:setArrayData(arr);
end

function Lua_HeroHeatPanel:updateShow()
    self.dragList.showTween = true;
    self:updateHeatInfo();
end

function Lua_HeroHeatPanel:onScreenResize(adaptHeight)
    if self.adaptHeight ~= adaptHeight then
        self:superCall("onScreenResize", adaptHeight);
        self.dragList:setContentRect(706, 858 + adaptHeight,false);
    end
end

function Lua_HeroHeatPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
    self:superCall("dispose");
end























Lua_HeroHeatCell = class("Lua_HeroHeatCell", Lua_ListCell);
function Lua_HeroHeatCell:ctor(p)
    self:superCall("ctor", p,"HeroHeatCell_skin");
end

function Lua_HeroHeatCell:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_HeroHeatCell:setData(rank_id)
	self.data = DataCenter.heroHeatUtil:getHeatRankDataById(rank_id);
	if self.data == nil then
		return;
	end
	local bOpenState = DataCenter.funcOpenData:isOpened(self.data.fun_id, false);
	self.bg_image:setGray(not bOpenState);
	self.bg_image:setUrl("/images/hero/"..self.data.first_path);
    self.name_txt.text = self.data.rank_name;

    local bHeatRedState = DataCenter.heroHeatData.bHeatRedState;
    self:showRedPoint(bHeatRedState);
end

function Lua_HeroHeatCell:onPressClick()
	if DataCenter.funcOpenData:isOpened(self.data.fun_id, true) then
		Lua_WindowUtil.openWin("Lua_HeroHeatRankWindow", Lua_WinParam.ACTION_OPEN, self.data.id);
	end
end

function Lua_HeroHeatCell:showRedPoint(bShow)
    if bShow then
        if self.redPointIcon == nil then
            self.redPointIcon = Lua_RedPointIcon.new(self.content);
            self.redPointIcon:setLocation(7, 35);
            self.redPointIcon:createRedPointEff();
        end
        self.redPointIcon:updateRedPointShow(true);
    else
        if self.redPointIcon ~= nil then
            self.redPointIcon:updateRedPointShow(false);
        end
    end
end

function Lua_HeroHeatCell:dispose()
	self.data = nil;
	self:superCall("dispose");
end