--英雄热度榜三级页签panel(通天塔)
checkRequire("Lua_HeroHeatRankItemCell");
checkRequire("Lua_HeroHeatRankLineupCell");
checkRequire("Lua_HeroHeatRankBasePanel")
Lua_HeroHeatRankThreePanel = class("Lua_HeroHeatRankThreePanel", Lua_HeroHeatRankBasePanel);
function Lua_HeroHeatRankThreePanel:ctor(p)
    self:superCall("ctor", p);
end

function Lua_HeroHeatRankThreePanel:buildShowItem()
    self:superCall("buildShowItem");
    self.selectCamp = nil; --选择的种族
    self.selectFloor = 0;--选择的层数
    self.bSelected = false;--是否点击筛选

    self.select_bg = UICreate.createUIAtlasImage(self.content, "hero_heat_atlas", "xui_rdb_toggle_1_b", -221, -310, 248, 52);
    self.select_bg:addClickFuntion(self, self.onSelectBtnClick);
    self.select_bg:setAnchorMax(0.5,1);
    self.select_bg:setAnchorMin(0.5,1);

    self.arrow_spr = UICreate.createUIAtlasImage(self.content, "video_atlas", "xui_jmd_widget_09", -132, -310, 34, 26);
    self.arrow_spr:setAnchorMax(0.5,1);
    self.arrow_spr:setAnchorMin(0.5,1);

    self.name_txt = UICreate.createLabel(self.content, nil, -322, -309, 200, 40, 24);
    self.name_txt.pivot = UIUtils.Pivot.Left;
    self.name_txt.alignmentValue = 3;
    self.name_txt:setAnchorMax(0.5,1);
    self.name_txt:setAnchorMin(0.5,1);

    self.line_spr = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_line_002", 0, 201, 693, 14);
    self.line_spr:setEnable(false);
    self.line_spr:setAnchorMax(0.5,0);
    self.line_spr:setAnchorMin(0.5,0);

    self.left_spr = UICreate.createUIAtlasImage(self.content, "hero_heat_atlas", "xui_rdb_button_1", -316, 154, 0, 0);
    self.left_spr:addClickFuntion(self, self.onLeftBtnClick);
    self.left_spr:setAnchorMax(0.5,0);
    self.left_spr:setAnchorMin(0.5,0);

    self.right_spr = UICreate.createUIAtlasImage(self.content, "hero_heat_atlas", "xui_rdb_button_1", 316, 154, 0, 0);
    self.right_spr:addClickFuntion(self, self.onRightBtnClick);
    self.right_spr:setScale(-1,1,1);
    self.right_spr:setAnchorMax(0.5,0);
    self.right_spr:setAnchorMin(0.5,0);

    self.tabList = Lua_DragList.new(self.content, 570, 56, Lua_AxisDefine.Horizontal);
    self.tabList:setListCell(Lua_HeroHeatThreeTabCell, 165, 56, 1);
    self.tabList:setCellSpacing(5, 0);
    self.tabList:setLocation(0, 154, 0);
    self.tabList:setRectAnchor(7);

    self:addLuaEvent("ON_HEAT_FLOOR_SELECT", self, self.updateFloor);
    self:addLuaEvent("ON_HEAT_FLOOR_SELECT_CLOSE", self, self.onSelectBtnClick)
   
    self:addLuaEvent("HERO_HEAT_RANK_INFO", self, self.updateHeatRankInfo);-- 更新单榜数据
    self:addLuaEvent("ON_HEAT_RANK_THREE_TAB_CELL", self, self.onTabBtnClick);-- 三级页签按钮
end

function Lua_HeroHeatRankThreePanel:updatePanelInfo(rank_id)
    local data = DataCenter.heroHeatUtil:getHeatRankDataById(rank_id);
    local posY;--列表Y轴
    if data.bCamp == 1 then--有种族筛选
        posY = -53;
        self.dragH = 739;
        self.selectCamp = nil; --选择的种族
        self:showCamp(true);
        self.line_spr:setEnable(true);
    else
        posY = -95;
        self.dragH = 824;
        self:showCamp(false);
        self.selectCamp = Lua_HeroUtil.All_TYPE;
        self.line_spr:setEnable(false);
    end

    if data.first_id == 1 then --英雄榜
        self.dragList:setListCell(Lua_HeroHeatRankItemCell, 686, 125, 1);
        self.dragList:setCellSpacing(0, 6);
        self.dragList:setLocation(0, posY, 0);
    elseif data.first_id == 2 then --阵容榜
        self.dragList:setListCell(Lua_HeroHeatRankLineupCell, 686, 125, 1);
        self.dragList:setCellSpacing(0, 6);
        self.dragList:setLocation(0, posY, 0);
    elseif data.first_id == 3 then --养成榜（待开发）

    end

    self.dragList:setContentRect(686, self.dragH + self.adaptHeight, false);

    local arr = DataCenter.heroHeatUtil:getThreeTabArr(data.first_id, data.second_id);
    self.tabLen = arr:getSize();
    self.tabList:setArrayData(arr);
    self.tabList:setSelected(1);
    self:onTabBtnClick(arr[1]);

    self.bg_spr:SetDimensions(720, 78 + self.dragH + self.adaptHeight);
   
end

-- 三级页签处理
function Lua_HeroHeatRankThreePanel:onTabBtnClick(rank_id)
    if self.selectTabId == rank_id then
        return;
    end
    self.selectTabId = rank_id;

    self.data = DataCenter.heroHeatUtil:getHeatRankDataById(rank_id);
    local select_floor = DataCenter.heroHeatUtil:getFloorIndexByRandId(rank_id);
    self:updateFloor(select_floor, false);
    if self.campSiftPanel ~= nil then
        self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, true);
    end
    self:sendHeatMsg(rank_id, self.selectFloor, self.selectCamp);
end

function Lua_HeroHeatRankThreePanel:updateHeatRankInfo(rank_id)
    if self.data.id ~= rank_id then
        return
    end
    local arr = DataCenter.heroHeatData.heroHeatIdArr;
    self:setShow(arr:getSize() == 0);
    self.dragList:setArrayData(arr);
end

-- 选择层级更新
function Lua_HeroHeatRankThreePanel:updateFloor(select_floor, bMsg)
    self.selectFloor = select_floor;
    local list = self.data.tower_arr_value;
    local mix = list[tostring(select_floor)][1];
    local max = list[tostring(select_floor)][2];
    local des;
    if mix == 0 then
        des = LanUtil.getValue(126354);
    elseif max == 0 then
        des = LanUtil.formateStr(126356, mix);
    else
        des = LanUtil.formateStr(126355, mix.."~"..max);
    end
    self.name_txt.text = des;

    if self.data ~= nil and bMsg ~= false then
        self:sendHeatMsg(self.data.id, self.selectFloor, self.selectCamp);
    end
end

-- 更新筛选状态
function Lua_HeroHeatRankThreePanel:onCampSelected(selectType)
    if self.selectCamp == selectType then
        return;
    end
    self.selectCamp = selectType;
    
    if self.data ~= nil and bool ~= false then
        self:sendHeatMsg(self.data.id, self.selectFloor, self.selectCamp);
    end
end

--种族筛选
function Lua_HeroHeatRankThreePanel:showCamp(bool)
    if not bool then
        return;
    end
    if self.campSiftPanel == nil then
        self.campSiftPanel = Lua_CampSiftPanel.new(self.content);
        self.campSiftPanel:setRectAnchor(7);
        self.campSiftPanel:setLocation(-32, 242, 0);
        self.campSiftPanel:setSiftItem(80);
        self.campSiftPanel:setArrayData(DataCenter.heroUtil.siftAllInfo);
        self.campSiftPanel:setCallBack(self, self.onCampSelected);
    end
    self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, true);
end

function Lua_HeroHeatRankThreePanel:onScreenResize(adaptHeight)
    if self.adaptHeight ~= adaptHeight then
        self:superCall("onScreenResize", adaptHeight);
        self.bg_spr:SetDimensions(720, 78 + self.dragH + adaptHeight);
        self.dragList:setContentRect(686, self.dragH + adaptHeight);
        self.dragList:moveToIndex(1, true);
    end
end

function Lua_HeroHeatRankThreePanel:sendHeatMsg(id, floor, camp)
    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroHeat(id, floor, camp);
end

function Lua_HeroHeatRankThreePanel:onSelectBtnClick(go)
    self.bSelected = not self.bSelected;
    if self.bSelected then
        self.arrow_spr:setScale(1,-1,1);
        Lua_WindowUtil.openWin("Lua_HeroHeatFloorSelectWindow", Lua_WinParam.ACTION_OPEN, { selectFloor = self.selectFloor, rank_id = self.data.id})
    else
        self.arrow_spr:setScale(1,1,1);
        Lua_WindowUtil.openWin("Lua_HeroHeatFloorSelectWindow", Lua_WinParam.ACTION_CLOSE)
    end
end

function Lua_HeroHeatRankThreePanel:onLeftBtnClick(go)
    if self.tabList ~= nil then
        self.tabList:moveToIndex(1);
    end
end

function Lua_HeroHeatRankThreePanel:onRightBtnClick(go)
    if self.tabList ~= nil then
        self.tabList:moveToIndex(self.tabLen);
    end
end

function Lua_HeroHeatRankThreePanel:dispose()
    if self.campSiftPanel ~= nil then
        self.campSiftPanel:dispose();
        self.campSiftPanel = nil;
    end

    if self.tabList ~= nil then
        self.tabList:dispose();
        self.tabList = nil;
    end
    self.select_bg = nil;
    self.arrow_spr = nil;
    self.name_txt = nil;
    self.line_spr = nil;
    self.left_spr = nil;
    self.right_spr = nil;
    self.data = nil;
    self:superCall("dispose");
end

























-- 三级页签
Lua_HeroHeatThreeTabCell = class("Lua_HeroHeatThreeTabCell", Lua_ListCell);
function Lua_HeroHeatThreeTabCell:ctor(p)
    self:superCall("ctor", p, "HeroHeatThreeTabCell_skin");
end

function Lua_HeroHeatThreeTabCell:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_HeroHeatThreeTabCell:setData(rank_id)
    self.data = DataCenter.heroHeatUtil:getHeatRankDataById(rank_id);
    if self.data == nil then
        return
    end
    self.name_txt.text = self.data.tab_name;
    self.bOpenState = DataCenter.funcOpenData:isOpened(self.data.fun_id, false);
    self.bg_spr:setGray(not self.bOpenState);
end

function Lua_HeroHeatThreeTabCell:onSelectionChange(bSelect)
    self:superCall("onSelectionChange",bSelect)
    local color;
    if bSelect and self.bOpenState then
        color = "8f5123";
        self.bg_spr:setAltas("common_altas_1", "xui_common_button_004_n");
    else
        color = "756150";
        self.bg_spr:setAltas("common_altas_1", "xui_common_button_005_n");
    end
    self.name_txt.text = Lua_ColorDefine.getColorStr(color, self.data.tab_name);
end

function Lua_HeroHeatThreeTabCell:onPressClick(go)
    if DataCenter.funcOpenData:isOpened(self.data.fun_id, true) then
        Lua_MsgUtil.callFunc("ON_HEAT_RANK_THREE_TAB_CELL", self.data.id);
    end

    return true;
end

function Lua_HeroHeatThreeTabCell:dispose()
    self.data = nil;
    self:superCall("dispose");
end