--英雄热度榜
Lua_HeroHeatRankWindow = class("Lua_HeroHeatRankWindow", Lua_Window);
function Lua_HeroHeatRankWindow:ctor()
    self:superCall("ctor");
    self.showWinBg = true;
    self.showBackBtn = true;
    self.isFullSizeWin = true;

    self.layer = MainWinDefine.MAIN_MENU_TOP_LAYER;
	self.winBgPath = "/images/common/xui_common_bg_001.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);

    self.windowName = "Lua_HeroHeatRankWindow";
    self.skinName = "HeroHeatRankWindow_skin";
end

function Lua_HeroHeatRankWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.tabList = Lua_DragList.new(self.content, 590, 108, Lua_AxisDefine.Horizontal);
    self.tabList:setListCell(Lua_HeatRankTabCell, 118, 108, 1);
    self.tabList:setRectAnchor(7);
    
    self.help_btn:addClickFuntion(self, self.onHelpClick);
    self:addLuaEvent("ON_HEAT_RANK_TAB_CELL", self, self.onTabBtnClick);-- 页签按钮
end

-- param --heat_rank-热度榜配置 id
function Lua_HeroHeatRankWindow:showWin(param)
    self:superCall("showWin", param);
    local data = DataCenter.heroHeatUtil:getHeatRankDataById(param);
    if data ~= nil then
    	self.name_spr:setAltas("hero_heat_atlas",data.title_spr);
    	local arr = DataCenter.heroHeatUtil:getSecondTabArr(data.first_id);
	    self.tabList:setArrayData(arr);
	    self.tabList.canDrag = arr:getSize() >5;
	    local posX = 655-arr:getSize()*118;
	    if posX < 64 then
	    	posX = 64;
	    end
	    self.tabList:setLocation(posX, 54);
	    self.tabList:setSelected(1);
	    self:onTabBtnClick(arr[1]);
    end
end

-- 页签处理
function Lua_HeroHeatRankWindow:onTabBtnClick(rank_id)
    if self.selectTabId == rank_id then
        return;
    end
    self.selectTabId = rank_id;
    local data = DataCenter.heroHeatUtil:getHeatRankDataById(rank_id);
    self.lang_id = data.lang_id;

    self.title_img:setUrl("/images/hero/"..data.title_path);
    local panelName = data.panel;
    if self.panelName ~= panelName then
        if self.curPanel ~= nil then
            self.curPanel:dispose();
            self.curPanel = nil;
        end
        self.panelName = panelName;
        local showPanel = checkRequire(self.panelName);
        self.curPanel = showPanel.new(self.content);
        self.curPanel:setRectAnchor(9);
    end
    if self.curPanel.updatePanelInfo ~= nil then
    	self.curPanel:updatePanelInfo(rank_id);
    end
    if self.curPanel.updateTween ~= nil then
        self.curPanel:updateTween();
    end
    self.curPanel:onScreenResize(self.adaptHeight);
end

function Lua_HeroHeatRankWindow:onHelpClick()
	local param = { des = LanUtil.getValue(self.lang_id), posX = 177, posY = -239 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, param);
end

function Lua_HeroHeatRankWindow:dispose()
	if self.tabList ~= nil then
		self.tabList:dispose();
		self.tabList = nil;
	end
	if self.curPanel ~= nil then
        self.curPanel:dispose();
        self.curPanel = nil;
    end
    self:superCall("dispose");
end





















-- 页签
Lua_HeatRankTabCell = class("Lua_HeatRankTabCell", Lua_ListCell);
function Lua_HeatRankTabCell:ctor(p)
    self:superCall("ctor", p,"HeatRankTabCell_skin");
end

function Lua_HeatRankTabCell:buildShowItem()
    self:superCall("buildShowItem");
    self.select:setEnable(false);
end

function Lua_HeatRankTabCell:setData(rank_id)
    self.data = DataCenter.heroHeatUtil:getHeatRankDataById(rank_id);
    if self.data == nil then
		return
	end
    self.bOpenState = DataCenter.funcOpenData:isOpened(self.data.fun_id, false);
    self.icon:setGray(not self.bOpenState);
end

function Lua_HeatRankTabCell:onSelectionChange(bSelect)
	self:superCall("onSelectionChange",bSelect)
    if bSelect and self.bOpenState then
        self.icon:setAltas("hero_heat_atlas", self.data.second_spr.."_p");
    else
        if self.bOpenState then
            self.icon:setAltas("hero_heat_atlas", self.data.second_spr.."_n");
        else
            self.icon:setAltas("hero_heat_atlas", self.data.second_spr.."_d");
        end
    end
    self.select:setEnable(bSelect);
end

function Lua_HeatRankTabCell:onPressClick(go)
	if self.data == nil then
		return 
	end
	if DataCenter.funcOpenData:isOpened(self.data.fun_id, true) then
    	Lua_MsgUtil.callFunc("ON_HEAT_RANK_TAB_CELL", self.data.id);
    end

    return true;
end

function Lua_HeatRankTabCell:dispose()
    self.data = nil;
    self:superCall("dispose");
end