-- 英雄升星材料选择
Lua_HeroSelectCostWindow = class("Lua_HeroSelectCostWindow", Lua_Window);
function Lua_HeroSelectCostWindow:ctor()
	self:superCall("ctor");
    self.isClickClose = true;
    self.showBlackMask = true;
	self.windowName = "Lua_HeroSelectCostWindow";
	self.skinName = "HeroSelectCostWindow_skin";
end

function Lua_HeroSelectCostWindow:buildShowItem()
	self:superCall("buildShowItem");
    self.tagSelectHeroDic = {};--记录当前界面选中的英雄
    self:addLuaEvent("UPDATA_SELECT_HERO_ITEM", self, self.updataSelectItemInfo); -- 选择单个英雄返回

	self.dragList = Lua_DragList.new(self.content, 610, 320, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_HeroSelectCostCell, 106, 108, 5);
    self.dragList:setCellSpacing(15, 15);
    self.dragList:setLocation(9, 32);

    self.sub_btn:addClickFuntion(self, self.onSubClick);
    self.select_btn:addClickFuntion(self, self.onAllSelectClick);
    -- self:addLuaEvent("UPDATE_STAR_INFO", self, self.updateSelectCostInfo);
end

-- 英雄展示数据
function Lua_HeroSelectCostWindow:showWin(param)
    self.upStarCostVo = param;
    self.costMaterialsIndex = param.costMaterialsIndex;

    DataCenter.heroUpStarData:initRemoveLineupStateDic(true);
    if self.upStarCostVo.star <= DataCenter.heroUtil.up_star_limit then
        self.sub_btn:setLocation(144, -197, 0);
        self.select_btn:setEnable(true);
    end
    self.costItemsInfo = DataCenter.heroUpStarData:showHeroInfo(param);
    self.dragList:setArrayData(self.costItemsInfo);
    self.tagUidDic, self.tagCostIndexInfo = DataCenter.heroUpStarData:tagInitInfo();--记录初始数据
    self:updateSelectCostNum();
    self:initSelectHero();
end

--初始化一次已选中的英雄-用于确定选中检测时候存在核心英雄
function Lua_HeroSelectCostWindow:initSelectHero()
    for i=1,self.costItemsInfo:getSize() do
        if DataCenter.heroUpStarData:isSelectHeroUidByUid(self.costItemsInfo[i]) == true then
            self.tagSelectHeroDic[self.costItemsInfo[i]] = 1;
        end
    end
end

function Lua_HeroSelectCostWindow:updateSelectCostNum()
    local selectNum = DataCenter.heroUpStarData:getSelectHeroNumByIndex(self.upStarCostVo.costMaterialsIndex);
    self.select_num.text = LanUtil.formateStr(126215, tostring(selectNum), tostring(self.upStarCostVo.needNum));
end

function Lua_HeroSelectCostWindow:updataSelectItemInfo(unique_id) -- 选择道具数据
    self.unique_id = unique_id;
    self.hvo = DataCenter.heroData:getItemByUniqueId(unique_id);
    if DataCenter.heroUpStarData:isSelectHeroUidByUid(unique_id) == true then
        self.tagSelectHeroDic[unique_id] = nil;
        DataCenter.heroUpStarData:delSelectedUidState(self.costMaterialsIndex, unique_id);
        self:updateSelect();
        self:updateSelectCostNum();
    else
        self.tagSelectHeroDic[unique_id] = 1;
        local selectNum = DataCenter.heroUpStarData:getSelectHeroNumByIndex(self.costMaterialsIndex);
        if selectNum == self.upStarCostVo.needNum then
            OperateAlert.showLangValue(126208);
            return;
        else
            self:checkTips();
        end
    end
end

function Lua_HeroSelectCostWindow:checkTips()
    if self.hvo == nil then
        return;
    end

    if self.hvo.isUpLineup and DataCenter.heroUpStarData.removeLineupStateDic[self.unique_id] ~= 1 then --是否显示下阵tips
        self:showHeroLineupTips();
        return;
    end

    if self.hvo.lock_state == true then--上锁tips
        self:showHeroUnlockTips();
        return;
    end

    -- if self.hvo.bcore then --核心tips
    --     self:showBcoreTips();
    --     return
    -- end

    self:onSubBtnClick();
end

--英雄下阵
function Lua_HeroSelectCostWindow:showHeroLineupTips()
    local tipData = { h = 443, font_size = 26, des = LanUtil.formateStr(126221, self.hvo.upLineupName), posY = 44,
        btnType = 1, owner = self, sureFun = self.onHeroLineup };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

--英雄下阵
function Lua_HeroSelectCostWindow:onHeroLineup()
    local bDownLineup;
    local showName;
    bDownLineup, showName = DataCenter.heroUpStarData:checkLineupNumState(self.unique_id);
    if bDownLineup then--是否可以下阵
        OperateAlert.showLangValue(126222);
        DataCenter.heroUpStarData.removeLineupStateDic[self.unique_id] = 1;
    else
        OperateAlert.show(LanUtil.formateStr(126223, showName));
        return
    end
    
    if self.hvo.lock_state == true then--上锁tips
        self:showHeroUnlockTips();
        return;
    end

    -- if self.hvo.bcore then --核心tips
    --     self:showBcoreTips();
    --     return
    -- end

    self:onSubBtnClick();
end

--英雄解锁tips
function Lua_HeroSelectCostWindow:showHeroUnlockTips()
    local tipData = { h = 443, font_size = 26, des = LanUtil.getValue(126219), posY = 44,
        btnType = 1, owner = self, sureFun = self.sendUnlock };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

--英雄解锁
function Lua_HeroSelectCostWindow:sendUnlock()
    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroLock(self.hvo.unique_id, 0);

    -- if self.hvo.bcore then --核心tips
    --     OperateAlert.showLangValue(126224);--提示已解锁
    --     self:showBcoreTips();
    --     return
    -- end

    OperateAlert.showLangValue(126220);
    self:onSubBtnClick();
end

function Lua_HeroSelectCostWindow:updateSelectInfo(unique_id)
    -- print(self.costMaterialsIndex," unique_id = =",unique_id)
    DataCenter.heroUpStarData:addSelectedUidState(self.costMaterialsIndex, unique_id);
end

-- --消耗核心英雄Tips
-- function Lua_HeroSelectCostWindow:showBcoreTips()
--     local tipData = { des = LanUtil.getValue(126207), btnType = 1, owner = self, sureFun = self.onSubBtnClick };
--     Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
-- end

function Lua_HeroSelectCostWindow:onSubBtnClick()
    self:updateSelectInfo(self.unique_id);
    self:updateSelect();
    self:updateSelectCostNum();
end

function Lua_HeroSelectCostWindow:updateSelect()
    if self.dragList ~= nil then
        local arr = self.dragList.showList;
        local len = arr:getSize();
        for i = 1, len do
            arr[i]:updateSelect();
        end
    end
end

function Lua_HeroSelectCostWindow:onAllSelectClick() -- 一键选择
    local selectNum = DataCenter.heroUpStarData:getSelectHeroNumByIndex(self.costMaterialsIndex);
    if selectNum == self.upStarCostVo.needNum then
        OperateAlert.showLangValue(126208);
        return;
    end

    if self.costItemsInfo:getSize() == 0 then
        OperateAlert.showLangValue(126210);
        return;
    end

    if self.dragList ~= nil then
        local length;
        local tagNum = 0;
        local needNum = self.upStarCostVo.needNum - selectNum;
        local list = DataCenter.heroUpStarData.removeLineupStateDic;
        local arr = self.costItemsInfo;
        local len = arr:getSize();
        for i = 1, len do
            local isSeleect = DataCenter.heroUpStarData:isSelectHeroUidByIndex(self.costMaterialsIndex,arr[i]);
            local isSpecialState = false;--是否存在特殊状态，（特殊状态无法被选中）
            length = string.len(arr[i]);
            if length >= 20 then--万能道具
                isSpecialState = false;
            else--英雄
                local hvo = DataCenter.heroData:getItemByUniqueId(arr[i]);
                if hvo ~= nil then
                    isSpecialState = hvo.lock_state or (hvo.isUpLineup and list[arr[i]] == nil);
                end
            end
            if isSeleect == false and isSpecialState == false then
                if tagNum <= needNum then
                    tagNum = tagNum + 1;
                    self:updateSelectInfo(arr[i]);
                    self.tagSelectHeroDic[arr[i]] = 1;
                    if tagNum == needNum then
                        break;
                    end
                end
            end
        end
    end
    self:updateSelect();
    self:updateSelectCostNum();
end

function Lua_HeroSelectCostWindow:onSubClick() -- 确定
    local hvo;
    local bBcore = false;
    for uid, v in pairs(self.tagSelectHeroDic) do
        if v >= 1 then
            hvo = DataCenter.heroData:getItemByUniqueId(uid);
            if hvo.bcore then
                bBcore = true;
            end
        end
    end

    if bBcore then
        self:showAllBcoreTips();
        return;
    end
    
    self:onHideSubClick();
end

function Lua_HeroSelectCostWindow:showAllBcoreTips()
    local tipData = { des = LanUtil.getValue(126207), btnType = 1, owner = self, sureFun = self.onHideSubClick };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

function Lua_HeroSelectCostWindow:onHideSubClick()
    Lua_MsgUtil.callFunc("UPDATA_SELECT_COST_HERO_NUM",self.costMaterialsIndex);
    self:hide();
end

function Lua_HeroSelectCostWindow:onBtnCloseClick(go)
    DataCenter.heroUpStarData:updateTagInitInfo(self.tagUidDic, self.tagCostIndexInfo);
    self:hide();
end

function Lua_HeroSelectCostWindow:onMaskClick(go)
    DataCenter.heroUpStarData:updateTagInitInfo(self.tagUidDic, self.tagCostIndexInfo);
    self:hide();
end


function Lua_HeroSelectCostWindow:dispose()
    if self.dragList ~= nil then
        self.dragList:dispose(); 
        self.dragList = nil;
    end
    self.hvo = nil;
    self.upStarCostVo = nil;
    self.tagUidDic = nil;
    self.tagCostIndexInfo = nil;
    self.tagSelectHeroDic = nil;
    DataCenter.heroUpStarData:initRemoveLineupStateDic(false);
    self:superCall("dispose");
end
















-- 英雄升星选择Item
Lua_HeroSelectCostCell = class("Lua_HeroSelectCostCell", Lua_ListCell);
function Lua_HeroSelectCostCell:ctor(p)
    self:superCall("ctor", p);
end

function Lua_HeroSelectCostCell:buildShowItem()
	self:superCall("buildShowItem");

    self.heroItemIcon = Lua_ItemIcon.new(self.content);
    self.heroItemIcon:setScale(0.86, 0.86);
end

function Lua_HeroSelectCostCell:setData(unique_id)
    self.unique_id = unique_id;
    local len = string.len(unique_id);
    if len >= 20 then
        local item_id = string.sub(unique_id,1,9);
        self.vo = Lua_ToolVo.new(item_id);
    else
        self.vo = DataCenter.heroData:getItemByUniqueId(unique_id);
    end
    self.heroItemIcon:setData(self.vo);

	self:updateSelect()
end

function Lua_HeroSelectCostCell:updateSelect()
    -- print("更新   =- =",self.data.unique_id)
    if DataCenter.heroUpStarData:isSelectHeroUidByUid(self.unique_id) == true then
        self.heroItemIcon:setDrawMask(true);
        self.heroItemIcon:setMask(false);
        self.heroItemIcon:setLock(false);
    else
        self.heroItemIcon:setDrawMask(false);
        local list = DataCenter.heroUpStarData.removeLineupStateDic;
        if self.vo.lock_state == true or (self.vo.isUpLineup == true and list[self.unique_id] ~= 1) then
            self.heroItemIcon:setLock(true);
            self.heroItemIcon:setMask(true);
        else
            self.heroItemIcon:setMask(false);
            self.heroItemIcon:setLock(false);
        end
    end 
end

function Lua_HeroSelectCostCell:onPressClick(go)
    if self.vo == nil then
        return;
    end
    Lua_MsgUtil.callFunc("UPDATA_SELECT_HERO_ITEM", self.unique_id);
end

function Lua_HeroSelectCostCell:dispose()
    self.data = nil;

    if self.heroItemIcon ~= nil then
        self.heroItemIcon:dispose();
        self.heroItemIcon = nil;
    end
    
    self:superCall("dispose");
end