-- 升星消耗道具 item
Lua_HeroUpStarCostItem = class("Lua_HeroUpStarCostItem", Lua_DisplayObject);
function Lua_HeroUpStarCostItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_HeroUpStarCostItem:buildShowItem()
	self:superCall("buildShowItem");
    self.itemIcon = Lua_ItemIcon.new(self.content);
    self.itemIcon:setClick(self, self.onHeroIconClick);

    self.add_icon = UICreate.createUIAtlasImage(self.content, "hero_develop_altas", "xui_hb_button_10", 35, -37, 0, 0);
    self.add_icon:addClickFuntion(self, self.onHeroIconClick);
    self.add_icon:setEnable(false);

    self.show_value = UICreate.createLabel(self.content, nil, 0, -81, 100, 35, 24);
    self.show_value.pivotValue = 4;
    self.show_value.alignmentValue = 4;
    self.show_value.horizontalOverflowValue = 1;
end

function Lua_HeroUpStarCostItem:updateRedDotState(redDotState)
    self.redDotState = redDotState;
    self:setSelectNum();
end

function Lua_HeroUpStarCostItem:setData(data)
	self.upStarCostVo = data;
	local hvo = data.heroVo;
	self.index = self.upStarCostVo.costMaterialsIndex;
    if hvo.id == 0 then
        self.itemIcon:setData(nil);
        self.itemIcon:setTypeIcon(hvo.campType);
        self.itemIcon:showHeroStar(hvo.quality, hvo.quality_star)
        self.itemIcon:setIconBg("common_altas_1", "xui_common_itembg_"..hvo.color);
        self.itemIcon:setIconImg("common_altas_1", "ui_common_hero_icon"..hvo.color);
    else
        self.itemIcon:setData(hvo);
    end
end

function Lua_HeroUpStarCostItem:setSelectNum()
	local selectNum = DataCenter.heroUpStarData:getSelectHeroNumByIndex(self.index);
    self.add_icon:setEnable(selectNum ~= self.upStarCostVo.needNum);
    self.itemIcon.iconBg:setGray(selectNum ~= self.upStarCostVo.needNum);
    self.itemIcon.iconImg:setGray(selectNum ~= self.upStarCostVo.needNum);
    local frontColor = "64be7e";
    local backColor = "64be7e";
    if selectNum < self.upStarCostVo.needNum then
        frontColor = "f0917f";
        backColor = "ffffff";
    end

	self.show_value.text = Lua_ColorDefine.getColorStr(frontColor, selectNum)..Lua_ColorDefine.getColorStr(backColor,"/"..self.upStarCostVo.needNum);

    local redDotState = false;
    if self.redDotState == true and selectNum < self.upStarCostVo.needNum then--有红点才展示材料红点
        local advance_state = DataCenter.heroUpStarData:upStarMaterialRedDot(self.upStarCostVo);--预选状态
        if advance_state then
            redDotState = true;
        end
    end
    self.itemIcon:showRedPoint(redDotState);
end

function Lua_HeroUpStarCostItem:onHeroIconClick()
    local bool = DataCenter.heroUpStarData:isHaveHeroCost(self.upStarCostVo);
    if bool == false then
        DataCenter.packUtil:openPathWindow(DataCenter.heroUtil.hero_goto_itemid, false);
        return
    end
	Lua_WindowUtil.openWin("Lua_HeroSelectCostWindow", Lua_WinParam.ACTION_OPEN, self.upStarCostVo);
end

function Lua_HeroUpStarCostItem:dispose()
	if self.itemIcon ~= nil then
        self.itemIcon:dispose();
        self.itemIcon = nil;
    end
    self.add_icon = nil;
    self.show_value = nil;
	self.upStarCostVo = nil;
	self:superCall("dispose");
end