-- 英雄升星
checkRequire("Lua_HeroStarItem");
checkRequire("Lua_HeroCostItem");
checkRequire("Lua_HeroUpStarCostItem");
Lua_HeroUpStarPanel = class("Lua_HeroUpStarPanel", Lua_DisplayObject);
function Lua_HeroUpStarPanel:ctor(p)
    self:superCall("ctor", p, "HeroUpStarPanel_skin");
end

function Lua_HeroUpStarPanel:buildShowItem()
    self:superCall("buildShowItem");

    self.star_btn:addClickFuntion(self, self.onUpStarBtnClick);
    
    self:addLuaEvent("UPDATE_HERO_TAB_REDDOT", self, self.updateCostOrRed);--更新升级红点
    self:addLuaEvent("UPDATA_SELECT_COST_HERO_NUM", self, self.updateSelectCostHeroNum);--选择材料后更新数量
end

function Lua_HeroUpStarPanel:updateHeroPanelInfo(data)
    self:removeTimer(self, self.onOpenTimer);
    self.isOpenTime = false;

    self.data = data;
    DataCenter.heroUpStarData:initUpStarData(self.data.unique_id);

    self.add_des:setLangValue(126211);
    self.add_vaule.text = self.data.heroUpStarVo.next_des;
    self.heroUpStarVo = self.data.heroUpStarVo;
    if self.heroUpStarVo.isMaxLevelLimit and (not self.data.isMaxStar) then
        self.limit_des:setEnable(false);
        self.limit_lvl:setEnable(false);
        self.add_des:setLocation(-95, 377);
        self.add_vaule:setLocation(57, 377);
    else
        self.limit_des:setEnable(true);
        self.limit_lvl:setEnable(true);
        self.add_des:setLocation(-247, 377);
        self.add_vaule:setLocation(-89, 377);
        self.limit_lvl.text = self.heroUpStarVo.next_lvl_limit;
    end

    local cfgData = DataCenter.heroUtil:getHeroAwakenStarConfigInfo(self.data.awaken_star_id);
    local awakenData = DataCenter.heroUtil:getHeroAwakenStarConfigInfo(cfgData.next_id);
    self.openLimit = awakenData ~= nil and awakenData.open_day_limit or 0;
    if self.data.isMaxStar then--最大质量星级
        self.arrows:setEnable(false);
        self.btnObj:SetActive(false);
        self.add_vaule.text = self.data.heroUpStarVo.max_des;
        self.limit_lvl.text = self.heroUpStarVo.add_lvl_limit; 
        self:showRedDot(false); -- 升星红点
        self:showMaxLevel(true);
        self:showCostHeroItem(nil);
        self:showRightStarsItem(nil);
        self:showCostMaterialItem(nil);
        self:showOpenTxt(false);
    elseif DataCenter.heroUpStarData.limlitUp and self.openLimit > DataCenter.roleData.open_days then
        self:showOpenTxt(true);
        self:setOpenTimer();
        self.arrows:setEnable(true);
        self.btnObj:SetActive(false);
        self:showRedDot(false);
        self:showMaxLevel(false);
        self:showCostHeroItem(nil);
        self:showRightStarsItem(awakenData);
        self:showCostMaterialItem(nil);
    else

        local arr = self.heroUpStarVo.costMaterialInfo;
        local btn_y = 200;
        -- self.rod_y = 231;
        if arr:getSize() > 0 then
            btn_y = 180;
            -- self.rod_y = 211;
        end
        self.star_btn:setLocation(210, btn_y, 0)

        self.arrows:setEnable(true);
        self.btnObj:SetActive(true);
        self.add_vaule.text = self.data.heroUpStarVo.next_des;
        
        self:showMaxLevel(false);
        self:showCostMaterialItem(arr);

        self.redDotState = DataCenter.heroUpStarData:checkUpStarRedDot(self.data);
        self:showRedDot(self.redDotState); -- 升星红点

        self:showRightStarsItem(awakenData);
        self:showCostHeroItem(self.heroUpStarVo);

        self:showOpenTxt(false);
    end

    self:showLeftStarsItem(self.data);

    if self.tweenName == nil then
        self.tweenName = DataCenter.winTweenManager:createWinTween(self.content.name, self.content.transform);
    end
end

function Lua_HeroUpStarPanel:updateSelectCostHeroNum(costMaterialsIndex)
    if self.costHeroArr[costMaterialsIndex] ~= nil then
        self.costHeroArr[costMaterialsIndex]:setSelectNum();
    end
end

function Lua_HeroUpStarPanel:updateCostOrRed()
    local redDotState = DataCenter.heroUpStarData:checkUpStarRedDot(self.data);
    self:showRedDot(redDotState); -- 升星红点
    if self.costHeroArr ~= nil then
        local len = self.costHeroArr:getSize();
        for i = 1, len do
            self.costHeroArr[i]:updateRedDotState(redDotState);
        end
    end
end

function Lua_HeroUpStarPanel:showLeftStarsItem(data) -- 左显示星
    if self.leftStarItem == nil then
        self.leftStarItem = Lua_HeroStarItem.new(self.content);
        self.leftStarItem:setRectAnchor(7);
    end

    if data.isMaxStar then
        self.leftStarItem:setLocation(-80, 479,0);
    else
        self.leftStarItem:setLocation(-262, 479,0);
    end
    self.leftStarItem:setData(data);
end

function Lua_HeroUpStarPanel:showRightStarsItem(data) -- 右显示星
    if data ~= nil and not data.isMaxStar then
        if self.rightStarItem == nil then
            self.rightStarItem = Lua_HeroStarItem.new(self.content);
            self.rightStarItem:setRectAnchor(7);
            self.rightStarItem:setLocation(78, 479,0);
        end
        self.rightStarItem:setData(data);
        self.rightStarItem:setEnable(true);
    else
        if self.rightStarItem ~= nil then
            self.rightStarItem:setEnable(false);
        end
    end
end

-- 最大星级提示
function Lua_HeroUpStarPanel:showMaxLevel(bool)
    if bool then
        if self.max_level == nil then
            self.max_level = UICreate.createLabel(self.content, nil, 0, 202, 100, 40, 30);
            self.max_level:setAnchorMin(0.5, 0);
            self.max_level:setAnchorMax(0.5, 0);
            self.max_level.alignmentValue = 4;
            self.max_level.horizontalOverflowValue = 1;
            self.max_level.pivot = UIUtils.Pivot.Center;
            self.max_level.fontName = Lua_MyUISettings.huakangFontName;
            -- self.max_level.effectStyle = 2;
            self.max_level.colorStr = Lua_ColorDefine.transColor("f0f0f0");
            -- self.max_level.effectColorStr = Lua_ColorDefine.transColor("FFFFFF");
        end
        self.max_level:setEnable(true);
        self.max_level.text = LanUtil.getValue(126225);
    else
        if self.max_level ~= nil then
            self.max_level:setEnable(false);
        end
    end
end

-- 升星英雄消耗
function Lua_HeroUpStarPanel:showCostHeroItem(heroUpStarVo)
    if heroUpStarVo ~= nil then
        local arr = heroUpStarVo.costHeroInfo;
        if self.costHeroArr == nil then
            self.costHeroArr = Array();
        end
        local len = self.costHeroArr:getSize();
        for i = 1, len do
            self.costHeroArr[i]:setEnable(false);
        end
        for i = 1, arr:getSize() do
            local item = nil;
            if self.costHeroArr[i] ~= nil then
                item = self.costHeroArr[i];
            else
                item = Lua_HeroUpStarCostItem.new(self.content);
                item:setRectAnchor(7);
                self.costHeroArr:add(item);
            end
            --需要自动选择材料的需要筛选一次数据
            if arr[i].isAutoSelect == true then
                arr[i]:initialCostInfo();
            end
            item:setData(arr[i]);
            item:updateRedDotState(self.redDotState);
            item:setLocation(-265+(i-1)*127, 213);
            item.content.name = "Lua_HeroUpStarCostItem" .. i;
            item:setEnable(true);
        end
    else
        if self.costHeroArr ~= nil then
            local len = self.costHeroArr:getSize();
            for i = 1, len do
                self.costHeroArr[i]:setEnable(false);
            end
        end
    end
end

-- 升星材料消耗
function Lua_HeroUpStarPanel:showCostMaterialItem(arr)
    if arr ~= nil then
        if self.costMaterialArr == nil then
            self.costMaterialArr = Array();
        end
        local len = self.costMaterialArr:getSize();
        for i = 1, len do
            self.costMaterialArr[i]:setEnable(false);
        end
        for i = 1, arr:getSize() do
            local item = nil;
            if self.costMaterialArr[i] ~= nil then
                item = self.costMaterialArr[i];
            else
                item = Lua_HeroCostItem.new(self.content);
                item:setRectAnchor(7);
                self.costMaterialArr:add(item);
            end
            item:setData(arr[i]);
            item:setLocation(115+(i-1)*127, 240, 0);
            item:setEnable(true);
        end
    else
        if self.costMaterialArr ~= nil then
            local len = self.costMaterialArr:getSize();
            for i = 1, len do
                self.costMaterialArr[i]:setEnable(false);
            end
        end
    end
end

function Lua_HeroUpStarPanel:onUpStarBtnClick() -- 升星
    if self.clickTime ~= nil and (getTime() - self.clickTime) < 0.5 then
        return;
    end
    
    self.clickTime = getTime();
    
    local isMeetUpStarCost = self.heroUpStarVo.isMeetUpStarCost;
    if isMeetUpStarCost ~= true then
        DataCenter.packUtil:openPathWindow(isMeetUpStarCost, false);
        return;
    end

    if DataCenter.heroUpStarData:isUpStar(self.heroUpStarVo.all_num) == true then
        if self.data.star == DataCenter.heroUtil.rollback_high then
            local cfgData = DataCenter.heroUtil:getHeroAwakenStarConfigInfo(self.data.awaken_star_id);
            local nextCfgData = DataCenter.heroUtil:getHeroAwakenStarConfigInfo(cfgData.next_id);
            local str = LanUtil.formateStr(126216,tostring(nextCfgData.quality_star));
            local tipsData = { des = str, btnType = 1, owner = self, sureFun = self.sureBtnClick };
            Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
        else
            self:sureBtnClick();
        end
    else
        OperateAlert.showLangValue(126210);
    end
end

function Lua_HeroUpStarPanel:sureBtnClick()
    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroUpStar(self.data.unique_id);
end

--升星红点
function Lua_HeroUpStarPanel:showRedDot(val)
    if val == true then
        if self.redDotIcon == nil then
            self.redDotIcon = Lua_RedPointIcon.new(self.star_btn.mainContent);
            -- self.redDotIcon:setRectAnchor(7);
            self.redDotIcon:createRedPointImg(nil);
            self.redDotIcon:setLocation(85, 31, 0);
        end
        self.redDotIcon:updateRedPointShow(true);
    else
        if self.redDotIcon ~= nil then
            self.redDotIcon:updateRedPointShow(false);
        end
    end
end

function Lua_HeroUpStarPanel:setOpenTimer()
    self.offsetTime = (self.openLimit - DataCenter.roleData.open_days - 1) * 86400 + getReaminSecondsTo24();
    if self.offsetTime < 0 or self.openLimit <= DataCenter.roleData.open_days then
        self.offsetTime = 0;
    end
    if self.offsetTime > 0 then
        if not self.isOpenTime then
            self.isOpenTime = true;
            self:onOpenTimer();
            self:addTimer("onOpenTimer", 1, self, self.onOpenTimer);
        end
    else
        if self.isOpenTime then
            self.isOpenTime = false;
            self:removeTimer(self, self.onOpenTimer);
            self:updateHeroPanelInfo(self.data);
        end
    end
end

function Lua_HeroUpStarPanel:onOpenTimer()
    self.offsetTime = self.offsetTime - 1;
    if self.offsetTime < 0 then
        self.offsetTime = 0;
        self:setOpenTimer();
    end
    self.openTxt.text = LanUtil.formateStr(126227, Lua_TimeTransform.transSeconds1(self.offsetTime));
end

function Lua_HeroUpStarPanel:showOpenTxt(val)
    if val then
        if self.openTxt == nil then
            self.openTxt = UICreate.createLabel(self.content, nil, 0, 202, 100, 40, 30);
            self.openTxt.anchorValue = 7;
            self.openTxt.alignmentValue = 4;
            self.openTxt.horizontalOverflowValue = 1;
            self.openTxt.pivot = UIUtils.Pivot.Center;
            self.openTxt.fontName = Lua_MyUISettings.huakangFontName;
            self.openTxt.colorStr = Lua_ColorDefine.transColor("f0f0f0");
            -- self.openTxt.effectStyle = 2;
            -- self.openTxt.effectColorStr = Lua_ColorDefine.transColor("FFFFFF");
        end
        self.openTxt:setEnable(true);
    else
        if self.openTxt ~= nil then
            self.openTxt:setEnable(false);
        end
    end
end

function Lua_HeroUpStarPanel:dispose()
    if self.leftStarItem ~= nil then
        self.leftStarItem:dispose();
        self.leftStarItem = nil;
    end

    if self.rightStarItem ~= nil then
        self.rightStarItem:dispose();
        self.rightStarItem = nil;
    end

    if self.costHeroArr ~= nil then
        self.costHeroArr:dispose();
        self.costHeroArr:clear();
        self.costHeroArr = nil;
    end
    if self.costMaterialArr ~= nil then
        self.costMaterialArr:dispose();
        self.costMaterialArr:clear();
        self.costMaterialArr = nil;
    end

    if self.redDotIcon ~= nil then
        self.redDotIcon:dispose();
        self.redDotIcon = nil;
    end

    self.l_star_bg = nil;
    self.l_star_level = nil; 
    self.l_quality_icon = nil;

    self.r_star_bg = nil;
    self.r_star_level = nil;
    self.r_quality_icon = nil;

    self.data = nil;
    DataCenter.winTweenManager:removeWinTween(self.tweenName);
    self:superCall("dispose");
end