-- 英雄升星成功Tips
checkRequire("Lua_HeroBreakAttributeItem");
Lua_HeroUpStarSucceedWindow = class("Lua_HeroUpStarSucceedWindow", Lua_Window);
function Lua_HeroUpStarSucceedWindow:ctor()
    self:superCall("ctor");
    self.isClickClose = true;
    self.showBlackMask = true;
    self.showCloseText = true;
    self.closeTextPosY = -445;
    self.windowName = "Lua_HeroUpStarSucceedWindow";
    self.skinName = "HeroUpStarSucceedWindow_skin";
end

function Lua_HeroUpStarSucceedWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.windEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_yx_sx_02", "ui_yx_sx_02", 0, 400);
    self.heroItemL = Lua_ItemIcon.new(self.content);
    self.heroItemR = Lua_ItemIcon.new(self.content);
    self.heroItemL:setLocation(-173, 192);
    self.heroItemR:setLocation(173, 192);
    self.winBg:setLocation(0, 187);
end

function Lua_HeroUpStarSucceedWindow:showWin(param)
    local cfgData = DataCenter.heroUtil:getHeroAwakenStarConfigInfo(param.data.awaken_star_id);
    if param.data.heroUpStarVo.isMaxLevelLimit then
        self.limit_des:setEnable(false);
    else
        local str = cfgData.lvl_limit;
        self.limit_des.text =  LanUtil.formateStr(126214,tostring(str));
        self.limit_des:setEnable(true);
    end
    local up_awaken_star_id = cfgData.up_id;
    local upCfgData = DataCenter.heroUtil:getHeroAwakenStarConfigInfo(up_awaken_star_id);
    local voL = Lua_ToolVo.createToolVo(param.data.id);
    voL.quality = upCfgData.quality;
    voL.quality_star = upCfgData.quality_star;
    voL.clothesId = param.data.clothesId;
    self.heroItemL:setData(voL);
    self.heroItemR:setData(param.data);
    self.heroItemR:show_level(nil);

    self:showAttributes(param.data,param.attrDic);
end

-- 属性展示
function Lua_HeroUpStarSucceedWindow:showAttributes(data, prop_list)
    local info = DataCenter.heroData:showAttrInfo(data, prop_list);
    if info ~= nil then
        if self.attrInfo == nil then
            self.attrInfo = Array();
        end
        local len = self.attrInfo:getSize();
        for i = 1, len do
            self.attrInfo[i]:setEnable(false);
        end
        for i = 1, info:getSize() do
            local item = nil;
            if self.attrInfo[i] ~= nil then
                item = self.attrInfo[i];
            else
                item = Lua_HeroBreakAttributeItem.new(self.content);
                self.attrInfo:add(item);
            end
            item:setIndex(i);
            item:setData(info[i]);
            item:setLocation(0, 85 - (i-1)*46, 0);
            item:setEnable(true);
        end
    else
        if self.attrInfo ~= nil then
            local len = self.attrInfo:getSize();
            for i = 1, len do
                self.attrInfo[i]:setEnable(false);
            end
        end
    end
end

function Lua_HeroUpStarSucceedWindow:dispose()
    if self.attrInfo ~= nil then
        self.attrInfo:dispose();
        self.attrInfo:clear();
        self.attrInfo = nil;
    end
    if self.windEff ~= nil then
        self.windEff:dispose();
        self.windEff = nil;
    end
    self.data = nil;
    self:superCall("dispose");
end