-- 英雄神兵
checkRequire("Lua_HeroMaterialItem")
Lua_HeroWeaponPanel = class("Lua_HeroWeaponPanel", Lua_DisplayObject)
function Lua_HeroWeaponPanel:ctor(p)
	self:superCall("ctor", p, "HeroWeaponPanel_skin")
end

function Lua_HeroWeaponPanel:buildShowItem()
	self:superCall("buildShowItem")

	self:addLuaEvent("HERO_WEAPON_UPGRADE", self, self.onUpgrade)
	self:addLuaEvent("UPDATE_HERI_MATERIAL_SELECT", self, self.updateCostHero)

	self.checkHelp:addClickFuntion(self, self.onCheckHelp)
	self.btnFunc:addClickFuntion(self, self.onBtnFuncClick)

	self.scoreNum = Lua_NumberImage.new(self.content)
	self.scoreNum:setRectAnchor(7)
	self.scoreNum:setLocation(-25, 477.5, 0)
	self.scoreNum.pivot = 1;
	self.scoreNum.numOffsetX = -10
	self.scoreNum.numAtlas = "number"
	self.scoreNum.preStr = "ui_zl2_number_0"

	self.skillItem = Lua_SkillIconItem.new(self.content)
	self.skillItem:setRectAnchor(7)
	self.skillItem:setLocation(284, 343.5, 0)
	self.skillItem:setCanClick(true, self, self.onSkillClick)
end

function Lua_HeroWeaponPanel:dispose()
	if self.scoreNum then
		self.scoreNum:dispose()
		self.scoreNum = nil
	end
	if self.skillItem then
		self.skillItem:dispose()
		self.skillItem = nil
	end
	if self.attrArr then
		self.attrArr:dispose()
		self.attrArr:clear()
		self.attrArr = nil
	end
	if self.costArr then
		self.costArr:dispose()
		self.costArr:clear()
		self.costArr = nil
	end
	if self.costHeroArr then
		self.costHeroArr:dispose()
		self.costHeroArr:clear()
		self.costHeroArr = nil
	end
	if self.redPointIcon then
		self.redPointIcon:dispose()
		self.redPointIcon = nil
	end
	if self.upgradeEff then
		self.upgradeEff:dispose()
		self.upgradeEff = nil
	end
	if self.trialTipItem ~= nil then
		self.trialTipItem:dispose();
		self.trialTipItem = nil;
	end
	DataCenter.heroMaterialData:dispose()
	self.data = nil
	self.weaponVo = nil
	DataCenter.winTweenManager:removeWinTween(self.tweenName);
	self:superCall("dispose")
end

function Lua_HeroWeaponPanel:updateHeroPanelInfo(data, isSHowAtlas)
	self.data = data
	self.isSHowAtlas = isSHowAtlas
	if isSHowAtlas == true then
		self.unlockText:setEnable(false)
		self.levelObject:SetActive(true)
		self.arrow:setEnable(false)
		self.nextLevel:setEnable(false)
		self.btnFunc:setEnable(false)
		local level = 0
		local config
		while true do
			config = DataCenter.heroUtil:getHeroWeaponVo(data.weaponId + level)
			if config.next_id == nil or config.next_id <= 0 then
				break
			end
			level = level + 1
		end
		self.scoreNum.num = config.score

		self.nameText.text = config.name
		self.curLevel.text = level
		self.skillItem:setSkillId(config.skill[1])
		local attrArr = DataCenter.attributesUtil:getAttrArrByDic(config.prop)
		self:showAttributes(attrArr)
	else
		local attrArr
		if data.weapon_id > 0 then -- 已解锁
			self.weaponVo = DataCenter.heroUtil:getHeroWeaponVo(data.weapon_id)
			self.scoreNum.num = self.weaponVo.score
			self.unlockText:setEnable(false)
			self.levelObject:SetActive(true)
			if self.weaponVo.next_id > 0 then
				local nextCfg = DataCenter.heroUtil:getHeroWeaponVo(self.weaponVo.next_id)
				attrArr = DataCenter.attributesUtil:getAttrArrByDic(self.weaponVo.prop, nextCfg.prop)
				self.arrow:setEnable(true)
				self.nextLevel:setEnable(true)
				self.btnFunc:setMouseEnable(true)
				self.btnFunc:setLangValue(390002)
				self:showConsume(self.weaponVo.upgrade_material)
				self:showHeroConsume(self.weaponVo.hero_material)
				self:showRedPoint()
			else
				attrArr = DataCenter.attributesUtil:getAttrArrByDic(self.weaponVo.prop)
				self.arrow:setEnable(false)
				self.nextLevel:setEnable(false)
				self.btnFunc:setMouseEnable(false)
				self.btnFunc:setLangValue(390003)
				self:showConsume(nil)
				self:showHeroConsume(nil)
				self:showRedPoint(false)
			end
			self.skillItem:setLocation(284, 343.5, 0)
			self.skillItem:setLock(false)
			self.skillItem:setGray(false)
		else
			self.weaponVo = DataCenter.heroUtil:getHeroWeaponVo(data.weaponId)
			self.scoreNum.num = nil
			attrArr = DataCenter.attributesUtil:getAttrArrByDic(self.weaponVo.prop)
			self.unlockText:setEnable(true)
			self.levelObject:SetActive(false)
			self.btnFunc:setMouseEnable(true)
			self.btnFunc:setLangValue(390001)
			self.skillItem:setLocation(284, 324, 0)
			self.skillItem:setLock(true)
			self.skillItem:setGray(true)
			self:showConsume(self.weaponVo.unlock_material)
			self:showHeroConsume(nil)
			self:showRedPoint()
		end
		self.nameText.text = self.weaponVo.name
		self.curLevel.text = self.weaponVo.level
		self.nextLevel.text = self.weaponVo.level + 1
		self.skillItem:setSkillId(self.weaponVo.skill[1])
		self:showAttributes(attrArr)

		if data.trial_state then
			self:showConsume(nil);
			self:showRedPoint(false);
		end
		self.btnFunc:setEnable(not data.trial_state);
		self:showTrialTipItem(data.trial_state);
	end
	
	if self.tag_uid ~= data.unique_id then
        self.tag_uid = data.unique_id
        if self.tweenName ~= nil then
            DataCenter.winTweenManager:removeWinTween(self.tweenName);
        end
        self.tweenName = DataCenter.winTweenManager:createWinTween(self.content.name, self.content.transform);
    end
end

function Lua_HeroWeaponPanel:onUpgrade()
	if self.upgradeEff == nil then
		self.upgradeEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_sb_shengji", "ui_sb_shengji", 0, 50)
	else
		self.upgradeEff:setEnable(false);
		self.upgradeEff:setEnable(true);
	end
end

function Lua_HeroWeaponPanel:updateCostHero(index)
	if self.costHeroArr[index] then
		self.costHeroArr[index]:updateNum()
	end
end

function Lua_HeroWeaponPanel:showAttributes(arr)
	if self.attrArr == nil then
		self.attrArr = Array()
	end
	local len = self.attrArr:getSize()
	local dataLen = arr:getSize()
	local maxLen = dataLen > len and dataLen or len
	local item
	for i = 1, maxLen do
		item = self.attrArr[i]
		if i > dataLen then
			if item then
				item:setEnable(false)
			end
		else
			if item == nil then
				item = Lua_HeroWeaponAttrItem.new(self.content)
				self.attrArr:add(item)
			else
				item:setEnable(true)
			end
			item.content.name = "Lua_HeroWeaponAttrItem" .. i;
			item:setRectAnchor(7)
			item:setLocation(-48.5, 364 - (i - 1) * 46, 0)
			item:setData(arr[i])
		end
	end
end

function Lua_HeroWeaponPanel:showConsume(data)
	if self.costArr == nil then
		self.costArr = Array();
	end

	local len = self.costArr:getSize();
	if data == nil then
		len = -len;
	else
		len = #data - len;
	end
	while (len > 0) do
		item = Lua_ConsumeIconItem.new(self.content);
		item:setStyle(Lua_MyUISettings.defaultFontName, 22, "FFFFFF");
		item:setColorStr("FFFFFF", "DE4A16");
		self.costArr:add(item);
		len = len - 1;
	end

	while (len < 0) do
		item = self.costArr:remove(1);
		item:dispose();
		len = len + 1;
	end

	len = self.costArr:getSize();
	local space = 200;
	local w = -(space * len) / 2 + space / 2;
	for i = 1, len do
		item = self.costArr[i];
		item:setRectAnchor(7)
		item:setLocation(((i - 1) % len) * space + w, 230, 0);
		item:setData(data[i]);
	end
end

function Lua_HeroWeaponPanel:showHeroConsume(data)
	if self.costHeroArr == nil then
		self.costHeroArr = Array()
	end

	local len = self.costHeroArr:getSize()
	local dataLen = 0
	if data then
		dataLen = #data
		DataCenter.heroMaterialData:init(self.data.unique_id)
	else
		DataCenter.heroMaterialData:dispose()
	end

	local maxLen = dataLen > len and dataLen or len
	local item
	local space = 120
	local w = -(space * dataLen) / 2 + space / 2
	local vo
	local arr
	for i = 1, maxLen do
		item = self.costHeroArr[i]
		if i > dataLen then
			if item then
				item:setEnable(false)
			end
		else
			if item then
				item:setEnable(true)
			else
				item = Lua_HeroMaterialItem.new(self.content)
				self.costHeroArr:add(item)
			end
			item:setRectAnchor(7)
			item:setLocation(-267 + ((i - 1) % dataLen) * space + w, 188.5, 0)

			vo = DataCenter.heroMaterialData:createMaterialVo(i)
			vo:setData(data[i])
			item:setData(vo)

			arr = DataCenter.heroMaterialData:getHeroList(vo, true)
			if arr and arr:getSize() > 0 then
				DataCenter.heroMaterialData:addHeroMaterial(vo.index, arr[1])
			end
			item:updateNum()
		end
	end
end

function Lua_HeroWeaponPanel:showRedPoint(bState)
	if bState == nil then
		if self.data.weapon_id > 0 then
			local costId = DataCenter.packData:checkConsumeEnough(self.weaponVo.upgrade_material)
			if costId then
				bState = false
			else
				if DataCenter.heroMaterialData:checkEnough(self.weaponVo.hero_material) then
					bState = true
				else
					bState = false
				end
			end
		else
			local costId = DataCenter.packData:checkConsumeEnough(self.weaponVo.unlock_material)
			if costId then
				bState = false
			else
				bState = true
			end
		end		
	end

	if bState == true then
		if self.redPointIcon == nil then
			self.redPointIcon = Lua_RedPointIcon.new(self.content)
			self.redPointIcon:setRectAnchor(7)
			self.redPointIcon:setLocation(90, 197)
			self.redPointIcon:createRedPointEff()
		end
		self.redPointIcon:updateRedPointShow(true)
	else
		if self.redPointIcon then
			self.redPointIcon:updateRedPointShow(false)
		end
	end
end

--显示试用英雄提示Item
function Lua_HeroWeaponPanel:showTrialTipItem(val)
    if val then 
        if self.trialTipItem == nil then
            self.trialTipItem = Lua_HeroTrialTipItem.new(self.content,2);
            self.trialTipItem:setRectAnchor(7);
            self.trialTipItem:setLocation(0, 187, 0);

            self.line = UICreate.createUIAtlasImage(self.content, "common_altas_3", "xui_common_line_006", 0, 233, 0, 0);
        	self.line.anchorValue = 7;
        end
        self.trialTipItem:setData(self.data);
        self.trialTipItem:setEnable(true);
        self.line:setEnable(true);
    else
        if self.trialTipItem ~= nil then
            self.trialTipItem:setData(nil);
            self.trialTipItem:setEnable(false);
            self.line:setEnable(false);
        end
   end
end

function Lua_HeroWeaponPanel:onSkillClick(data)
	if self.data == nil then
		return;
	end
	Lua_WindowUtil.openWin("Lua_HeroWeaponSkillWindow", Lua_WinParam.ACTION_OPEN, { data = self.data, isSHowAtlas = self.isSHowAtlas });
end

function Lua_HeroWeaponPanel:onCheckHelp(go)
	local tipsData = { posX = 17, posY = -260, des = LanUtil.getValue(390000) }
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData)
end

function Lua_HeroWeaponPanel:onBtnFuncClick(go)
	if self.data.weapon_id > 0 then
		local costId = DataCenter.packData:checkConsumeEnough(self.weaponVo.upgrade_material)
		if costId then
			DataCenter.packUtil:openPathWindow(costId, false)
		else
			if DataCenter.heroMaterialData:checkEnough(self.weaponVo.hero_material) then
				Lua_ProxyManager.getProxy("Lua_HeroProxy"):sUpgradeWeapon(self.data.unique_id, DataCenter.heroMaterialData.selectedDic)
			else
				OperateAlert.showLangValue(390009)
			end
		end
	else
		local costId = DataCenter.packData:checkConsumeEnough(self.weaponVo.unlock_material)
		if costId then
			DataCenter.packUtil:openPathWindow(costId, false)
		else
			Lua_ProxyManager.getProxy("Lua_HeroProxy"):sUnlockWeapon(self.data.unique_id)
		end
	end
end




















Lua_HeroWeaponAttrItem = class("Lua_HeroWeaponAttrItem", Lua_DisplayObject);
function Lua_HeroWeaponAttrItem:ctor(p)
	self:superCall("ctor", p, "HeroWeaponAttrItem_skin");
end

function Lua_HeroWeaponAttrItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_HeroWeaponAttrItem:dispose()
	self:superCall("dispose");
end

function Lua_HeroWeaponAttrItem:setData(data)
	self.attrIcon:setAltas("common_altas_2", data.hero_attr_icon)
	self.nameText.text = data.show_name
	self.curText.text = data.showValue
	if data.nextValue and data.nextValue > 0 then
		self.arrow:setEnable(true)
		self.nextText:setEnable(true)
		self.nextText.text = data.showNextValue
	else
		self.arrow:setEnable(false)
		self.nextText:setEnable(false)
	end
end