Lua_HeroWeaponTipsWindow = class("Lua_HeroWeaponTipsWindow", Lua_Window)
function Lua_HeroWeaponTipsWindow:ctor()
	self:superCall("ctor")

	self.windowName = "Lua_HeroWeaponTipsWindow"
	self.skinName = "HeroWeaponTipsWindow_skin"
	self.showBlackMask = true
	self.isClickClose = true
end

function Lua_HeroWeaponTipsWindow:buildShowItem()
	self:superCall("buildShowItem")
end

function Lua_HeroWeaponTipsWindow:dispose()
	if self.attrArr then
		self.attrArr:dispose()
		self.attrArr:clear()
		self.attrArr = nil
	end
	if self.titelEff then
		self.titelEff:dispose()
		self.titelEff = nil
	end
	if self.weaponEff then
		self.weaponEff:dispose()
		self.weaponEff = nil
	end
	self:superCall("dispose")
end

function Lua_HeroWeaponTipsWindow:showWin(param)
	self:superCall("showWin", param)
	self.weaponImg:setUrl(param.uiPicUrl)

	local prevVo = DataCenter.heroUtil:getHeroWeaponVo(param.id - 1)
	local attrArr
	if prevVo == nil then
		self:showTitleEff("ui_sb_jihuokuang_1")
		attrArr = DataCenter.attributesUtil:getAttrArrByDic(param.prop)
	else
		self:showTitleEff("ui_sb_jihuokuang_3")
		attrArr = DataCenter.attributesUtil:getAttrArrByDic(prevVo.prop, param.prop)
	end
	self:showAttributes(attrArr)

	self.weaponEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/ui_sb_jihuokuang_2", "ui_sb_jihuokuang_2", 1, 210)

	local str = Lua_SkillConfigData.getConfigData(param.skill[1]).des
	self.skillText.text = string.gsub(str, "499E6A", "8BE26F")
end

function Lua_HeroWeaponTipsWindow:showAttributes(arr)
	if self.attrArr == nil then
		self.attrArr = Array()
	end
	local len = self.attrArr:getSize()
	local dataLen = arr:getSize()
	local maxLen = dataLen > len and dataLen or len
	local item
	for i = 1, maxLen do
		item = self.attrArr[i]
		if i > dataLen then
			if item then
				item:setEnable(false)
			end
		else
			if item == nil then
				item = Lua_HeroWeaponTipsItem.new(self.content)
				self.attrArr:add(item)
			else
				item:setEnable(true)
			end
			item:setLocation(0, 7.5 - (i - 1) * 45.5, 0)
			item:setData(i, arr[i])
		end
	end
end

function Lua_HeroWeaponTipsWindow:showTitleEff(value)
	if value then
		if self.titelEff == nil then
			self.titelEff = UICreate.createUIEffect(self.content, "/effects/uiEffects/"..value, value, 0, 451)
		end
		self.titelEff:setEnable(true);
	else
		if self.titelEff then
			self.titelEff:setEnable(false);
		end
	end
end





















Lua_HeroWeaponTipsItem = class("Lua_HeroWeaponTipsItem", Lua_DisplayObject)
function Lua_HeroWeaponTipsItem:ctor(p)
	self:superCall("ctor", p, "HeroWeaponTipsItem_skin")
end

function Lua_HeroWeaponTipsItem:buildShowItem()
	self:superCall("buildShowItem")
end

function Lua_HeroWeaponTipsItem:dispose()
	self:superCall("dispose")
end

function Lua_HeroWeaponTipsItem:setData(index, data)
	self.bg:setEnable(index % 2 == 1)
	self.nameText.text = data.show_name
	self.nameText:resetSize()
	self.curText.text = data.showValue
	if data.nextValue and data.nextValue > 0 then
		self.nameText:setLocation(-220, 0, 0)
		self.curText:setLocation(-220 + self.nameText.width + 24, 0, 0)
		self.arrow:setEnable(true)
		self.nextText:setEnable(true)
		self.nextText.text = data.showNextValue
	else
		self.nameText:setLocation(-92, 0, 0)
		self.curText:setLocation(-92 + self.nameText.width + 24, 0, 0)
		self.arrow:setEnable(false)
		self.nextText:setEnable(false)
	end
end