-- 英雄Panel
checkRequire("Lua_HeroCellsItem"); -- cell
Lua_HeroPanel = class("Lua_HeroPanel", Lua_DisplayObject);
function Lua_HeroPanel:ctor(p)
    self:superCall("ctor", p,"HeroPanel_skin");
end

function Lua_HeroPanel:addEvent()
    self:addLuaEvent("ADD_HERO_ITEM", self, self.updateList);--英雄增加
    self:addLuaEvent("DELETE_HERO_ITEM", self, self.updateList);--英雄删除
    self:addLuaEvent("UPDATE_ADD_BAG_SIZE", self, self.updatePackSizeInfo);--背包数量更新
    self:addLuaEvent("SELECT_SHOW_ATTRS_WINOW_INDEX", self, self.onOpenAttrWinow); -- 打开属性面板
    self:addLuaEvent("ENFORCE_UPDATA_HERO_PANEL", self, self.enforceUpdateHeroInfo); -- 在属性界面强制刷新
    self:addLuaEvent("GUIDE_SELECTED_HERO", self, self.guideSelectedHero); -- 引导查找英雄item
    self.add_btn:addClickFuntion(self, self.onAddBtnClick);
end

function Lua_HeroPanel:buildShowItem()
    self:superCall("buildShowItem");
    self:addEvent();

    self.dragList = Lua_DragList.new(self.content,695, 796+self.adaptHeight, Lua_AxisDefine.Vertical);
    self.dragList:setListCell(Lua_HeroCellsItem, 170, 221, 4);
    self.dragList:setCellSpacing(5, 3);
    self.dragList:setLocation(8, -24);
    self.dragList.tweenId = 2028;

    self.campSiftPanel = Lua_CampCareerSiftPanel.new(self.content);
    self.campSiftPanel:setLocation(0, -470-self.adaptHeight/2, 0);
    self.campSiftPanel:setArrayData(DataCenter.heroUtil.siftAllInfo);
    self.campSiftPanel:setCallBack(self, self.onCampSelected);
    self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, 0, true);

    self.embattleIcon = UICreate.createUIAtlasImage(self.content, "hero_altas", "xui_hb_button_1_n", -280, -273, 0, 0);
    self.embattleIcon:setAnchorMin(0.5, 1);
    self.embattleIcon:setAnchorMax(0.5, 1);
    self.embattleIcon.name = "embattleIcon";
    self.embattleIcon:addClickFuntion(self, self.onOpenLineupClick);

    self:updatePackSizeInfo();
end

-- 强制刷新
function Lua_HeroPanel:enforceUpdateHeroInfo()
    DataCenter.heroData:sortHeroInfo();
    self:updateDragInfo(self.selectSiftType, self.careerType, false);
end

function Lua_HeroPanel:updateList()
    local campType = self.selectSiftType or Lua_HeroUtil.All_TYPE;
    local careerType = self.careerType or 0;
    self:updateDragInfo(campType, careerType);
    self:updatePackSizeInfo();
end

function Lua_HeroPanel:updatePackSizeInfo()
    self.add_btn:setEnable( not DataCenter.heroData.isExtendBagLimit);
    local arr = DataCenter.heroData.allHeroUidArr;
    self.show_num.text = arr:getSize().."/"..DataCenter.heroData.bag_size;
end

function Lua_HeroPanel:updateShow()
    self.selectSiftType = nil;
    self.dragList:moveToIndex(1, true);
    self.dragList.showTween = true;
    self.campSiftPanel:setSelected(Lua_HeroUtil.All_TYPE, 0, true);
end
    
function Lua_HeroPanel:onCampSelected(selectType, careerType) -- 更新筛选状态
    if self.selectSiftType == selectType and self.careerType == careerType then
        return;
    end

    self.selectSiftType = selectType;
    self.careerType = careerType;

    self:updateDragInfo(selectType, careerType)
end

-- 打开属性面板
function Lua_HeroPanel:updateDragInfo(selectType, careerType, bMoveToIdx)
    self.showCampTypeArr = DataCenter.heroData:getPackAllInfoByCampType(selectType, careerType);
    local len = self.showCampTypeArr:getSize();
    self.show_bg:setEnable(len <= 0);
    self.show_txt:setEnable(len <= 0);

    self.dragList:setArrayData(self.showCampTypeArr);
    if bMoveToIdx ~= false then
        self.dragList:moveToIndex(1, true);
    end
end

-- 打开属性面板
function Lua_HeroPanel:onOpenAttrWinow(data)
    if data == nil then
        return;
    end

    if self.tag_uid == data.unique_id then
        return
    end
    self.tag_uid = data.unique_id;

    if self.clickTime ~= nil and getTime() - self.clickTime <= 0.6 then
        return
    end
    self.clickTime = getTime();

    DataCenter.preLoadData:removeBySign("Lua_HeroShowAttributeWindow", self, self.onShowModel);
    local info = {arr = self.showCampTypeArr, selectSiftType = self.selectSiftType,careerType = self.careerType, selectBtn = 1, unique_id = data.unique_id, createIdx = data.index};
    -- print("选择索引 = = ",data.index);
    local unique_id = self.showCampTypeArr[data.index].unique_id;
    local heroVo = DataCenter.heroData:getItemByUniqueId(unique_id);
    DataCenter.preLoadData:preShowModelScene("Lua_HeroShowAttributeWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onShowModel, info, heroVo);
end

function Lua_HeroPanel:onShowModel(param, modelScenePanel, issuccess)
    if issuccess then
        self.tag_uid = nil;
        param.modelScenePanel = modelScenePanel;
        Lua_WindowUtil.openWin("Lua_HeroShowAttributeWindow", Lua_WinParam.ACTION_OPEN, param);
        return;
    end

    DataCenter.preLoadData:removeBySign("Lua_HeroShowAttributeWindow", self, self.onShowModel);
end

function Lua_HeroPanel:onAddBtnClick()
    local vo = DataCenter.heroUtil:getBagCostVoById(DataCenter.heroData.extend_times+1);
    if vo ~= nil and vo.amount ~= nil then
        local str = spliceIconStrById(Lua_ResourcesDefine.DIAMOND);
        local tipData = {
            des = LanUtil.formateStr(126110, str, tostring(vo.amount), tostring(vo.add)),
            posY = 50, btnType = 1, owner = self, sureFun = self.onSubBtnClick

        };
        Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
    else
        self:onSubBtnClick() -- 确定
    end
end

function Lua_HeroPanel:onSubBtnClick() -- 确定
    Lua_ProxyManager.getProxy("Lua_HeroProxy"):sAddPackSize(); --请求英雄数据
end

function Lua_HeroPanel:onScreenResize(adaptHeight)
    if self.adaptHeight ~= adaptHeight then
        self:superCall("onScreenResize", adaptHeight);
        self.dragList:setContentRect(695, 796 + adaptHeight);
        self.dragList:moveToIndex(1, false);
        self.campSiftPanel:setLocation(0, -470-self.adaptHeight/2, 0);
    end
end

function Lua_HeroPanel:guideSelectedHero(heroId)
    if heroId ~= nil then
        local unique_id;
        local maxLvl = 0;
        local arr = DataCenter.heroData:getHeroUidArrById(heroId);
        if arr:getSize() == 0 then
            return;
        end
        for i = 1, arr:getSize() do
            local heroVo = DataCenter.heroData:getItemByUniqueId(arr[i]);
            if heroVo ~= nil and heroVo.level > maxLvl then
                unique_id = arr[i];
                maxLvl = heroVo.level;
            end
        end
        
        arr = self.dragList.showDragDataList;
        local index = 1;
        for i = 1, arr:getSize() do
            local cellData = arr:getItem(i).data;
            if cellData.unique_id == unique_id then
                index = i;
                self.dragList:moveToIndex(index, true);
                break;
            end
        end

        local item = self.dragList.showDragDataList:getItem(index).cell;
        local path = "content/Lua_HeroPanel/Lua_DragList/ScrollContainer/Content/"..item.content.name;
        Lua_MsgUtil.callFunc("GUIDE_SELECT_HERO_TARGETITEM", path);
    end
end

function Lua_HeroPanel:onOpenLineupClick() -- 打开布阵
    local sceneId = DataCenter.heroLineupData:getLineUpSceneId(Lua_HeroUtil.LINEUP_MAIN_TYPE);
    DataCenter.preLoadData:preShowScene("Lua_HeroLineupWindow", Lua_PreLoadDefine.LOADSHOW_TYPE_NONE, self, self.onSceneShow, nil, sceneId, 0);
end


function Lua_HeroPanel:onSceneShow(param)
    local arr = DataCenter.heroLineupUtil:getLineupTabArr()
    Lua_WindowUtil.openWin("Lua_HeroLineupWindow", Lua_WinParam.ACTION_OPEN, arr);
end

function Lua_HeroPanel:dispose()
    if self.campSiftPanel ~= nil then
        self.campSiftPanel:dispose();
        self.campSiftPanel = nil;
    end

    if self.dragList ~= nil then
        self.dragList:dispose();
        self.dragList = nil;
    end
    
    if self.fetterRedDot then
        self.fetterRedDot:dispose();
        self.fetterRedDot = nil;
    end

    self.showCampTypeArr = nil;
    DataCenter.preLoadData:removeBySign("Lua_HeroShowAttributeWindow", self, self.onShowModel);
    self:superCall("dispose");
end