--英雄属性展示
checkRequire("Lua_HeroTabCell");
checkRequire("Lua_HeroTrialTipItem")
checkRequire("Lua_HeroShowBaseWindow");
Lua_HeroShowAttributeWindow = class("Lua_HeroShowAttributeWindow", Lua_HeroShowBaseWindow);
function Lua_HeroShowAttributeWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_HeroShowAttributeWindow";
    self.selectIndex = 1; --英雄选择索引
end

function Lua_HeroShowAttributeWindow:buildPanel(go)
    self:superCall("buildPanel", go);
    self:addLuaEvent("ADD_HERO_ITEM", self, self.updateShowArr);-- 英雄增加
    self:addLuaEvent("DELETE_HERO_ITEM", self, self.updateShowArr);-- 英雄删除

    self:addLuaEvent("UPDATE_ONE_HERO_INFO", self, self.updateShowHero);-- 数据更新
    self:addLuaEvent("UPDATA_TAG_BUTTON_ITEM", self, self.onTabBtnClick);-- 页签按钮
    
    self:addLuaEvent("UPDATE_HERO_TAB_REDDOT", self, self.updateShowTabBtnState);--页签红点更新
    self:addLuaEvent("UPDATE_CBCARDDETAIL_REWARD", self, self.updateShowHeroInfo); -- 卡牌奖励更新

    self:addLuaEvent("UPDATA_UP_STAR_SUCCEED_INFO", self, self.updateUpStarSucceedInfo);--升星成功
end

function Lua_HeroShowAttributeWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.share_btn:setEnable(false);
    self.skin_btn:setEnable(false);
    self.sub_btn:setEnable(false);
    self.add_btn:setEnable(false);

    self.tabList = Lua_DragList.new(self.buttomObj, 590, 108, Lua_AxisDefine.Horizontal);
    self.tabList:setListCell(Lua_HeroTabCell, 118, 108, 1);
    self.tabList:setRectAnchor(7);
    
    self.sub_btn:addClickFuntion(self, self.onSubBtnClick);
    self.add_btn:addClickFuntion(self, self.onAddBtnClick);
    self.lock_btn:addClickFuntion(self, self.onLockBtnClick);-- 上锁
    self.type_icon:addClickFuntion(self, self.onCompBtnClick);--阵容克制描述
    self.comment_btn:addClickFuntion(self, self.onCommentBtnClick);-- 评论
    self.rebuild_btn:addClickFuntion(self, self.onRebuildBtnClick);-- 重修
    self.quality_icon:addClickFuntion(self, self.onQualityBtnClick);--质量描述
    self.introduce_btn:addClickFuntion(self, self.onIntroduceBtnClick);-- 传记
end

function Lua_HeroShowAttributeWindow:onScreenResize()
    self:superCall("onScreenResize");
    if self.modelScenePanel ~= nil then
        self.modelScenePanel:setRotBgDimensions(720,815+self.adaptHeight);
    end
end

--英雄展示数据
function Lua_HeroShowAttributeWindow:showWin(param)
    self:superCall("showWin", param);
    if param == nil then
        self:hide();
        return;
    end
    self.selectTabId = nil;
    self.selectBtn = param.selectBtn;
    self.showArr = param.arr; --英雄背包数据
    if self.showArr ~= nil then
        self.showIdx = param.createIdx;
        self.selectSiftType = param.selectSiftType;--当前选择阵容页签的类型
        self.careerType = param.careerType;--职业
    else--外部打开
        if param.unique_id == nil then
            self:hide();
            return;
        end
        self.selectUId = param.unique_id;
    end
    self.isSignOpenW = true;
    self:updateShowHeroInfo();-- 显示英雄信息
    self:onPlayLinesSound()
end

function Lua_HeroShowAttributeWindow:updateShowHeroInfo()
    if self.showArr == nil then
        if self.selectUId == nil then
            self:hide();
            return;
        end

        self.data = DataCenter.heroData:getItemByUniqueId(self.selectUId);
        if self.data == nil then
            self:hide();
            return;
        end

        self.sub_btn:setEnable(false);
        self.add_btn:setEnable(false);
    else
        local unique_id = self.showArr[self.showIdx].unique_id;
        self.data = DataCenter.heroData:getItemByUniqueId(unique_id);
        self:updateTabState()
    end
    
    self.name.text = self.data.name;
    self.title.text = self.data.title;
    self.forceNum.num = self.data.heroForce;
    self.profession.text = self.data.career_des;
    self.type_icon:setAltas("common_altas_3", "xui_common_attribute_"..29 + self.data.campType);
    
    local width = self.forceNum:getWidth(1, 1, 20);
    self.zhanli:setLocation(-12 - (self.forceNum.totalWidth - width)/2, 542);
    self.forceNum:setLocation(12 - (self.forceNum.totalWidth - width)/2, 542);

    if self.data.lock_state == true then
        self.lock_btn:setAltas("hero_develop_altas","xui_hb_button_3");
    else
        self.lock_btn:setAltas("hero_develop_altas","xui_hb_button_2");
    end
    
    self:updateShowTabBtnState();  -- 更新页签显示

    --页签点击之后更新
    self:updateUIEnable();
    
    -- 切换页签更新数据
    if self.curPanel ~= nil and self.isSignOpenW ~= true then
        self.curPanel:updateHeroPanelInfo(self.data, false, self.showData);
    end
    
    if self.isSignOpenW then
        self.isSignOpenW = false;
    end
end

-- 动态更新UI显隐状态
function Lua_HeroShowAttributeWindow:updateUIEnable()
    local bStar;--是否显示星星
    local bQuality = true;--是否显示质量
    local bForce;--是否显示战力
    local bRebuild;--是否显示重修
    self:showRedPoint(self.data.bHeroCardRedDot);
    if self.selectTabId == 1 then--属性
        bStar = true;
        bForce = true;
        bRebuild = self.data.isCultivateHero;--是否显示重修
    elseif self.selectTabId == 4 then--皮肤
        bStar = true;
        bForce = false;
        bRebuild = false;
        self:showRedPoint(false);
    elseif self.selectTabId == 6 then--神兵
        bStar = false;
        bQuality = false;
        bForce = false;
        bRebuild = false;
        self:showRedPoint(false);
    else--其他页签
        bStar = true;
        bForce = true;
        bRebuild = false;
    end

    if bStar then
        self:showStarsItem(self.data); -- 显示星级
    else
        self:showStarsItem(nil); -- 显示星级
    end

    self.forceNum:setEnable(bForce);
    if bQuality then
        self.quality_icon:setAltas("common_altas_4", "xui_common_attribute_"..35+self.data.quality);
    end
    self.quality_icon:setEnable(bQuality);
    self.rebuild_btn:setEnable(bRebuild);
end

-- 页签显示状态
function Lua_HeroShowAttributeWindow:updateShowTabBtnState(selectTabId)
    if self.selectBtn ~= nil then -- 首次打开跳转处理
        selectTabId = self.selectBtn;
        self.selectBtn = nil;
    end
    if selectTabId ~= nil then --例：Tips窗口跳转，升级页签跳转到升星页签
        self.selectTabId = nil;
    end

    if self.selectTabId ~= nil  then
        selectTabId =  self.selectTabId;
    end
    local arr;
    local curSelectIdx;
    local curSelectTabId;

    arr,curSelectIdx,curSelectTabId = DataCenter.heroUtil:updateTabInfo(self.data, selectTabId);
    local len = arr:getSize();
    self.tabList.canDrag = len >5;
    local posX = 655-len*118;
    if posX < 64 then
        posX = 64;
    end
    self.tabList:setLocation(posX, 54);
    self.tabList:setArrayData(arr);
    self.tabList:setSelected(curSelectIdx);
    self.tabList:moveToIndex(curSelectIdx);

    -- 选中页签索引发生改变标记
    local data = arr[curSelectIdx];
    if self.selectTabId ~= curSelectTabId then 
        -- if self.selectUId ~= nil then-- 外部打开
        --     self:onTabBtnClick(arr[curSelectIdx]);
        -- else
        --     self:onTabBtnClick(arr[curSelectIdx]);
        -- end
        self:onTabBtnClick(arr[curSelectIdx]);
    else
        if data.id == 3 and data.showRedDotState then -- 升星
            DataCenter.heroData:updateHeroUpStarState(self.data.unique_id, false);
        end
    end
end

-- 页签处理
function Lua_HeroShowAttributeWindow:onTabBtnClick(tabVo)
    if DataCenter.funcOpenData:isOpened(tabVo.openId, true) == false then
        return;
    end

    if tabVo.showGrayState == true then
        OperateAlert.show(tabVo.showTipsDes);
        return;
    end

    if self.selectTabId == tabVo.id then
        return;
    end

    self.selectTabId = tabVo.id;
    if self.selectTabId == 3 and tabVo.showRedDotState then -- 升星
        DataCenter.heroData:updateHeroUpStarState(self.data.unique_id, false);
    end
    self:updateModel()

    local panelName = tabVo.panel;
    if self.panelName ~= panelName then
        if self.curPanel ~= nil then
            self.curPanel:dispose();
            self.curPanel = nil;
        end
        self.panelName = panelName;
        local showPanel = checkRequire(self.panelName);
        
        self.curPanel = showPanel.new(self.content);
    end
    
    if self.selectTabId == 2 or self.selectTabId == 7 then --装备/图腾
        self.profession.fontSize = 26;
        self.profession:setLocation(7,579,0);
    else
        self.profession.fontSize = 28;
        self.profession:setLocation(249,542,0);
    end
    self.curPanel:setRectAnchor(9);
    self.curPanel:updateHeroPanelInfo(self.data, false, self.showData);
    
    self.bSwitch = false;
    self:updateObject(tabVo.id);
end

function Lua_HeroShowAttributeWindow:updateObject(selectTabId)
    local bUpObj;--上吸附UI
    local bDownObj;--下吸附UI
    local showBtn;--按钮显示
    if selectTabId == 4 then
        showBtn = false;
        bUpObj = true;
        bDownObj = false;
    elseif selectTabId == 6 then
        showBtn = false;
        bUpObj = false;
        bDownObj = false;        
    else
        bUpObj = true;
        showBtn = true;
        bDownObj = selectTabId ~= 4;
    end
    -- self.skin_btn:setEnable(showBtn);
    self.lock_btn:setEnable(showBtn);
    -- self.share_btn:setEnable(showBtn);
    self.comment_btn:setEnable(showBtn);
    self.rebuild_btn:setEnable(showBtn);
    self.introduce_btn:setEnable(showBtn);

    self.up_obj:SetActive(bUpObj);
    self.down_obj:SetActive(bDownObj);
    self:updateUIEnable();
end

function Lua_HeroShowAttributeWindow:onSubBtnClick()
    if self.modelScenePanel == nil or self.modelScenePanel:checkShowComplete() ~= true then 
        return;
    end

    if self.showArr == nil then
        return;
    end

    if self.showIdx <= 1 then
        return;
    end

    self.bSwitch = true

    self.showIdx = self.subShowIdx;
    self:updateShowHeroInfo();
    self:updateModel();
    self:onPlayLinesSound()
end

function Lua_HeroShowAttributeWindow:onAddBtnClick()
    if self.modelScenePanel == nil or self.modelScenePanel:checkShowComplete() ~= true then 
        return;
    end

    if self.showArr == nil then
        return;
    end

    local len = self.showArr:getSize();
    if self.showIdx >= len then
        return;
    end
    
    self.bSwitch = true
    self.showIdx = self.addShowIdx;
    self:updateShowHeroInfo();
    self:updateModel();
    self:onPlayLinesSound()
end

--数据更新
function Lua_HeroShowAttributeWindow:updateShowHero(uid)
    if self.data.unique_id == uid then
        self:updateShowHeroInfo();
    end
end

--英雄删除/增加，更新一次展示列表数据，确保左右切换页签数据的正确
function Lua_HeroShowAttributeWindow:updateShowArr()
    if self.selectUId ~= nil then --外部打开，不再更新列表数据
        return;
    end
    DataCenter.heroData:sortHeroInfo();
    self.showArr, self.showIdx = DataCenter.heroData:getPackAllInfoByCampType(self.selectSiftType, self.careerType, self.data.unique_id);
    self:updateTabState();
end

function Lua_HeroShowAttributeWindow:updateModel()
    if self.selectTabId == 6 then
        local weaponId = self.data.weaponId
        if self.data.weapon_id > 0 then
            weaponId = self.data.weapon_id
        end
        local vo = DataCenter.heroUtil:getHeroWeaponVo(weaponId);
        self:showHeroMondel(vo)
    else
        self:showHeroMondel(self.data);-- 模型展示
    end
end

--更新页签状态
function Lua_HeroShowAttributeWindow:updateTabState()
    local len = self.showArr:getSize();
    if len == 1 then
        self.sub_btn:setEnable(false);
        self.add_btn:setEnable(false);
    else
        if self.showIdx == 1 then
            self.sub_btn:setEnable(false);
            self.add_btn:setEnable(true);
        elseif self.showIdx == len then
            self.sub_btn:setEnable(true);
            self.add_btn:setEnable(false);
        else
            self.sub_btn:setEnable(self.subShowIdx > 0);
            self.add_btn:setEnable(self.addShowIdx <= len);
        end
    end
end

--获取上个英雄的展示索引
function Lua_HeroShowAttributeWindow.Get:subShowIdx()
    local showIdx = self.showIdx;
    while showIdx > 0 do
        showIdx = showIdx -1;
        if showIdx ~= 0 and not self:bTransactionHero(showIdx) then
            return showIdx;
        end 
    end

    return 0;
end

--获取下个英雄的展示索引
function Lua_HeroShowAttributeWindow.Get:addShowIdx()
    local showIdx = self.showIdx;
    local len = self.showArr:getSize();
    while showIdx <= len do
        showIdx = showIdx + 1;
        if showIdx <= len and not self:bTransactionHero(showIdx) then
            return showIdx;
        end 
    end
    return showIdx;
end

--是否是交易英雄
function Lua_HeroShowAttributeWindow:bTransactionHero(showIdx)
    local unique_id = self.showArr[showIdx].unique_id;
    if unique_id ~= nil then
        local data = DataCenter.heroData:getItemByUniqueId(unique_id);
        if data ~= nil then
            return data.is_league_transaction;
        end
    end
end

-- 上锁
function Lua_HeroShowAttributeWindow:onLockBtnClick()
    if self.data.lock_state == false then
        OperateAlert.showLangValue(126078);
        Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroLock(self.data.unique_id, 1);
    else
        OperateAlert.showLangValue(126079);
        Lua_ProxyManager.getProxy("Lua_HeroProxy"):sHeroLock(self.data.unique_id, 0);
    end
end

-- 克制描述
function Lua_HeroShowAttributeWindow:onCompBtnClick()
    Lua_WindowUtil.openWin("Lua_HeroCampDesTipsWindow", Lua_WinParam.ACTION_OPEN, {des = DataCenter.heroUtil:getCampDic(self.data.campType), pos = {0, 520 + self.adaptHeight/2}});
end

function Lua_HeroShowAttributeWindow:onQualityBtnClick()
    Lua_WindowUtil.openWin("Lua_HeroCampDesTipsWindow", Lua_WinParam.ACTION_OPEN, {des = LanUtil.getValue(126068 + self.data.quality), pos = {0, 520 + self.adaptHeight/2}});
end

--传记
function Lua_HeroShowAttributeWindow:onIntroduceBtnClick()
    if not DataCenter.funcOpenData:isOpened(10239, true) then
        return
    end

    if not DataCenter.collectionBookUtil:checkCompletedCardByHeroId(self.data.id) then
        OperateAlert.showLangValue(126063);
        return
    end
    Lua_WindowUtil.openWin("Lua_CollectionBookShowHeroChannelWindow", Lua_WinParam.ACTION_OPEN, self.data.cardList);
end

--评论
function Lua_HeroShowAttributeWindow:onCommentBtnClick()
    Lua_WindowUtil.openWin("Lua_HeroCommentWindow", Lua_WinParam.ACTION_OPEN, self.data);
end

--重修
function Lua_HeroShowAttributeWindow:onRebuildBtnClick()
    if self.data.is_resonance == true then
        self:showttips();
        return;
    elseif self.data.trial_state then
        OperateAlert.showLangValue(760206);
        return;
    end
    Lua_WindowUtil.openWin("Lua_HeroRebuildWindow", Lua_WinParam.ACTION_OPEN, self.data);
end

function Lua_HeroShowAttributeWindow:showttips()
    local tipData = {
        h = 443, font_size = 26, des = LanUtil.getValue(126919), posY = 44,
        btnType = 1, owner = self, sureFun = self.sendDemount
    };
    Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipData);
end

--从同调器中卸下
function Lua_HeroShowAttributeWindow:sendDemount()
    local grid_id = DataCenter.lifeTreeData:getGridIdByUid(self.data.unique_id);
    if grid_id == 0 then
        return;
    end
    Lua_ProxyManager.getProxy("Lua_LifeTreeProxy"):sDemountHero(grid_id);
end

-- 检测引导数据
function Lua_HeroShowAttributeWindow:checkWinGuide()
    self:superCall("checkWinGuide");
end

-- 引导同步
function Lua_HeroShowAttributeWindow:updateGuide(guideId, info)
    if info == nil or self.data == nil then
        return;
    end
    local operateVal = info.operateVal; -- 操作行为参数
    if operateVal == nil then
        return;
    end

    local heroLevel = info.heroLevel ~= nil and tonumber(info.heroLevel) or 1;
    if operateVal == 1 then -- 升级到特定等级
        Lua_MsgUtil.callFunc("Guide_UpHeroGrade_Panel", heroLevel);
        Lua_CommonUtil.delayCall(0.1, self, self.delayUpdateGuideData, guideId);
    elseif operateVal == 2 then -- 指定页签
        local tabNum = info.tabNum or 1;
        local item = self.tabList.showDragDataList:getItem(tabNum).cell;
        if item ~= nil then
            if self.selectTabId ~= nil and self.selectTabId == tabNum then
                DataCenter.guideCommonData.winGuideResult = 1;
            else
                item:checkCellPressInGuide(true, guideId);
            end
            DataCenter.guideCommonData.guideClickObjTarget = item.content;
            DataCenter.guideCommonData.guideSceneId = nil; -- 场景
            Lua_MsgUtil.callFunc("Guide_WinSync_Complete", guideId);
        end
    end
end

function Lua_HeroShowAttributeWindow:delayUpdateGuideData(guideId)
    DataCenter.guideCommonData.guideSceneId = nil; -- 场景
    DataCenter.guideCommonData.guideClickObjPath = "content/Lua_HeroAttributePanel/upgrade_btn";
    Lua_MsgUtil.callFunc("Guide_WinSync_Complete", guideId);
end

function Lua_HeroShowAttributeWindow:dispose()
    if self.tabInfo ~= nil then
        self.tabInfo:dispose();
        self.tabInfo:clear();
        self.tabInfo = nil;
    end

    if self.curPanel ~= nil then
        self.curPanel:dispose();
        self.curPanel = nil;
    end

    if self.redDotEff ~= nil then
        self.redDotEff:dispose();
        self.redDotEff = nil;
    end

    self.data = nil;
    self.showArr = nil;
    self.panelName = nil;
    if Lua_WindowUtil.isWindowShowing("Lua_HeroAttrAnimationWindow") then
        Lua_WindowUtil.openWin("Lua_HeroAttrAnimationWindow", Lua_WinParam.ACTION_CLOSE);
    end
    
    if self.showModelEff ~= nil then
        self.showModelEff:dispose();
        self.showModelEff = nil;
    end
    self.uplist = nil;
    self.up_hvo = nil;
    Lua_CommonUtil.removeTimer(self, self.onOpenUpStarSucceedWindow);

    self:superCall("dispose");
    Lua_MsgUtil.callFunc("ENFORCE_UPDATA_HERO_PANEL");
end

--英雄升星成功特效展示
function Lua_HeroShowAttributeWindow:updateUpStarSucceedInfo(msg)
    if msg == nil then
        return
    end
    
    self.uplist = {};
    local info = msg.prop;
    local base_attr = DataCenter.heroUtil.hero_base_attr;
    for i = 1, #info do
        self.uplist[info[i].name] = info[i].value;
    end

    local uid = tonumber(msg.uid);
    self.up_hvo = DataCenter.heroData:getItemByUniqueId(uid);

    self:showUpStarEff();
    Lua_CommonUtil.delayCall(2, self, self.onOpenUpStarSucceedWindow);
end

function Lua_HeroShowAttributeWindow:showUpStarEff()
    if self.uiSceneId ~= self.data.uiSceneId then
        self.uiSceneId = self.data.uiSceneId;
        local modelUrl = "/effects/scsEffects/yingxiong_shengxing_01";
        local url = UrlManager.fixFileSuffix(modelUrl);
        self.showModelEff = ModelEffComponent(self.data.uiSceneId, 0);
        self.showModelEff:setFullUrl(url, "yingxiong_shengxing_01", "yingxiong_shengxing_01", nil);
    else
        if self.showModelEff ~= nil then
            self.showModelEff:setEnable(false);
            self.showModelEff:setEnable(true);
        end
    end
end

function Lua_HeroShowAttributeWindow:onOpenUpStarSucceedWindow()
    if self.uplist == nil then
        return
    end
    Lua_WindowUtil.openWin("Lua_HeroUpStarSucceedWindow", Lua_WinParam.ACTION_OPEN, {data = self.up_hvo, attrDic = self.uplist});
    self.uplist = nil;
    self.up_hvo = nil;
end