-- 英雄展示 基类
Lua_HeroShowBaseWindow = class("Lua_HeroShowBaseWindow", Lua_Window);
function Lua_HeroShowBaseWindow:ctor()
    self:superCall("ctor");
    
    self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
    self.windowName = "Lua_HeroShowBaseWindow";
    self.skinName = "HeroShowBaseWindow_skin";
    self.isFullSizeWin = true;
    self.isSingleShowWin = true;
    self.showBackBtn = true;
end

function Lua_HeroShowBaseWindow:buildPanel(go)
    self:superCall("buildPanel", go);
    self:addLuaEvent("UPDATE_HERO_MODEL", self, self.showHeroMondel);
end

function Lua_HeroShowBaseWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.backBtn:setParent(self.buttomObj);

    self.forceNum = Lua_NumberImage.new(self.down_obj);
    self.forceNum:setRectAnchor(7);
    self.forceNum.pivot = 1;
    self.forceNum.preStr = "xui_zl1_number_0";
    self.forceNum.numOffsetX = -1;
    self.forceNum.num = 0;
end

function Lua_HeroShowBaseWindow:showStarsItem(data) -- 显示星
    if self.starArr ~= nil then
        for i = 1, self.starArr:getSize() do
            self.starArr[i]:setEnable(false);
        end
    end

    if data ~= nil and data.quality <= 4 and data.quality_star > 0 then
        if self.starArr == nil then
            self.starArr = Array();
        end
        local item;
        local starWidth = 44;
        local star = data.quality_star;
        for i = 1, star do
            item = self.starArr[i];
            if item == nil then
                item = UICreate.createUIAtlasImage(self.up_obj, "common_altas_4", "xui_common_label_15", 0, 0, 0, 0);
                item:setAnchorMax(0.5,1);
                item:setAnchorMin(0.5,1);
                self.starArr:add(item);
            end

            item:setEnable(true);
            item:setLocation(-1 * starWidth * star / 2 + starWidth * (i-1) + starWidth / 2 + 9, -103, 0);
        end
    end
    self:showEffect(data);
end

function Lua_HeroShowBaseWindow:showEffect(data)
    if self.effectArr ~= nil then
        for i = 1, self.effectArr:getSize() do
            self.effectArr[i]:setEnable(false);
        end
    end

    if data ~= nil and data.quality ~= nil and data.quality >= 5  then
        if self.effectArr == nil then
            self.effectArr = Array();
        end
        local effect;
        local starWidth = 40;
        local star = data.quality_star;
        for i = 1, star do
            effect = self.effectArr[i];
            if effect == nil then
                effect = UICreate.createModelEffImg(self.up_obj, "/effects/scsEffects/yinxiong_fire", "yinxiong_fire", 0, 0, 250, 250);
                effect:setCamField(100, 1, 100, true);
                effect:setAnchorMax(0.5,1);
                effect:setAnchorMin(0.5,1);
                self.effectArr:add(effect);
            end
            effect:setEnable(true);
            effect:setLocation(-1 * starWidth * star / 2 + starWidth * (i-1) + starWidth / 2 + 9, -115, 0);
        end
    end
end

function Lua_HeroShowBaseWindow:showHeroMondel(data)
    if self.uiModelUrl == data.uiModelUrl and self.modelScenePanel.bShowModel == true then
        return
    end
    self.uiModelUrl = data.uiModelUrl;
    
    if self.modelScenePanel == nil then
        self.modelScenePanel = Lua_ModelScenePanel.new();
        self.modelScenePanel:setParent(self.content);
        self.modelScenePanel:setRotBgPos(0, 189);
        self.modelScenePanel:setRotBgDimensions(720, 815 + self.adaptHeight);
        self.modelScenePanel:setClick(self, self.onPlayLinesSound);
    end
    self.modelScenePanel:setFurEffShow(data.bShowFur);

    -- 预加载已初始化第一次
    if self._bEnterFirst or not self.modelScenePanel.bShowModel then
        self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UISHOW, data.showActEffs);
        self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UIWAIT, data.poseActEffs);
        self.modelScenePanel:showModelScene(data.uiSceneId, data.uiModelUrl, data.uiModelAvatarName, data.uiModelCamController);
        self.modelScenePanel:setModelAct(data.uiShowAct, Lua_ThingDefine.UIWAIT, true);
    end

    -- 修改朝向
    self._bEnterFirst = true;
    self.modelScenePanel:setModelDir(data.uiModelDir);
    self.modelScenePanel:setModelScale(data.uiModelScale);
end

function Lua_HeroShowBaseWindow:showWin(param)
    self:superCall("showWin", param);
    if param ~= nil and param.modelScenePanel ~= nil then -- 模型展示界面
        if self.modelScenePanel ~= nil and self.modelScenePanel ~= param.modelScenePanel then
            self.modelScenePanel:dispose();
            self.modelScenePanel = nil;
        end
        
        self.modelScenePanel = param.modelScenePanel;
        self.modelScenePanel:setParent(self.content);
        self.modelScenePanel:setRotBgPos(0, 189);
        self.modelScenePanel:setRotBgDimensions(720,815+self.adaptHeight);
        self.modelScenePanel:setClick(self, self.onPlayLinesSound);
        param.modelScenePanel = nil;
    end
end

function Lua_HeroShowBaseWindow:onPlayLinesSound()
    if self.data == nil then
        return;
    end
    if DataCenter.audioManager:isPlayingById(self.data.lineSound) then
        return;
    end
    local startTime = self:getLineStartTime(self.data.lineSound);
    if getTime() - startTime < DataCenter.heroUtil.play_line_interval then
        return;
    end
    DataCenter.audioManager:play(self.data.lineSound);
    self:setLineStartTime(self.data.lineSound);
end

function Lua_HeroShowBaseWindow:setLineStartTime(lineSound)
    if self.lineSoundDic == nil then
        self.lineSoundDic = {};
    end
    self.lineSoundDic[lineSound] = getTime();
end

function Lua_HeroShowBaseWindow:getLineStartTime(lineSound)
    if self.lineSoundDic == nil or self.lineSoundDic[lineSound] == nil then
        return 0;
    end
    return self.lineSoundDic[lineSound];
end

function Lua_HeroShowBaseWindow:dispose()
    DataCenter.audioManager:stopByPlayerId(Lua_AudioDefine.PLAYER_NPC, true);
    self.lineSoundDic = nil;

    if self.forceNum ~= nil then
        self.forceNum:dispose();
        self.forceNum = nil;
    end
    -- if self.starArr ~= nil then
    --     for k,v in pairs(self.starArr) do
    --         v:dispose();
    --         v = nil;
    --     end
    --     self.starArr = nil;
    -- end
    if self.starArr ~= nil then
        self.starArr:dispose();
        self.starArr:clear();
        self.starArr = nil;
    end

    if self.effectArr ~= nil then
        self.effectArr:dispose();
        self.effectArr:clear();
        self.effectArr = nil;
    end
    
    if self.modelScenePanel ~= nil then
        self.modelScenePanel:dispose();
        self.modelScenePanel = nil;
    end

    if self.redPointIcon ~= nil then
        self.redPointIcon:dispose();
        self.redPointIcon = nil;
    end

    self:superCall("dispose");
end

function Lua_HeroShowBaseWindow:showRedPoint(bShow)
    if bShow then
        if self.redPointIcon == nil then
            self.redPointIcon = Lua_RedPointIcon.new(self.content);
            self.redPointIcon:setRectAnchor(1);
            self.redPointIcon:setLocation(330, -92);
            self.redPointIcon:createRedPointEff();
        end
        self.redPointIcon:updateRedPointShow(true);
    else
        if self.redPointIcon ~= nil then
            self.redPointIcon:updateRedPointShow(false);
        end
    end
end

function Lua_HeroShowBaseWindow:resetActive(bActive)
    self:superCall("resetActive", bActive);
    if bActive then -- 显示
        if self.data ~= nil then
            self:showHeroMondel(self.data);
        end
    else
        if self.modelScenePanel ~= nil then
            self.modelScenePanel:dispose();
            self.modelScenePanel = nil;
            self.uiModelUrl = nil;
        end
    end
end