--英雄tips
checkRequire("Lua_HeroSkillItem"); --英雄技能 Item 
Lua_HeroTipsWindow = class("Lua_HeroTipsWindow", Lua_Window);
function Lua_HeroTipsWindow:ctor()
    self:superCall("ctor");
    self.windowName = "Lua_HeroTipsWindow";
    self.skinName = "HeroTipsWindow_skin";
    self.showBlackMask = true;
    self.isClickClose = true;
end

function Lua_HeroTipsWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.heroItemIcon = Lua_HeroItemIcon.new(self.content);
    self.heroItemIcon:setLocation(-218, 404, 0);

    self.forceNum = Lua_NumberImage.new(self.content);
	self.forceNum:setLocation(-84, 420, 0);
	self.forceNum.pivot = 1;
	self.forceNum.numAtlas = "number";
	self.forceNum.preStr = "xui_zl1_number_0";

	self.propList = Lua_DragList.new(self.content, 421, 83, Lua_AxisDefine.Vertical);
	self.propList:setListCell(Lua_HeroTipAttributeItem, 206, 36, 2);
	self.propList:setCellSpacing(9, 10);
	self.propList:setLocation(78, 343);

	self.itemList = Lua_DragContainer.new(self.content, 636, 748, Lua_AxisDefine.Vertical);
	self.itemList:setLocation(-3, 255, 0);
	self.itemList:setCellSpacing(0, 9);
	self.itemList:setRectPivot(1);
	self.itemList:setRectAnchor(1);

	self.attr_btn:addClickFuntion(self, self.attrBtnClick);--详情属性
	self.comment_btn:addClickFuntion(self, self.commentBtnClick);--评论
end

function Lua_HeroTipsWindow:showWin(param)
	self:superCall("showWin",param);--param = 英雄vo
	if self.isWindowShowing == true then
		return;
	end

	DataCenter.heroData.showTipHeroVo = param;
	self.isWindowShowing = true;
	self:showTipsInfo(param);
	self:showDetailInfo();
end

-- 展示
function Lua_HeroTipsWindow:showTipsInfo(hvo)
	self.name.text = hvo.name;
	self.forceNum.num = hvo.heroForce;
	self.profession.text = hvo.career_des;

	self.heroItemIcon:setData(hvo);
	self.heroItemIcon:showFightIcon(false);

	self:showAttr(hvo.heroPropVo.heroPropInfo);--属性
end

-- 属性展示
function Lua_HeroTipsWindow:showAttr(info)
	local len = info:getSize(); 
	self.propList.canDrag = len > 4;
	self.propList:setArrayData(info);
end

function Lua_HeroTipsWindow:showDetailInfo()
	local list = DataCenter.heroUtil:getHeroTipIds();
	for i = 1, #list do
		self.itemList:addSubContainer(Lua_HeroTipAttributeDragItem, list[i], false);
	end
	self.itemList:updateChildPos();
end

function Lua_HeroTipsWindow:attrBtnClick()
	Lua_WindowUtil.openWin("Lua_HeroAllAttributeWindow", Lua_WinParam.ACTION_OPEN,{data = self.showData});
end

function Lua_HeroTipsWindow:commentBtnClick()
	Lua_WindowUtil.openWin("Lua_HeroCommentWindow", Lua_WinParam.ACTION_OPEN, self.showData);
end

function Lua_HeroTipsWindow:dispose()
	DataCenter.heroData.showTipHeroVo = nil;
	if self.forceNum ~= nil then
		self.forceNum:dispose();
		self.forceNum = nil;
	end
	if self.heroItemIcon ~= nil then
		self.heroItemIcon:dispose();
		self.heroItemIcon = nil;
	end
	if self.propList ~= nil then
		self.propList:dispose();
		self.propList = nil;
	end
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
    self:superCall("dispose");
end










-- 英雄属性item
Lua_HeroTipAttributeItem = class("Lua_HeroTipAttributeItem", Lua_ListCell);
function Lua_HeroTipAttributeItem:ctor(p)
	self:superCall("ctor", p, "HeroTipAttributeItem_skin");
end

function Lua_HeroTipAttributeItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_HeroTipAttributeItem:setData(data)
    if data == nil then
    	return;
    end

    self.attr_value.text = data.showValue;
    self.attr_icon:setAltas("common_altas_2", data.attr_icon_2);
end

function Lua_HeroTipAttributeItem:dispose()
    self:superCall("dispose");
end











Lua_HeroTipAttributeDragItem = class("Lua_HeroTipAttributeDragItem", Lua_DragContainerItem);
function Lua_HeroTipAttributeDragItem:ctor(p)
	self:superCall("ctor", p, "HeroTipAttributeDragItem_skin");
end

function Lua_HeroTipAttributeDragItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_HeroTipAttributeDragItem:dispose()
	if self.skillItems ~= nil then
		for i = 1, #self.skillItems do
			self.skillItems[i]:dispose();
			self.skillItems[i] = nil;
		end
		self.skillItems = nil;
	end
	if self.showItems ~= nil then
		for i = 1, #self.showItems do
			self.showItems[i]:dispose();
			self.showItems[i] = nil;
		end
		self.showItems = nil;
	end
	self:superCall("dispose");
end

function Lua_HeroTipAttributeDragItem:setData(data)
	self.type = data;
	if data == nil then
		return;
	end

	local cfg = getConfig("hero_tip_desc", self.type);
	if cfg == nil then
		return;
	end

	self.nameTxt.text = cfg.name;
	self:updateItems(cfg);
end

function Lua_HeroTipAttributeDragItem:updateItems(cfg)
	self.noneTxt.text = nil;
	self.splitSp:setEnable(false);
	if self.type == 1 then -- 技能
		self:showSkills(cfg);
	elseif self.type == 2 then -- 装备
		self:showEquips(cfg);
	elseif self.type == 3 then -- 图腾
		self:showTotems(cfg);
	elseif self.type == 4 then -- 天赋
		self:showTalents(cfg);
	elseif self.type == 5 then -- 符石
		self:showRunes(cfg);
	end

	self:getItemAngBgHeight(cfg);
end

function Lua_HeroTipAttributeDragItem:showSkills(cfg)
	self.itemObj:SetActive(false);
	self.skillObj:SetActive(true);

	local heroVo = DataCenter.heroData.showTipHeroVo;
	if heroVo == nil then
		return;
	end

	if self.skillItems == nil then
		self.skillItems = {};
	end

	local item;
	local obj = heroVo.heroSkillInfo;
	local len = obj ~= nil and #obj or 0;
	local bConnect = heroVo.connectId > 0;

	local distanceX;
	local startPosX;
	local itemScale = cfg.scale ~= nil and cfg.scale or 1;
	local special_setting = cfg.special_setting;
	if bConnect then
		distanceX = special_setting ~= nil and special_setting[1] ~= nil and special_setting[1][2] or 0;
		startPosX = special_setting ~= nil and special_setting[1] ~= nil and special_setting[1][1] or 0;
	else
		distanceX = special_setting ~= nil and special_setting[2] ~= nil and special_setting[2][2] or 0;
		startPosX = special_setting ~= nil and special_setting[2] ~= nil and special_setting[2][1] or 0;
	end
	startPosX = -(len - 1) * distanceX / 2 + startPosX;
	for i = 1, len do
		item = self.skillItems[i];
		if item == nil then
			item = Lua_HeroSkillItem.new(self.skillObj);
			self.skillItems[i] = item;
		end

		posX = startPosX + (i - 1) * distanceX;
		item:setLocation(posX, 2);
		item:setScale(itemScale, itemScale);
		item:setData(obj[i]);
		item:setEnable(true);
	end

	if bConnect then
		len = len + 1;
		item = self.skillItems[len];
		if item == nil then
			item = Lua_HeroSkillItem.new(self.skillObj);
			self.skillItems[len] = item;
		end

		local posX = special_setting ~= nil and special_setting[3] ~= nil and special_setting[3][1] or 0;
		local posY = special_setting ~= nil and special_setting[3] ~= nil and special_setting[3][2] or 0;
		item:setLocation(posX, posY);
		item:setScale(itemScale, itemScale);
		item:setConnectData(heroVo);
		item:setEnable(true);

		self.splitSp:setEnable(true);
	end

	if len < #self.skillItems then
		for i = len + 1, #self.skillItems do
			item = self.skillItems[i];
			if item ~= nil then
				item:setEnable(false);
			end
		end
	end
end

function Lua_HeroTipAttributeDragItem:showEquips(cfg)
	self.itemObj:SetActive(true);
	self.skillObj:SetActive(false);

	local heroVo = DataCenter.heroData.showTipHeroVo;
	if heroVo == nil then
		return;
	end

	if self.showItems == nil then
		self.showItems = {};
	end

	local item;
	local startPosX = cfg.start_pos_x or 0;
	local distanceX = cfg.distance or 0;
	local itemScale = cfg.scale or 1;
	local obj = heroVo.equipTipsInfo;
	local len = cfg.show_num or 4;
	for i = 1, len do
		item = self.showItems[i];
		if item == nil then
			item = Lua_ItemIcon.new(self.itemObj);
			item:setCanClick(true);
			self.showItems[i] = item;
		end

		if obj[i] == nil then
			item:setData(nil);
			item:setShadow(true, "hero_equip_altas", DataCenter.equipUtil:getEquipShadow(i, 2));
			item:setIconBg("common_altas_1", "xui_common_itembg_0");
		else
			item:setShadow(false);
			item:setData(obj[i]);
		end
		posX = startPosX + (i - 1) * distanceX;
		item:setScale(itemScale, itemScale);
		item:setLocation(posX, 0);
		item:setEnable(true);
	end

	if len < #self.showItems then
		for i = len + 1, #self.showItems do
			item = self.showItems[i];
			if item ~= nil then
				item:setEnable(false);
			end
		end
	end
end

function Lua_HeroTipAttributeDragItem:showRunes(cfg)
	self.itemObj:SetActive(true);
	self.skillObj:SetActive(false);

	local heroVo = DataCenter.heroData.showTipHeroVo;
	if heroVo == nil then
		return;
	end

	if self.showItems == nil then
		self.showItems = {};
	end

	local item;
	local startPosX = cfg.start_pos_x or 0;
	local distanceX = cfg.distance or 0;
	local itemScale = cfg.scale or 1;
	local obj = heroVo.runsTipsInfo;
	local len = cfg.show_num or 4;
	for i = 1, len do
		item = self.showItems[i];
		if item == nil then
			item = Lua_ItemIcon.new(self.itemObj);
			item:setCanClick(true);
			self.showItems[i] = item;
		end

		posX = startPosX + (i - 1) * distanceX;
		if obj[i] == nil then
			item:setData(nil);
			item:setShadow(true, "common_altas_4", "ui_zb_icon_02");
			item:setIconBg("common_altas_1", "xui_common_itembg_0");
		elseif type(obj[i]) == "number" then
			tvo = DataCenter.runesData:getRunesVoByUid(obj[i]) or {};
			item:setData(tvo);
			item:setShadow(false);
			item:showText(4, nil);
		else
			item:setShadow(false);
			item:setData(obj[i]);
		end
		item:setScale(itemScale, itemScale);
		item:setLocation(posX, 0);
		item:setEnable(true);
	end

	if len < #self.showItems then
		for i = len + 1, #self.showItems do
			item = self.showItems[i];
			if item ~= nil then
				item:setEnable(false);
			end
		end
	end
end

function Lua_HeroTipAttributeDragItem:showTotems(cfg)
	self.itemObj:SetActive(true);
	self.skillObj:SetActive(false);

	local heroVo = DataCenter.heroData.showTipHeroVo;
	if heroVo == nil then
		return;
	end

	local hasTotem = heroVo.recoTotemSuit;-- 图腾系统
	if hasTotem == nil then
		self.noneTxt:setLangValue(126080);
		self.itemObj:SetActive(false);
		return;
	end

	if self.showItems == nil then
		self.showItems = {};
	end

	local totemDir = {};
	local info = heroVo.totem_info;
	local obj = info ~= nil and info.totem_item;
	if obj ~= nil then
		for i = 1, #obj do
			tvo = Lua_ToolVo.createToolVo(tonumber(obj[i].id));
			tvo:fromServer(obj[i]);
			totemDir[tvo.part] = tvo;
		end
	end

	local item;
	local startPosX = cfg.start_pos_x or 0;
	local distanceX = cfg.distance or 0;
	local itemScale = cfg.scale or 1;
	local len = cfg.show_num or 4;
	for i = 1, len do
		item = self.showItems[i];
		if item == nil then
			item = Lua_ItemIcon.new(self.itemObj);
			item:setCanClick(true);
			self.showItems[i] = item;
		end

		posX = startPosX + (i - 1) * distanceX;
		if totemDir[i] == nil then
			item:setData(nil);
			item:setShadow(true, "friend_altas_2", "xui_zldb_label_4");
			item:setIconBg("common_altas_1", "xui_common_itembg_0");
		else
			item:setShadow(false);
			item:setData(totemDir[i]);
		end
		item:setScale(itemScale, itemScale);
		item:setLocation(posX, 0);
		item:setEnable(true);
	end

	if len < #self.showItems then
		for i = len + 1, #self.showItems do
			item = self.showItems[i];
			if item ~= nil then
				item:setEnable(false);
			end
		end
	end
end

function Lua_HeroTipAttributeDragItem:showTalents(cfg)
	local heroVo = DataCenter.heroData.showTipHeroVo;
	if heroVo == nil then
		return;
	end


	local hasTalents = DataCenter.heroGeniusData:checkExistGenius(heroVo.id);
	self.itemObj:SetActive(false);
	if hasTalents then
		self.skillObj:SetActive(true);
		self.noneTxt.text = nil;
	else
		self.skillObj:SetActive(false);
		self.noneTxt:setLangValue(126081);
		return;
	end
	
	if self.skillItems == nil then
		self.skillItems = {};
	end

	local talentData = heroVo.geniusSkill or {}; 
	local obj = {};
	local index;
	for i = 1, #talentData do 
		index = tonumber(talentData[i].key);
		obj[index] = talentData[i];
	end

	local item;
	local startPosX = cfg.start_pos_x or -149;
	local distanceX = cfg.distance or 127;
	local itemScale = cfg.scale or 0.9;
	local len = cfg.show_num or 4;
	local skillVo;
	local skillId;
	for i = 1, len do
		item = self.skillItems[i];
		if item == nil then
			item = Lua_HeroSkillItem.new(self.skillObj);
			self.skillItems[i] = item;
		end

		if obj[i] == nil then
			item:setData(nil);
			item:setShowLevel(false);
			item:setSkillIcon("common_altas_4", "xui_hy_window_9");
			item:setSkillBg("common_altas_4", "xui_hy_window_8");
		else
			skillId = tonumber(obj[i].value);
			skillVo = Lua_HeroSkillVo.new(i);
			skillVo.skill_id = skillId;
			skillVo.skill_level = self:getTalentSkillIdx(skillId, i);
			item:setData(skillVo);
			item:setShieldSkillWinLvl(true);
		end
		posX = startPosX + (i - 1) * distanceX;
		item:setScale(itemScale, itemScale);
		item:setLocation(posX, 0);
		item:setEnable(true);
	end

	if len < #self.skillItems then
		for i = len + 1, #self.skillItems do
			item = self.skillItems[i];
			if item ~= nil then
				item:setEnable(false);
			end
		end
	end
end

function Lua_HeroTipAttributeDragItem:getTalentSkillIdx(skillId, index)
	local heroVo = DataCenter.heroData.showTipHeroVo;
	if heroVo == nil then
		return;
	end

	local arr = DataCenter.heroGeniusData:getHeroGeniusList(heroVo.id);
	if arr ~= nil and arr:getSize() >= index then
		local list = DataCenter.heroGeniusData:getGeniusConfig(arr[index]);
		list = list and list.skill_list or {};
		for i = 1, #list do
			if list[i] == skillId then
				return i;
			end
		end
	end
	return 0;
end

function Lua_HeroTipAttributeDragItem:getItemAngBgHeight(cfg)
	local height = cfg.bg_height or 115;
	local ratioHeight = 115;
	local distanceHeight = height - ratioHeight or 0;
	self.itemHeight = 128 + distanceHeight;
	self.itemBg:SetDimensions(549, height);
end

function Lua_HeroTipAttributeDragItem:getWidth()
    return 623;
end

function Lua_HeroTipAttributeDragItem:getHeight()
    return self.itemHeight;
end