--英雄系统主界面
checkRequire("Lua_HeroPanel");--英雄
checkRequire("Lua_HeroAtlasPanel");--英雄图鉴
checkRequire("Lua_HeroHeatPanel"); --英雄热度
Lua_HeroWindow = class("Lua_HeroWindow", Lua_Window);
function Lua_HeroWindow:ctor()
	self:superCall("ctor");
	self.layer = MainWinDefine.MAIN_WINDOW_LAYER;
	self.isFullSizeWin = true;
	self.showWinBg = true;
	self.winBgPath = "/images/common/xui_common_bg_001.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self.showClose = false;
	self.showBackBtn = false;--显示返回按键
	self.titleSprite = "fonts_1_002";
	self.windowName = "Lua_HeroWindow";
	self.skinName = "HeroWindow_skin";
	self.openSound = "bgm_zhucheng";
	self.closeSound = nil;
end

function Lua_HeroWindow:resetActive(bActive)
	self:superCall("resetActive", bActive);
	if bActive then
		DataCenter.audioManager:play(self.openSound);
	end
end

function Lua_HeroWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.panelObjTab = {};
	
	self.tabInfo = Array();
    self.tabInfo:add({textStr = LanUtil.getValue(126000), tagType = Lua_HeroUtil.HERO_TYPE, panel = Lua_HeroPanel, redPointId = Lua_RedPointList.HeroTab, title_img = "/images/hero/xui_hb_bg_001.jpg"});
    self.tabInfo:add({textStr = LanUtil.getValue(126001), tagType = Lua_HeroUtil.ATLAS_TYPE, panel = Lua_HeroAtlasPanel, redPointId = Lua_RedPointList.HeroAtlas, title_img = "/images/hero/xui_hb_bg_001.jpg"});
    self.tabInfo:add({textStr = LanUtil.getValue(126350), tagType = Lua_HeroUtil.HRAT_TYPE, panel = Lua_HeroHeatPanel, redPointId = Lua_RedPointList.HeroHeat, title_img = "/images/hero/xui_rdb_bg_1.jpg"});

    self.btnList = Lua_ButtonList.new(self.content, Lua_AxisDefine.Horizontal);
    self.btnList:setRectAnchor(7)
    self.btnList:setLocation(0, 160, 0);
    self.btnList:setButtonItem(229, 66);
    self.btnList:setRedPoint(79, 26);
    self.btnList:setButtonStyle("common_altas_1","xui_common_button_005_n","xui_common_button_004_n",204,66);
    self.btnList:setButtonText(0, 0, "756150", "8f5123", 34, 34, Lua_MyUISettings.huakangFontName, UnityEngine.FontStyle.Normal);
    self.btnList:setClickCallBack(self, self.onTabBtnClick);
    self.btnList:setData(self.tabInfo);

    self:addLuaEvent("FUNCTION_OPEN", self, self.onOpenState);-- 页签状态更新
    self:addLuaEvent("GUIDE_SELECT_HERO_TARGETITEM", self, self.guideSelectHeroPath);-- 选择英雄item的路径
end

function Lua_HeroWindow:showWin(param)
	self:superCall("showWin", param);

	local idx = 1;
	if type(param) == "number" then
		idx = param;
	else
		idx = param.main_id;
	end
	self:updateOpenState();
	self.btnList:setSelected(idx);
end

-- 热度页签开启状态
function Lua_HeroWindow:updateOpenState()
    self.openHeatState = DataCenter.funcOpenData:isOpened(DataCenter.heroHeatUtil.heat_func_id,false);
    self.btnList:setOpenState(Lua_HeroUtil.HRAT_TYPE, self.openHeatState);
end 

function Lua_HeroWindow:onTabBtnClick(val)
	if self.selectTabIndex == val then
		return;
	end
	local tagType = self.tabInfo[val].tagType;
    if tagType == Lua_HeroUtil.HRAT_TYPE then--英雄热度
        if not self.openHeatState then
        	DataCenter.funcOpenData:isOpened(DataCenter.heroHeatUtil.heat_func_id,true);
            return
        end
    end
    local title_img = self.tabInfo[val].title_img;
    self.title_img:setUrl(title_img);
	--self.line:setEnable(self.tabInfo[val].tagType ~= Lua_HeroUtil.FETTER_TYPE);
	-- 隐藏旧的
	self.panel = self.panelObjTab[self.selectTabIndex];
	if self.panel ~= nil then
		self.panel:setEnable(false);
	end
	self.selectTabIndex = val;
	self.panel = self.panelObjTab[val];
	if self.panelObjTab[val] == nil then
		local showPanel = self.tabInfo[val].panel;
		self.panel = showPanel.new(self.content);
		self.panel:setRectAnchor(9);
		self.panelObjTab[val] = self.panel;
	else
		self.panel:setEnable(true);
		if self.panel.updateShow ~= nil then
			self.panel:updateShow();
		end
	end
end

--更新页签开启状态
function Lua_HeroWindow:onOpenState(openDic)
	if openDic == nil or openDic[DataCenter.heroHeatUtil.heat_func_id] == nil then
		return;
	end

	if not self.openHeatState then
    	self:updateOpenState();
    end
end

-- 检测引导数据
function Lua_HeroWindow:checkWinGuide()
    self:superCall("checkWinGuide");
end

-- 引导同步
function Lua_HeroWindow:updateGuide(guideId, info)
    if info == nil then
        return;
    end

    local operateVal = info.operateVal; -- 操作行为参数
    if operateVal == nil then
        return;
    end

    if operateVal == 1 then -- 查找英雄item
    	self.guideId = guideId;
    	local heroId = info.heroId;
    	Lua_MsgUtil.callFunc("GUIDE_SELECTED_HERO", heroId);
    end
end

function Lua_HeroWindow:guideSelectHeroPath(targetPath)
	if targetPath ~= nil then
		DataCenter.guideCommonData.guideSceneId = nil; -- 场景
		DataCenter.guideCommonData.guideClickObjPath = targetPath;
		Lua_MsgUtil.callFunc("Guide_WinSync_Complete", self.guideId);
	end
end

function Lua_HeroWindow:dispose()
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end

	if self.panelObjTab ~= nil then
		for idx, panelObj in pairs(self.panelObjTab) do
            panelObj:dispose();
            self.panelObjTab[idx] = nil;
        end
		self.panelObjTab = nil;
	end
	self.panel = nil;

	if self.tabInfo ~= nil then
		self.tabInfo:dispose();
		self.tabInfo:clear();
		self.tabInfo = nil;
	end

	DataCenter.preLoadData:removeBySign("Lua_HeroLineupWindow", self, self.onSceneShow);
	-- Lua_CommonUtil.removeTimer(self, self.showEmbattleRedDot);
	self:superCall("dispose");
end